#include <oswrapper.h>
#if DECT_TESTING
VoiceCirQ_t dectTxQ;
VoiceCirQ_t dectRxQ;
VoiceQ_t    gVoiceTxDectQBuffer[MAX_TX_VOICE_Q];  /* Data going from DECT to DSP */
VoiceQ_t    gVoiceRxDectQBuffer[MAX_TX_VOICE_Q];  /* Data comming from DSP to DECT */
dsp_regEndPoint_str dectCalls;

int dectWrite(void *ref, unsigned char *buf, int len)
{
  VoiceQ_t *voice;
  if(buf != NULL)
  {
    dectRxQ.writeIdx = (dectRxQ.writeIdx + 1) % MAX_TX_VOICE_Q;
    voice = &gVoiceRxDectQBuffer[dectRxQ.writeIdx];
    memcpy(voice->aucPayload,buf, len);
    voice->ucPktLen = len;
  }
  return 0;
}

int dectRead(void *ref, unsigned char *buf, int len)
{
  if(dectTxQ.writeIdx == dectTxQ.readIdx)
  {
    memset(buf,0,len);
  }
  else
  {
    dectTxQ.readIdx = (dectTxQ.readIdx + 1) % MAX_TX_VOICE_Q;
  }
  memcpy(buf,gVoiceTxDectQBuffer[dectTxQ.readIdx].aucPayload,len);
  return 0;
}


/* Sample from DSP, should be from DECT H/W in case of DECT */
VoiceQ_t* dectHWRead(void)
{
  int index = (dectTxQ.writeIdx + 1) % MAX_TX_VOICE_Q;
  return &gVoiceTxDectQBuffer[index];
}

void dectHWReadDone(void)
{
   dectTxQ.writeIdx = (dectTxQ.writeIdx + 1) % MAX_TX_VOICE_Q;
}

VoiceQ_t* dectHWWrite(void)
{
  if(dectRxQ.readIdx == dectRxQ.writeIdx)
    return NULL;
  dectRxQ.readIdx = (dectRxQ.readIdx + 1) % MAX_TX_VOICE_Q;
  return &gVoiceRxDectQBuffer[dectRxQ.readIdx];
}

void dectSampleInit(void)
{
  memset(&dectCalls, 0, sizeof(dsp_regEndPoint_str));
  memset(&dectTxQ, 0, sizeof(dectTxQ));
  memset(&dectRxQ, 0, sizeof(dectRxQ));
  dectCalls.withoutConv.writeVoice = dectWrite;
  dectCalls.withoutConv.readVoice = dectRead;
  dectCalls.port = 1;
  dectCalls.maxFrames = 1;
  dectRegisterCallBacks(&dectCalls);
}

void dectStartTrans(void)
{
  dectCalls.withConv.writeVoice = dectWrite;
  dectCalls.withConv.readVoice = dectRead;
  dectCalls.withoutConv.writeVoice = NULL;
  dectCalls.withoutConv.readVoice = NULL;
}

void dectStopTrans(void)
{
  dectCalls.withConv.writeVoice = NULL;
  dectCalls.withConv.readVoice = NULL;
  dectCalls.withoutConv.writeVoice = dectWrite;
  dectCalls.withoutConv.readVoice = dectRead;
}


#endif

