/*******************************************************************
Ver       : 0.06
File Name : CIDTxGen.c
Purpose   : Declaration of data structures for Caller-ID Generation.
Project   : To generate CID CP-FSK Signals.
Complaint : Bellcore -30/31.
********************************************************************/
//#define CID_SIMULATION
//---> Enable this switch to log CIDTX.
//#define  LOG_CIDTX

#ifndef CID_SIMULATION 
#include <oswrapper.h>

#else
  #include <stdio.h>
  #include <stdlib.h>
  #include <string.h>
  #include "Jit_typedef.h"
  #include "CidTxCon.h"
  #include "CidTxVar.h"
  #include "CidTxProto.h"
#endif

#if CALLER_IDTx
  CidTxType_  SMM_CidTx[MAX_VOICE_CHANNELS];
  dtmfCidType_ dtmfCidGen[MAX_VOICE_CHANNELS];

extern unsigned short guiCountry;
unsigned short fisrt_ring_cidtx_play[NUM_COUNTRY]={260,140,140,140,140};
//unsigned short fisrt_ring_cidtx_play[NUM_COUNTRY]={130,90};
unsigned short fisrt_ring_cidtx_play_5ms[NUM_COUNTRY]={520,280,280,280,280};
short stringLen;
CidParams_t gMwiParams;

#if CID_SIMULATION
UCHAR   CidStrPtr[MAX_CIDTX_STRING_LEN];
#endif

UCHAR ucCallerIdIntrHandler[MAX_VOICE_CHANNELS];

/********************************************************************
		 resetCidTxPlay 
********************************************************************/

void resetCidTxPlay(uWord16 CurChanNum)
{
	SMM_CidTx[CurChanNum].PhaseSum  = 0;
	//--> Initial State.
	SMM_CidTx[CurChanNum].CidTxState    =  CID_TX_STATE0;	
	SMM_CidTx[CurChanNum].CidTxCurIndex =   0;
         SMM_CidTx[CurChanNum].TimerCntr = 0;
	SMM_CidTx[CurChanNum].CidTxType = 0;
	SMM_CidTx[CurChanNum].bCaller = 1;
    ucCallerIdIntrHandler[CurChanNum] = 0;
// Sagem ICC : Bug 3242 2006/01/09        
    SMM_CidTx[CurChanNum].bVMWI = FALSE ;
	dtmfCidGen[CurChanNum].ucDigState = 0;
}

/*******************************************************************
		 End of resetCidTxPlay
********************************************************************/

/*******************************************************************
  Function : CidTxMain()  <---> API
  Args		: a. Port Number
			  b. CidTxFlag
			  c, RemoteUserNum
			  d. RemoteUserName
			  e. CidType
			  f. bFirstRingOff

   1. CidTxFlag :                1 :-  Display only Caller ID
				 2 ---- To display only User Name
				 3 -----Display both Cid and User Name(default)
				 4 ---- Both Caller ID and User Number are private. User resticted to display his details
				 5 -----Both Caller ID and User Number are not available.
				 6 ----- Error.
   2.CidType: Indicates the type of caller ID.
				1 ------- For on_hook caller ID Display
				2 ------  For Off_hook Caller ID Display

NOTE:  CidTxFlag should be 3 for type2 caller ID
********************************************************************/

Word16 CidTxMain(uWord16 CurChanNum,UCHAR CidTxFlag,UCHAR *ucRemoteUserNum,UCHAR *ucRemoteUserName,UCHAR *DateBuffStr, UCHAR CidType,UCHAR bFirstRingOff)
{  
    //--> Local Variables
    
	uWord16 CheckSmWrd16=0,PrsTypeIndex=0,MsgLayerLen=0,i=0,j=0,CidStrLen;
	UCHAR   CidSpcsBuff[CIDTX_STRING_BUFF_LEN]="";

        if(strlen(DateBuffStr) <= 1)
        {
          /* Fill Date Field */
          *(UINT16*)&DateBuffStr[0] = 1;
          *(UINT16*)&DateBuffStr[2] = 1;
          *(UINT16*)&DateBuffStr[4] = 1;
          *(UINT16*)&DateBuffStr[6] = 1;
        }
#if 0 //ndef CID_SIMULATION 
	UCHAR  DateBuffStr[10] ="";
	UCHAR *pPtr = DateBuffStr;
	Word32  lSecs,lUsecs;
	struct tm   *psTime;
/*******************************************************************
		//------------Get Time and Date
********************************************************************/
  
  gettimeofday((int *) &lSecs,(int *) &lUsecs);
  psTime = gmtime((time_t*)&lSecs);
  sprintf(pPtr,"%2d",psTime->tm_mon+1);
  pPtr += 2;
  sprintf(pPtr,"%2d",psTime->tm_mday);
  pPtr += 2;
  sprintf(pPtr,"%2d",psTime->tm_hour);
  pPtr += 2;
  sprintf(pPtr,"%2d",psTime->tm_min);
  pPtr += 2;
#endif
//printf(" Numer String =\n %s\n",ucRemoteUserNum);
//printf(" Flag =\n %d\n",CidTxFlag);

/*******************************************************************
		     FRAMING OF  MESSAGE  LAYER
********************************************************************/
	//---> Message Layer decision.
    CidSpcsBuff[0] =  CIDTX_MSG_TYPE;
	//---< SMDF >--->>>

	if( CidSpcsBuff[0] ==  SPCS_MSG_TYPE_SDMF)
	{		
		//--> Cater Type field in CheckSum
		CheckSmWrd16 = SPCS_MSG_TYPE_SDMF;

		//--> Month Field
		//--> Day Field
		//--> Hour Field
		//--> Minute Field			
		for( i =2,j=0; i < ( DATE_FIELD_LENGTH + 2); i++,j++)
		{
			 CidSpcsBuff[i] = DateBuffStr[j];
			 if(CidSpcsBuff[i] == ' ')
			   CidSpcsBuff[i] = '0';
			 CheckSmWrd16 = CheckSmWrd16 + (uWord16)CidSpcsBuff[i];
		}
		j = 0;

		//--> Copy the Number filed

		if(CidTxFlag == 4) //if Number is private
			CidSpcsBuff[i] = 'P';
		else if(CidTxFlag == 5) //If Number is out of Area
			CidSpcsBuff[i] = 'O';
		else
		{
			//		while(!(ucRemoteUserNum[j] == '\0'))
			CidStrLen = strlen(ucRemoteUserNum);
			if(CidStrLen >= CIDTX_STRING_LEN) //limitation of the characters to be displayed
			CidStrLen = CIDTX_STRING_LEN;
			for(j=0;j<CidStrLen;j++)
			{
			   CidSpcsBuff[i] = ucRemoteUserNum[j];
			   CheckSmWrd16   = CheckSmWrd16 + (uWord16)  CidSpcsBuff[i];
			   //j++;
			   i++;
			}
		}

        //2-- i included the Msg Type , MsgLen
		//--> Message Length field.
		CidSpcsBuff[1] = (UCHAR)(i-2); 

		//--> Include Message Length field in Check Sum
		CheckSmWrd16 +=  (i-2);

		CheckSmWrd16 = CheckSmWrd16 % 256;

		//--> Neglect Upper Byte 
		CheckSmWrd16 = CheckSmWrd16 & 0x00FF;

		//---> Do Check Sum One's Complement
		CheckSmWrd16 = ~CheckSmWrd16;

		//---> Do Check Sum Second's Complement
		CheckSmWrd16 +=1;

		//--> Neglect Upper Byte 
		CheckSmWrd16 = CheckSmWrd16 & 0x00FF;

		//CheckSmWrd16 = (CheckSmWrd16%256)^0xff);

		CidSpcsBuff[i++] = (UCHAR)CheckSmWrd16;

		CidSpcsBuff[i] = '\0';


	}else if ( CidSpcsBuff[0] ==  SPCS_MSG_TYPE_MDMF)
	{
	      //---< MDMF >--->>>>
         /*
		   1.Message Layer
			1.1.Messgae Type
			1.2.Messgae Length = Par1.Len + Par2.Len + Par3.Len.+ 6
		   2.Presentation Layer
			2.1.1.Parameter Type Date
			2.1.2.Parameter Date Length
			2.1.3.Parameter Date
			2.2.1.Parameter Type Number
			2.2.2.Parameter number Length
			2.2.3.Parameter Number
			2.3.1.Parameter Type Name
			2.3.2.Parameter Name Length
			2.3.3.Parameter Name
		   3.Check Sum.
         */
		
//--> Cater Type field in CheckSum
		CheckSmWrd16 = SPCS_MSG_TYPE_MDMF;		
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);

//---> 2.1.1  Parameter Type Date
		CidSpcsBuff[2] = (UCHAR) MDMF_DATE_TIME_TYPE;
		CheckSmWrd16 += MDMF_DATE_TIME_TYPE;
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);

//---> 2.1.2  Parameter Date Length
		CidSpcsBuff[3] = (UCHAR) DATE_FIELD_LENGTH;
		CheckSmWrd16 += DATE_FIELD_LENGTH;
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);
		
//---> 1.2 update Message Layer Length w.r.t Date field Length
		MsgLayerLen  = DATE_FIELD_LENGTH;

		//---> 2.1.3  Parameter Date 
		//--> Month Field
		//--> Day Field
		//--> Hour Field
		//--> Minute Field			

		for( i =4,j=0; i < ( DATE_FIELD_LENGTH + 4); i++,j++)
		{
			 CidSpcsBuff[i] = DateBuffStr[j];
			 if(CidSpcsBuff[i] == ' ')
			   CidSpcsBuff[i] = '0';
			 CheckSmWrd16 = CheckSmWrd16 + (uWord16)  CidSpcsBuff[i];
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);
		}
		
		if(CidTxFlag == 1)  
		{
			
/*******************************************************************
		    //----------Send only Number 
********************************************************************/
			
			PrsTypeIndex = i;
			i +=2;
			j = 0;
     			//---> 2.2.3  Parameter  Number Copy
		//	while(!(ucRemoteUserNum[j]=='\0'))
			CidStrLen = strlen(ucRemoteUserNum);
			if(CidStrLen >= CIDTX_STRING_LEN) //limitation of the characters to be displayed
			CidStrLen = CIDTX_STRING_LEN;
			for(j=0;j<CidStrLen;j++)
			{		   	
			   CidSpcsBuff[i] = ucRemoteUserNum[j];
			   CheckSmWrd16   = CheckSmWrd16 + (uWord16)  CidSpcsBuff[i];
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);
			   i++;
			}

    		CidSpcsBuff[PrsTypeIndex] = (UCHAR) MDMF_T_CALL_NUMBER_TYPE;
			CheckSmWrd16 += MDMF_T_CALL_NUMBER_TYPE;
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);
			//---> 2.2.2  Parameter Number Length
			CidSpcsBuff[PrsTypeIndex+1] = i - PrsTypeIndex - 2;
			CheckSmWrd16 += (i - PrsTypeIndex - 2);
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);

			//1.2 update Message Layer Length w.r.t Parameter Number field Length
			MsgLayerLen  += (i - PrsTypeIndex - 2);

			MsgLayerLen  += 4;

		}
		else if(CidTxFlag == 2)  
		{
/*******************************************************************/
			//----------Display only Name
/********************************************************************/

			PrsTypeIndex = i;
			i +=2;
			j=0;
			//---> 2.3.3  Parameter  Name Copy
			//		while(!(( CidStrPtr[j] == ',')||(CidStrPtr[j] =='\0')))
			CidStrLen = strlen(ucRemoteUserName);
			if(CidStrLen >= CIDTX_STRING_LEN) //limitation of the characters to be displayed
			CidStrLen = CIDTX_STRING_LEN;
			for(j=0;j<CidStrLen;j++)
			{
				CidSpcsBuff[i] = ucRemoteUserName[j];
				CheckSmWrd16   = CheckSmWrd16 + (uWord16) CidSpcsBuff[i];
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);
				i++;
			}

			//---> 2.3.1  Parameter Type  Name
			CidSpcsBuff[PrsTypeIndex] = (UCHAR) MDMF_T_CALL_NAME_TYPE;
			CheckSmWrd16 += MDMF_T_CALL_NAME_TYPE;
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);

			//---> 2.3.2  Parameter Name Length
			CidSpcsBuff[PrsTypeIndex+1] = i - PrsTypeIndex - 2;
			CheckSmWrd16 += (i - PrsTypeIndex - 2);
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);
			// 1.2 update Message Layer Length w.r.t Parameter Name field Length.
			MsgLayerLen  += (i - PrsTypeIndex - 2);
			/*  
			update Message Layer Length w.r.t Parameter 
			Date/Num/Name field Property fields
			*/
			MsgLayerLen  += 4;

		}
		else if(CidTxFlag == 3)  
		{
/*******************************************************************/
		//----------Display Number and Name
/*******************************************************************/
			PrsTypeIndex = i;
			i +=2;
			j = 0;
				//---> 2.2.3  Parameter  Number Copy
			//	while(!(ucRemoteUserNum[j]=='\0'))
			CidStrLen = strlen(ucRemoteUserNum);

			if(CidStrLen >= CIDTX_STRING_LEN) //limitation of the characters to be displayed
				CidStrLen = CIDTX_STRING_LEN;

			for(j=0;j<CidStrLen;j++)	   	
			{
			   CidSpcsBuff[i] = ucRemoteUserNum[j];
			   CheckSmWrd16   = CheckSmWrd16 + (uWord16)  CidSpcsBuff[i];
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);
			   i++;
			}

			//---> 2.2.1  Parameter Type  Number 		
			 CidSpcsBuff[PrsTypeIndex] = (UCHAR) MDMF_T_CALL_NUMBER_TYPE;
			 CheckSmWrd16 += MDMF_T_CALL_NUMBER_TYPE;
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);


			//---> 2.2.2  Parameter Number Length
			CidSpcsBuff[PrsTypeIndex+1] = i - PrsTypeIndex - 2;
			CheckSmWrd16 += (i - PrsTypeIndex - 2);
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);

		//1.2 update Message Layer Length w.r.t Parameter Number field Length
			MsgLayerLen  += (i - PrsTypeIndex - 2);

			PrsTypeIndex = i;
			i +=2;
			j=0;
			//---> 2.3.3  Parameter  Name Copy
		//		while(!(( CidStrPtr[j] == ',')||(CidStrPtr[j] =='\0')))
			CidStrLen = strlen(ucRemoteUserName);
			if(CidStrLen >= CIDTX_STRING_LEN) //limitation of the characters to be displayed
				CidStrLen = CIDTX_STRING_LEN;

			for(j=0;j<CidStrLen;j++)
			{
			   CidSpcsBuff[i] = ucRemoteUserName[j];
			   CheckSmWrd16   = CheckSmWrd16 + (uWord16) CidSpcsBuff[i];
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);
			   i++;
			}

			//---> 2.3.1  Parameter Type  Name
  		    CidSpcsBuff[PrsTypeIndex] = (UCHAR) MDMF_T_CALL_NAME_TYPE;
			CheckSmWrd16 += MDMF_T_CALL_NAME_TYPE;
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);
			

			//---> 2.3.2  Parameter Name Length
			CidSpcsBuff[PrsTypeIndex+1] = i - PrsTypeIndex - 2;
			CheckSmWrd16 += (i - PrsTypeIndex - 2);
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);
		// 1.2 update Message Layer Length w.r.t Parameter Name field Length.
			MsgLayerLen  += (i - PrsTypeIndex - 2);
			/*  
			update Message Layer Length w.r.t Parameter 
			Date/Num/Name field Property fields
			*/
			MsgLayerLen  += 6;

		}
		else if((CidTxFlag == 4)|| (CidTxFlag == 5)) 
		{
/*******************************************************************/
			//----------Name and Number are private
/*******************************************************************/
			PrsTypeIndex = i;
			i +=2;
			j = 0;
				//---> 2.2.3  Parameter  Number Copy
			if(CidTxFlag == 4)
				CidSpcsBuff[i] = 'P';
			else
				CidSpcsBuff[i] = 'O';

			//---> 2.2.1  Parameter Type  Number 		
			CidSpcsBuff[PrsTypeIndex] = (UCHAR) MDMF_R_CALL_NUMBER_TYPE;
			CheckSmWrd16 += CidSpcsBuff[i];
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);
			i++;
			CheckSmWrd16 += MDMF_R_CALL_NUMBER_TYPE;
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);

			//---> 2.2.2  Parameter Number Length
			CidSpcsBuff[PrsTypeIndex+1] = i - PrsTypeIndex - 2;
			CheckSmWrd16 += (i - PrsTypeIndex - 2);
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);

		//1.2 update Message Layer Length w.r.t Parameter Number field Length
			MsgLayerLen  += (i - PrsTypeIndex - 2);

#if 1 
			PrsTypeIndex = i;
			i +=2;
			j=0;
			//---> 2.3.3  Parameter  Name Copy
			if(CidTxFlag == 4)
				CidSpcsBuff[i] = 'P';
			else
				CidSpcsBuff[i] = 'O';


			//---> 2.3.1  Parameter Type  Name
  		    CidSpcsBuff[PrsTypeIndex] = (UCHAR) MDMF_R_CALL_NAME_TYPE;
			CheckSmWrd16 += CidSpcsBuff[i];
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);
			i++;

		    CheckSmWrd16 += MDMF_R_CALL_NAME_TYPE;
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);

			//---> 2.3.2  Parameter Name Length
			CidSpcsBuff[PrsTypeIndex+1] = i - PrsTypeIndex - 2;
			CheckSmWrd16 += (i - PrsTypeIndex - 2);
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);
		// 1.2 update Message Layer Length w.r.t Parameter Name field Length.

			MsgLayerLen  += (i - PrsTypeIndex - 2);

			MsgLayerLen  += 6;

#else //for testing
			MsgLayerLen  += 4;
#endif

		}
		else
		{
		  PRINT( "Check the Cid String ,CidTxFlag is set wrongly");
     		  return CIDTX_FAILURE;
		}
		
		//---> 1.2 update Message Layer Length in Main Buffer
        CidSpcsBuff[1] = (UCHAR)MsgLayerLen;
        
		//--> Include Message Length field in Check Sum
        CheckSmWrd16 +=  MsgLayerLen;
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);

		CheckSmWrd16 = CheckSmWrd16 % 256;
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);
		
		//---> Do Check Sum One's Complement
        CheckSmWrd16 = ~CheckSmWrd16;
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);

		CheckSmWrd16 = CheckSmWrd16 & 0x00FF;
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);

		//---> Do Check Sum Second's Complement
       	CheckSmWrd16 +=1;
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);

		//--> Neglect Upper Byte 
		CheckSmWrd16 = CheckSmWrd16 & 0x00FF;
		//printk("###%d#CheckSmWrd16 =%d\n",__LINE__,CheckSmWrd16);

		CidSpcsBuff[i++] = (UCHAR)CheckSmWrd16;
		//printk("###%d#CidSpcsBuff[i-1] =%d\n",__LINE__,CidSpcsBuff[i-1]);
		
		CidSpcsBuff[i] = '\0';
		stringLen = i;


	}else if ( CidSpcsBuff[0] ==  SPCS_MSG_TYPE_GDMF)
	{
#if LOG_CIDTX
	      //---< GDMF >---
        PRINT( " No Supprt for SPCS - GDMF "); 		
#endif
		//---> Give Some Error Condition.
     		  return CIDTX_FAILURE;
	}

// resetCidTxPlay(CurChanNum);
//PRINT(" CidTxMain String =\n %s\n",CidSpcsBuff);
   CidTxDataFrame(CidSpcsBuff,CurChanNum,CidType);

  if(bFirstRingOff == 0)
  {
    if(CidType == 2)  // offhook
    {
      dspipcSetCallWtState(CurChanNum);
     SMM_CidTx[CurChanNum].CidTxState = CID_TX_STATE1; //for type set after getting digit "D" from Pho ne
    }
    else
      SMM_CidTx[CurChanNum].CidTxState = CID_TX_STATE2;  //for type1
  }
  else 
  {
    if(CidType == 2)  // offhook
      dspipcSetCallWtState(CurChanNum);
   //AKSHAY SMM_CidTx[CurChanNum].CidTxState = CID_TX_STATE1; //for type set after getting digit "D" from Pho
  }
  SMM_CidTx[CurChanNum].CidTxType = CidType;
  return 1;	
}
/******************************************************************
		     END OF FRAMING OF  MESSGAE LAYER 
*******************************************************************/


/*******************************************************************
  Function : CidTxDataFrame()  <---> API
  Args		: a. StringPtr
			  b.Port Number
String should be framed either MDMF or SDMF format   
********************************************************************/

void CidTxDataFrame(UCHAR *CidStrPtr,uWord16 CurChanNum,UCHAR CidType)
{
	uWord16 CidTxCntr = 0,StrLen,BitLen =0,CurWord=0,CurBit,RghtSft;
	uWord16 TotBits,TotWords,BitsRem,*CurFramePtr,Index,i=0;
	UCHAR   CurChar;

//-------> Init. of CidStructure
   resetCidTxPlay(CurChanNum);

/******************************************************************
		     FRAMING OF  DATA  LAYER 
*******************************************************************/
   //StrLen = strlen(CidStrPtr);
   StrLen = stringLen;
   if(CidType == CIDTX_TYPE1)  //for on_hook caller ID display
		TotBits  = StrLen * 10 + 300 + 180;
   else
		TotBits  = StrLen * 10 + 80;

	TotWords = TotBits / 12;
	BitsRem   = TotBits % 12;

	if(BitsRem > 0)
         TotWords +=1;   
//--------> at present total word are defined 100 by considering max. length of  name and Number 25
	if(TotWords >= CIDTX_STRING_BUFF_LEN)
	{
		return;
	}
  
	CurFramePtr = (uWord16 *) SMM_CidTx[CurChanNum].CidTxFramePtr;

	 if(CidType == CIDTX_TYPE1)  //for on_hook caller ID display
	 {
		//--> Stuff First Channel Seizure = 300 bits --> 300/12 = 25 Words.
		//-->  b 1100 1010 1010 1010 = 0x CAAA
		for( Index  = 0; Index < LEN_CHAN_SEIZURE_25x12BITS ; Index++ )
			CurFramePtr[Index] =  0xC555;


		//--> Stuff Mark Signal After  
		//--> Channel Seizure = 180 bits --> 180/12 = 15 Words.
		//-->  b 1100 1111 1111 1111 = 0x CFFF
		for( Index  = LEN_CHAN_SEIZURE_25x12BITS; 
		Index < (LEN_MARK_SIG_15x12BITS +LEN_CHAN_SEIZURE_25x12BITS);
		Index++)
			CurFramePtr[Index] =  0xCFFF;
	 }
	 else //for off_hook caller ID display
	 {
		//--> Channel Seizure = 80 bits --> 80/12 = 15 Words.
		 //for( Index  = 0;Index <(LEN_MARK_SIG_15x12BITS);	Index++)
		 for( Index  = 0;Index <(CIDCW_MARK_SIG_7x12BITS);Index++)
			CurFramePtr[Index] =  0xCFFF;
	 }

	//--> 1.Parsing of the String.
    //while( !((CidStrPtr[CidTxCntr] == '\0' )||( CidTxCntr == StrLen)||( Index > TotWords )))
    while( !(( CidTxCntr == StrLen)||( Index > TotWords )))
	{
        //---> Skip the comma Or Blank Space.
//BC 24458
//FCU: BUG IKANOS!!! ne pas skipper le caractere comma car la valeur Ox2C (comma en hexa) peut arriver dans un message v23 dans : la longueur totale du message, en tant que caractere d'un nom, dans le checksum
//introduit une mauvaise creation de message V23 donc pb d'affichage FXS
#if 0
		if(CidStrPtr[CidTxCntr] == ',' )
		{ 

			CidTxCntr++;
			continue;

		}else
#endif
		{

          	CurChar = CidStrPtr[CidTxCntr];
		//------------------------>
         	//--START BIT
		//------------------------>			 
//--> If Bit Length is Full Then Update it in CidTx Word16 Buffer.
			if( BitLen == 12 )
			{
			   CurFramePtr[Index] = 0xC000 | CurWord;
			   BitLen = 0;
			   Index++;
			   CurWord = 0;

			}//--> End of BitLen == 12

//---> Give a space for LSB for one Bit.
			CurWord =    CurWord  << 1;
			
			//---> Append it in LSB of CurWord;
	        CurWord =    CurWord  & 0xFFFE;
           
			//---> Increment the Bit Length
			BitLen++;
			//------------------------>
			//-- ASCII CHARACTER  Fill from LSB to MSB
			//------------------------>
			for( i = 0 ; i< 8;i++ )
			{
//--> If Bit Length is Full Then Update it in CidTx Word16 Buffer.
               if( BitLen == 12 )
			   {
				   CurFramePtr[Index] = 0xC000 | CurWord;
				   BitLen = 0;
				   Index++;
				   CurWord = 0;

			   }//--> End of BitLen == 12

       		   CurBit  = (uWord16) CurChar & 0x0001;

			   CurChar = CurChar >> 1;

			   //---> Give a space for LSB.
			   CurWord =    CurWord  << 1;

			   //---> Append it in LSB of CurWord;
               CurWord =    CurWord  |  CurBit; 

			   //---> Increment the Bit Length
			   BitLen++;

			}//--> End of Byte.

   			//------------------------>
			//-- STOP BIT
			//------------------------>

//--> If Bit Length is Full Then Update it in CidTx Word16 Buffer.
           	if( BitLen == 12 )
			{
			   CurFramePtr[Index] = 0xC000 | CurWord;
			   BitLen = 0;
			   Index++;
			   CurWord = 0;

			}//--> End of BitLen == 12

            		//---> Give a space for LSB for one Bit.
			CurWord =    CurWord  << 1;
			
			//---> Append it in LSB of CurWord;
            CurWord =    CurWord  | 0x0001;
            
			//---> Increment the Bit Length
			BitLen++;

		}//---> End of else of other than Blank (or) Comma.

		CidTxCntr++;

	}//--> End of While Loop

/*
Un updates Last  Bits need to be appended in the Last Word of Array
*/
	if( BitLen > 0 )
	{	   
		RghtSft  = 12 - BitLen;
		CurWord  = CurWord << RghtSft;

		BitLen   = BitLen << 12;
		BitLen   = BitLen & 0xF000;

		CurFramePtr[Index] = BitLen | CurWord;
		Index++;
	}

	SMM_CidTx[CurChanNum].CidTxFrameLen = Index;

//	SMM_CidTx[CurChanNum].CidTxState = CID_TX_STATE1;

#if LOG_CIDTX
PRINT("CALLER ID STATE:-------%d\n",SMM_CidTx[CurChanNum].CidTxState);
#endif

/********************************************************************
		   END OF FRAMING OF  DATA  LAYER 
********************************************************************/

}//--> End of CidTxDataFrame API
/********************************************************************
 		   End of CidTxDataFrame  <---> API
********************************************************************/

/********************************************************************
                Cid Play out Generation for 10 ms,
				PHYSICAL LAYER SIGNAL GENERATION
********************************************************************/
void CidTxPlay(uWord16 CurChanNum)
{        

	uWord16 CurWord, BitLen,CurBit,i,ii,CidTxDec = 3,Index,Pha_adv;
	Word16 Sample;

	for(i = 0;i<CID_TX_PAY_LOAD_LEN;i++)
		SMM_CidTx[CurChanNum].CidTxPayLoad[i] = 0;

	CurWord =  SMM_CidTx[CurChanNum].
				 CidTxFramePtr[SMM_CidTx[CurChanNum].CidTxCurIndex];

	BitLen  = CurWord & 0xF000;
	CurWord = CurWord << 4;

	BitLen  = BitLen >> 12;
	CidTxDec = 3;
	Index    = 0;

 
	for ( i = 0; i< BitLen ; i++ )
	{
		CurBit =  ( CurWord & 0x8000);
		CurWord = CurWord << 1;
		CurBit =  CurBit >> 15;

		if( CurBit ==  0)
			Pha_adv = PHA_ADV1;
		else
			Pha_adv = PHA_ADV2;
			 
				
		for( ii = 0 ; ii < NO_OF_SAMPLES_PER_BIT ; ii++ )
		{
#ifdef DECIMATION
			if( CidTxDec  == DOWN_SAMPLING_MOD_CONST )
			{
#endif
				Sample = GetSin(SMM_CidTx[CurChanNum].PhaseSum);

				SMM_CidTx[CurChanNum].CidTxPayLoad[Index] = Sample;
				
				Index++;

#ifdef DECIMATION
			  CidTxDec = 0;
			}//-->End of Decimation.
#endif
			//--> Phase Increment.
			SMM_CidTx[CurChanNum].PhaseSum = 
						 SMM_CidTx[CurChanNum].PhaseSum + Pha_adv;
			CidTxDec++;
		}//--> End of for ( ii = 0 ; ii < 20 , ii++)

	}//--> End of BitLen for Loop.
//--> Decrement Word.
	SMM_CidTx[CurChanNum].CidTxFrameLen--;
	SMM_CidTx[CurChanNum].CidTxCurIndex++;
	
	
}//--> End of CidTxPlay.

/********************************************************************
  END OF PHYSICAL LAYER SIGNAL GENERATION
********************************************************************/

/*******************************************************************
  This Function is used to Generate the Sample with given Phase.
  Taylor Series Approximation of Sin(x) = f(x)
  for f(x) function look for 5- order Taylors series Polynomial 
     Approximation.
  x- should be in Radians,  Domain of x is --->  0 < x < Pi/2    
********************************************************************/

Word16 GetSin(Word16 x)
{
	Word16	x1;
	uWord16 	y,z;

	y = ((x & 0x4000) ? -x : x) & 0x7fff;
	z = y;

	x1 = Round(0x08B70000L+Mul(0x1CCE,y));
	x1 = Round(0xAACC0000L+Mul(x1,y));
	x1 = Round(0x00530000L+Mul(x1,y));
	x1 = Round(0x32400000L+Mul(x1,y));
	x1 = Round(0L+Mul(x1,y));
	//x1 = (x1 << 3);
	x1 = (x1 >> 1);	//to get 2048 as output
	if (x1 < 0) y = 0x7fff;
	else y = x1;
	if (x<0) y = -y;
	return (y);
}

/*******************************************************************
  Function : mesgWaitingIndMain()  <---> API
  Args		: a. Port Number
			  b. Message Waiting Indicator Structure

   1. CidTxFlag :                1 :-  Display only Caller ID
				 2 ---- To display only User Name
				 3 -----Display both Cid and User Name(default)
				 4 ---- Both Caller ID and User Number are private. User resticted to display his details
				 5 -----Both Caller ID and User Number are not available.
				 6 ----- Error.
   2.CidType: Indicates the type of caller ID.
				1 ------- For on_hook caller ID Display
				2 ------  For Off_hook Caller ID Display

NOTE:  CidTxFlag should be 3 for type2 caller ID
********************************************************************/

Word16 mesgWaitingIndMain(uWord16 CurChanNum,CidParams_t *gMwiParams)
{
	uWord16 CheckSmWrd16=0,MsgLayerLen=0,i=0,k;
	UCHAR   CidSpcsBuff[CIDTX_STRING_BUFF_LEN]="";

/*******************************************************************
		     FRAMING OF  MESSAGE  LAYER
********************************************************************/
	//---> Message Layer decision.
        CidSpcsBuff[0] =  SPCS_MSG_TYPE_WAITING_IND;

	//--> Cater Type field in CheckSum
	CheckSmWrd16 = SPCS_MSG_TYPE_WAITING_IND;

#if 0

//=====================>Date and Time

//-> 2.1.1  Parameter Type Date
	CidSpcsBuff[2] = (UCHAR) MDMF_DATE_TIME_TYPE;
	CheckSmWrd16 += MDMF_DATE_TIME_TYPE;

//---> 2.1.2  Parameter Date Length
	CidSpcsBuff[3] = (UCHAR) DATE_FIELD_LENGTH;
	CheckSmWrd16 += DATE_FIELD_LENGTH;
	
//---> 1.2 update Message Layer Length w.r.t Date field Length
	MsgLayerLen  = DATE_FIELD_LENGTH+2;

	for( i =4,j=0; i < ( DATE_FIELD_LENGTH + 4); i++,j++)
	{
			CidSpcsBuff[i] = gMwiParams->ucDate[j];
			if(CidSpcsBuff[i] == ' ')
			CidSpcsBuff[i] = '0';
			CheckSmWrd16 = CheckSmWrd16 + (uWord16)gMwiParams->ucDate[i];
	}
	
//===========>Parameter Number

	PrsTypeIndex = i;
	i +=2;
	j = 0;
	//---> 2.2.3  Parameter  Number Copy
	
	CidStrLen = strlen(gMwiParams->ucNumber);

	if(CidStrLen >= CIDTX_STRING_LEN) //limitation of the characters to be displayed
		CidStrLen = CIDTX_STRING_LEN;

	for(j=0;j<CidStrLen;j++)	   	
	{
		CidSpcsBuff[i] = gMwiParams->ucNumber[j];
		CheckSmWrd16   = CheckSmWrd16 + (uWord16)  gMwiParams->ucNumber[i];
		i++;
	}

//---> 2.2.1  Parameter Type  Number 		
	CidSpcsBuff[PrsTypeIndex] = (UCHAR) MDMF_T_CALL_NUMBER_TYPE;
	CheckSmWrd16 += MDMF_T_CALL_NUMBER_TYPE;

//---> 2.2.2  Parameter Number Length
	CidSpcsBuff[PrsTypeIndex+1] = i - PrsTypeIndex - 2;
	CheckSmWrd16 += (i - PrsTypeIndex - 2);

//1.2 update Message Layer Length w.r.t Parameter Number field Length
	MsgLayerLen  += (i - PrsTypeIndex);

//===========>Parameter Name
	PrsTypeIndex = i;
	i +=2;
	j=0;

	CidStrLen = strlen(gMwiParams->ucName);
	if(CidStrLen >= CIDTX_STRING_LEN) //limitation of the characters to be displayed
		CidStrLen = CIDTX_STRING_LEN;

	for(j=0;j<CidStrLen;j++)
	{
		CidSpcsBuff[i] = gMwiParams->ucName[j];
		CheckSmWrd16   = CheckSmWrd16 + (uWord16) gMwiParams->ucName[i];
		i++;
	}

	//---> 2.3.1  Parameter Type  Name
  	CidSpcsBuff[PrsTypeIndex] = (UCHAR) MDMF_T_CALL_NAME_TYPE;
	CheckSmWrd16 += MDMF_T_CALL_NAME_TYPE;

 	//---> 2.3.2  Parameter Name Length
	CidSpcsBuff[PrsTypeIndex+1] = i - PrsTypeIndex - 2;
	CheckSmWrd16 += (i - PrsTypeIndex - 2);

 	MsgLayerLen  += (i - PrsTypeIndex);

#endif
        i = 2;
	
//===========>Visual Indicator

//---> 2.3.1  Parameter Type  Name
  	CidSpcsBuff[i++] = (UCHAR) MDMF_VISUAL_IND_NAME_TYPE;
	CheckSmWrd16 += MDMF_VISUAL_IND_NAME_TYPE;

	CidSpcsBuff[i++] = 1;
	CheckSmWrd16 += 1;

	CidSpcsBuff[i++] = gMwiParams->ucVisualInd;
	CheckSmWrd16   = CheckSmWrd16 + (uWord16) gMwiParams->ucVisualInd;
	
	MsgLayerLen  += 3;

#if 0

//===========>No. Of Messgaes parameter Type

  	CidSpcsBuff[i++] = (UCHAR) MDMF_NO_OF_MESSAGES_TYPE;
	CheckSmWrd16 += MDMF_NO_OF_MESSAGES_TYPE;

	CidSpcsBuff[i++] = 1;
	CheckSmWrd16 += 1;

	CidSpcsBuff[i++] = gMwiParams->ucNoOfMsgs;
	CheckSmWrd16   = CheckSmWrd16 + (uWord16) gMwiParams->ucNoOfMsgs;

	MsgLayerLen  += 3;


//===========>Last Message CLI

	PrsTypeIndex = i;
	i +=2;
	j = 0;
	//---> 2.2.3  Parameter  Number Copy
	
	CidStrLen = strlen(gMwiParams->ucLastMsgCli);

	if(CidStrLen >= 20) //limitation of the characters to be displayed
		CidStrLen = 20;

	for(j=0;j<CidStrLen;j++)	   	
	{
		CidSpcsBuff[i] = gMwiParams->ucLastMsgCli[j];
		CheckSmWrd16   = CheckSmWrd16 + (uWord16)  gMwiParams->ucLastMsgCli[i];
		i++;
	}

//---> 2.2.1  Parameter Type  Number 		
	CidSpcsBuff[PrsTypeIndex] = (UCHAR) MDMF_LASTMSGCLI_TYPE;
	CheckSmWrd16 += MDMF_LASTMSGCLI_TYPE;
	//---> 2.2.2  Parameter Number Length
	CidSpcsBuff[PrsTypeIndex+1] = i - PrsTypeIndex - 2;
	CheckSmWrd16 += (i - PrsTypeIndex - 2);

//1.2 update Message Layer Length w.r.t Parameter Number field Length
	MsgLayerLen  += (i - PrsTypeIndex);

//===========>Message Indentification

	PrsTypeIndex = i;
	i +=2;
	j = 0;
	
	CidStrLen = strlen(gMwiParams->ucMsgIdenti);

	if(CidStrLen >= 3) //limitation of the characters to be displayed
		CidStrLen = 3;

	for(j=0;j<CidStrLen;j++)	   	
	{
		CidSpcsBuff[i] = gMwiParams->ucMsgIdenti[j];
		CheckSmWrd16   = CheckSmWrd16 + (uWord16)  gMwiParams->ucMsgIdenti[i];
		i++;
	}

//---> 2.2.1  Parameter Type  Number 		
	CidSpcsBuff[PrsTypeIndex] = (UCHAR) MDMF_MSG_IDENTIFICATION_TYPE;
	CheckSmWrd16 += MDMF_MSG_IDENTIFICATION_TYPE;
	//---> 2.2.2  Parameter Number Length
	CidSpcsBuff[PrsTypeIndex+1] = i - PrsTypeIndex - 2;
	CheckSmWrd16 += (i - PrsTypeIndex - 2);

//1.2 update Message Layer Length w.r.t Parameter Number field Length
	MsgLayerLen  += (i - PrsTypeIndex);
#endif



		//---> 1.2 update Message Layer Length in Main Buffer
        CidSpcsBuff[1] = (UCHAR)MsgLayerLen;
        
		//--> Include Message Length field in Check Sum
        CheckSmWrd16 +=  MsgLayerLen;

		CheckSmWrd16 = CheckSmWrd16 % 256;
		
		//---> Do Check Sum One's Complement
        CheckSmWrd16 = ~CheckSmWrd16;

		CheckSmWrd16 = CheckSmWrd16 & 0x00FF;

		//---> Do Check Sum Second's Complement
       	CheckSmWrd16 +=1;

		//--> Neglect Upper Byte 
		CheckSmWrd16 = CheckSmWrd16 & 0x00FF;

		CidSpcsBuff[i++] = (UCHAR)CheckSmWrd16;
		
		CidSpcsBuff[i] = '\0';
		stringLen = i;
    for(k = 0;k<stringLen;k++)
      PRINT(" %x ",CidSpcsBuff[k]);	

   CidTxDataFrame(CidSpcsBuff,CurChanNum,1);
   //SMM_CidTx[CurChanNum].CidTxState = CID_TX_STATE1;
   // Sagem ICC : Bug 3242 2006/01/09
   SMM_CidTx[CurChanNum].bVMWI = TRUE ;
   SMM_CidTx[CurChanNum].CidTxType = 1;
   
   return 1;
}
/********************************************************************
************--> End of GetSin() Function********
********************************************************************/


#ifdef CIDTX_STRING_INTERN
/*******************************************************************
		Input information generation Simulation code
		    for CidTxMain Calling EnvironMent  .
*******************************************************************/
void  GetCidStr(UCHAR *CidStrPtr )
{

#ifdef MDMF_1
//    CidStrPtr = ( UCHAR * ) malloc(sizeof(UCHAR) * 31);
	//-----> Month MM <------> December
	CidStrPtr[0]			 =	   '1';
	CidStrPtr[1]    		 =	   '2';

	//-----> Day   DD <------> 25'th
	CidStrPtr[2]			 =	   '2';
	CidStrPtr[3]			 =	   '5';
	
	//------> Hour HH <------> 3 PM
	CidStrPtr[4]			 =	 '1';
	CidStrPtr[5]			 =	 '5';

	//------> Minutes  mm <-----> 30 minutes
	CidStrPtr[6]		     =   '3';
	CidStrPtr[7]		     =   '0';
		
	//------> Field Seperator7
	CidStrPtr[8]		     =   ',';

    //-----> Calling Phone Number
	CidStrPtr[9]			 =	   '3';
	CidStrPtr[10]    		 =	   '7';
	CidStrPtr[11]			 =	   '5';
	CidStrPtr[12]			 =	   '0';
	CidStrPtr[13]			 =	   '2';
	CidStrPtr[14]    		 =	   '5';
	CidStrPtr[15]			 =	   '0';

	//------> Field Seperator
	CidStrPtr[16]		     =     ',';
        
	
	//-----> Calling Phone Name	
	CidStrPtr[17]			 =	   'A';
	CidStrPtr[18]			 =	   'N';
	CidStrPtr[19]			 =	   'A';
	CidStrPtr[20]			 =	   'L';
	CidStrPtr[21]			 =	   'O';
	CidStrPtr[22]			 =	   'G';

	CidStrPtr[23]			 =	   'D';
	CidStrPtr[24]			 =	   'E';
	CidStrPtr[25]			 =	   'V';
	CidStrPtr[26]			 =	   'I';
	CidStrPtr[27]			 =	   'C';
	CidStrPtr[28]			 =	   'E';
	CidStrPtr[29]			 =	   'S';
    
	//----> End of String field.
	CidStrPtr[30]			 =	  '\0';

#endif //--> End of  MDMF

#ifdef MDMF_2

	//    CidStrPtr = ( UCHAR * ) malloc(sizeof(UCHAR) * 31);
	//----> CA will send  ASCII Characters.

	//-----> Month MM <------> Nov
	CidStrPtr[0]			 =	   '1';
	CidStrPtr[1]    		 =	   '1';

	//-----> Day   DD <------> 28'th
	CidStrPtr[2]			 =	   '2';
	CidStrPtr[3]			 =	   '8';
	
	//------> Hour HH <------> 3 PM
	CidStrPtr[4]			 =	 '1';
	CidStrPtr[5]			 =	 '5';

	//------> Minutes  mm <-----> 43 minutes
	CidStrPtr[6]		     =   '4';
	CidStrPtr[7]		     =   '3';
		
	//------> Field Seperator7
	CidStrPtr[8]		     =   ',';

    //-----> Calling Phone Number
	CidStrPtr[9]			 =	   'P';
	//------> Field Seperator
	CidStrPtr[10]		     =     ',';
        
	
	//-----> Calling Phone Name	
	CidStrPtr[11]			 =	   'J';
	CidStrPtr[12]			 =	   'o';
	CidStrPtr[13]			 =	   'e';
	CidStrPtr[14]			 =	   ',';
	CidStrPtr[15]			 =	   'S';
	CidStrPtr[16]			 =	   'm';
	CidStrPtr[17]			 =	   'i';
	CidStrPtr[18]			 =	   't';
	CidStrPtr[19]			 =	   'h';	
	
    
	//----> End of String field.
	CidStrPtr[20]			 =	  '\0';

#endif //--> End of  TEST_CASE1

#ifdef MDMF_3

	//    CidStrPtr = ( UCHAR * ) malloc(sizeof(UCHAR) * 31);
	//----> CA will send  ASCII Characters.

	//-----> Month MM <------> Nov
	CidStrPtr[0]			 =	   '0';
	CidStrPtr[1]    		 =	   '3';

	//-----> Day   DD <------> 28'th
	CidStrPtr[2]			 =	   '2';
	CidStrPtr[3]			 =	   '1';
	
	//------> Hour HH <------> 3 PM
	CidStrPtr[4]			 =	 '1';
	CidStrPtr[5]			 =	 '4';

	//------> Minutes  mm <-----> 43 minutes
	CidStrPtr[6]		     =   '0';
	CidStrPtr[7]		     =   '5';
		
	//------> Field Seperator7
	CidStrPtr[8]		     =   ',';

    //-----> Calling Phone Number
	CidStrPtr[9]			 =	   '5';
	CidStrPtr[10]    		 =	   '0';
	CidStrPtr[11]			 =	   '4';
	CidStrPtr[12]			 =	   '5';
	CidStrPtr[13]			 =	   '5';
	CidStrPtr[14]    		 =	   '5';
	CidStrPtr[15]			 =	   '1';
	CidStrPtr[16]			 =	   '2';
	CidStrPtr[17]			 =	   '3';
	CidStrPtr[18]    		 =	   '4';
	

	//------> Field Seperator
	CidStrPtr[19]		     =     ',';
        
	
	//-----> Calling Phone Name	
	CidStrPtr[20]			 =	   'P';
	
	//----> End of String field.
	CidStrPtr[21]			 =	  '\0';

#endif //--> End of  TEST_CASE1


#ifdef SDMF_1
	//    CidStrPtr = ( UCHAR * ) malloc(sizeof(UCHAR) * 31);
	//----> CA will send  ASCII Characters.

	//-----> Month MM <------> Nov
	CidStrPtr[0]			 =	   '1';
	CidStrPtr[1]    		 =	   '2';

	//-----> Day   DD <------> 28'th
	CidStrPtr[2]			 =	   '2';
	CidStrPtr[3]			 =	   '5';
	
	//------> Hour HH <------> 3 PM
	CidStrPtr[4]			 =	   '1';
	CidStrPtr[5]			 =	   '5';

	//------> Minutes  mm <-----> 43 minutes
	CidStrPtr[6]		     =     '3';
	CidStrPtr[7]		     =     '0';
		
	//------> Field Seperator7
	CidStrPtr[8]		     =   ',';

    //-----> Calling Phone Number
	CidStrPtr[9]			 =	   'P';	
    
	//----> End of String field.
	CidStrPtr[10]			 =	  '\0';

#endif

#ifdef SDMF_2
	
	//    CidStrPtr = ( UCHAR * ) malloc(sizeof(UCHAR) * 31);
	//----> CA will send  ASCII Characters.

	//-----> Month MM <------> Nov
	CidStrPtr[0]			 =	   '1';
	CidStrPtr[1]    		 =	   '2';

	//-----> Day   DD <------> 28'th
	CidStrPtr[2]			 =	   '2';
	CidStrPtr[3]			 =	   '5';
	
	//------> Hour HH <------> 3 PM
	CidStrPtr[4]			 =	 '1';
	CidStrPtr[5]			 =	 '5';

	//------> Minutes  mm <-----> 30 minutes
	CidStrPtr[6]		     =   '3';
	CidStrPtr[7]		     =   '0';
		
	//------> Field Seperator7
	CidStrPtr[8]		     =   ',';

    //-----> Calling Phone Number
	CidStrPtr[9]			 =	   '6';
	CidStrPtr[10]    		 =	   '0';
	CidStrPtr[11]			 =	   '6';
	CidStrPtr[12]			 =	   '1';
	CidStrPtr[13]			 =	   '2';
	CidStrPtr[14]    		 =	   '3';
	CidStrPtr[15]			 =	   '4';
	CidStrPtr[16]			 =	   '5';
	CidStrPtr[17]			 =	   '6';
	CidStrPtr[18]    		 =	   '7';	
    
	//----> End of String field.
	CidStrPtr[19]			 =	  '\0';

#endif

#ifdef SDMF_3
	
	//    CidStrPtr = ( UCHAR * ) malloc(sizeof(UCHAR) * 31);
	//----> CA will send  ASCII Characters.

	//-----> Month MM <------> Nov
	CidStrPtr[0]			 =	   '1';
	CidStrPtr[1]    		 =	   '1';

	//-----> Day   DD <------> 28'th
	CidStrPtr[2]			 =	   '1';
	CidStrPtr[3]			 =	   '1';
	
	//------> Hour HH <------> 3 PM
	CidStrPtr[4]			 =	 '1';
	CidStrPtr[5]			 =	 '1';

	//------> Minutes  mm <-----> 30 minutes
	CidStrPtr[6]		     =   '1';
	CidStrPtr[7]		     =   '1';
		
	//------> Field Seperator7
	CidStrPtr[8]		     =   ',';

    //-----> Calling Phone Number
	CidStrPtr[9]			 =	   '1';
	CidStrPtr[10]    		 =	   '1';
	CidStrPtr[11]			 =	   '1';
	CidStrPtr[12]			 =	   '1';
	CidStrPtr[13]			 =	   '1';
	
	//----> End of String field.
	CidStrPtr[14]			 =	  '\0';

#endif
/*******************************************************************
	             End of  CidTxMain Calling EnvironMent Top API Input
				       		information Simulation
********************************************************************/
}

#endif

unsigned short getCIDTxPlayCntr(UCHAR ucIntrFlag)
{
 if(ucIntrFlag == 0)
   return(fisrt_ring_cidtx_play[guiCountry]);
 else if(ucIntrFlag == 1)
   return(fisrt_ring_cidtx_play_5ms[guiCountry]);
 return (fisrt_ring_cidtx_play[guiCountry]);
}


#endif //endif for CALLER_IDTx switch


// LCe OpenRG Hollande
void dtmfCidGenerationFlag(Word16 ucPortNo)
{
/* last digit sended (time on and time off), next digit */
dtmfCidGen[ucPortNo].ucIpcDigFlag = 0;
}

void dtmfCidGeneration(Word16 ucPortNo)
{
 UCHAR ucDigit;
        if(dtmfCidGen[ucPortNo].ucDigState == 1)
	{ //SEIZ State.
		if( dtmfCidGen[ucPortNo].ucIpcDigCntr == 1)		
			slicReverseActivate(ucPortNo);

		if( dtmfCidGen[ucPortNo].ucIpcDigCntr >= 40)		
                {
			dtmfCidGen[ucPortNo].ucDigState = 2;			
			dtmfCidGen[ucPortNo].ucIpcDigCntr = 0;
                }
	}
	else if(dtmfCidGen[ucPortNo].ucDigState ==2)
	{ // DIGIT Play
		if(dtmfCidGen[ucPortNo].ucIpcDigFlag == 0)
		{
			if(dtmfCidGen[ucPortNo].ucDigFrameLen > 0)
			{//Generate Next DTMF Digit
				ucDigit =  dtmfCidGen[ucPortNo].aucCidDigStr[dtmfCidGen[ucPortNo].ucDigIndex];
			        dspipcGenTone(ucPortNo,ucDigit,0);
				dtmfCidGen[ucPortNo].ucDigFrameLen--;
				dtmfCidGen[ucPortNo].ucIpcDigFlag = 1;			
				dtmfCidGen[ucPortNo].ucIpcDigCntr = 0;
				dtmfCidGen[ucPortNo].ucDigIndex++;
//printk("\n Digit: %x",ucDigit);
			}
			else
			{
                           dtmfCidGen[ucPortNo].ucIpcDigCntr = 0;
                           dtmfCidGen[ucPortNo].ucDigState = 3;
			}

		}
	}
	else if(dtmfCidGen[ucPortNo].ucDigState == 3 )
	{ // WAIT after last digit
		if( dtmfCidGen[ucPortNo].ucIpcDigCntr >= (30-8))	// interdigit du dernier digit
			{
			dtmfCidGen[ucPortNo].ucIpcDigCntr = 0;
			dtmfCidGen[ucPortNo].ucDigState = 4;		// ringing
                        }
		}
}

void dtmfCidInit(UCHAR *aucStr,Word16 portNum)
{ //Init Cid Digit Structure.
   UCHAR ucCntr = 0,i;
#if 0
   VoiceOptions voiceOpts;
    bzero(&voiceOpts,sizeof(voiceOpts));
    voiceOpts.encoder_opt[0] = 0x8d00; // This sets 15th and 8th Bits.
    voiceOpts.decoder_opt[0] = 0x8c80;
    voiceOpts.decoder_opt[1] = 0x0100; //Bell Core

    //if(gaCMCB[ulIndex].dspInfo.bInitDone == FALSE)
    {
    	cmInitDSPPort(portNum,&voiceOpts);
    }
#endif

    dtmfCidGen[portNum].aucCidDigStr[ucCntr++] = DIG_D_TONE; //mapped to 0xd

    if (strlen(aucStr) == 0)		// CLIR or number unaviable send 10 DIGIT_0
	{
	for(i=0;i<10;i++)
		{
		dtmfCidGen[portNum].aucCidDigStr[ucCntr++] = DIG_0_TONE;
		}
	}
    else
	{
	for(i=0;i<strlen(aucStr);i++)
		{
		dtmfCidGen[portNum].aucCidDigStr[ucCntr++] = (aucStr[i] - 0x30) + DIG_0_TONE;
//		PRINT("%c ....%d\n\r",aucStr[i],atoi(tempChar));
		}
	}
    dtmfCidGen[portNum].aucCidDigStr[ucCntr++] = DIG_C_TONE; //0xC; mapped to C 
    dtmfCidGen[portNum].ucDigFrameLen = ucCntr;
    dtmfCidGen[portNum].ucDigState = 1;
    dtmfCidGen[portNum].ucDigIndex = 0;
    dtmfCidGen[portNum].ucIpcDigCntr = 0;
    dtmfCidGen[portNum].ucIpcDigFlag = 0;

   /* for(i=0;i<ucCntr;i++)
    {
	PRINT("\n%d\n\r",dtmfCidGen[portNum].aucCidDigStr[i]);
    }*/

}

