
/******************************************************************************
Ver       : 0.01
File Name : CIDRxCon.h
Purpose   : 
Project   : 
Complaint : Bellcore 30/31
******************************************************************************/
#include "../include/voice_typedef.h"

#define MAX_CHAN_CID  1    /* MAX FXO Port not FXS port */
#define BLOCK_LEN     80
#define	RATE_LENGTH   30

/******************************************************************************
                      RUN CONDITIONS 
******************************************************************************/


//---> Resolving of PayLoad Buffer Length Constants
#ifdef  DECIMATION 
	#define CID_TX_PAY_LOAD_LEN        80
#else
	#define CID_TX_PAY_LOAD_LEN       240
#endif


//--> Select Source side One Source  Input
//#define SDMF_1
//#define SDMF_2
#define  MDMF_1
//#define  MDMF_2

/******************************************************************************
                     CONTROLLING PARAMETERS/USER SELECTION
******************************************************************************/
//---> No of Channles
//#define  MAX_VOICE_CHANNELS          NUM_VOICE_CHANNELS


/******************************************************************************
              DATA TRANSMISSION PROTOCOL MANAGING STATE DEFENETIONS.
******************************************************************************/
#define  CID_TX_STATE0	             0
#define  CID_TX_STATE1               1
#define  CID_TX_STATE2               2
#define  CID_TX_STATE3               3
#define  CID_TX_STATE4               4

//---> First Ring to Data Start Generation Event Delay Counter interm of 10ms.
#define  FISRT_RING_CIDTX_PLAY     150   //--> 150 ms.



/******************************************************************************
             Caller -ID BELL -30/  Message Layer Type fields
******************************************************************************/
#define  SPCS_MSG_TYPE_SDMF           0x04
#define  SPCS_MSG_TYPE_MDMF           0x80
#define  SPCS_MSG_TYPE_GDMF           0xFF  // --> Need to be captured


/******************************************************************************
             Caller -ID BELL -30/ Presentation Layer Date field Length
******************************************************************************/
#define  DATE_FIELD_LENGTH            0x08



/******************************************************************************
         Caller -ID BELL -30/   MDMF Presentation Layer  field Types
      if Number and and Name are available,
                                following Type  for Num and Name will be used
******************************************************************************/
#define  MDMF_DATE_TIME_TYPE          0x01
#define  MDMF_T_CALL_NUMBER_TYPE      0x02
#define  MDMF_T_CALL_NAME_TYPE        0x07


/******************************************************************************
         Caller -ID BELL -30/   MDMF Presentation Layer  field Types
if Number and and Name are not 
                          available ,following Type  for Num and Name are used
to indicate the reasons for non-availability of Information
******************************************************************************/
#define  MDMF_R_CALL_NUMBER_TYPE      0x04
#define  MDMF_R_CALL_NAME_TYPE        0x08


/******************************************************************************
     DATA LAYER Channel Seizure/ Mark signal generation side 
	 Counters   interms of 10 ms Intervals.
******************************************************************************/
#define LEN_CHAN_SEIZURE_25x12BITS  25
#define LEN_MARK_SIG_15x12BITS      15


/******************************************************************************
                  PHYSICAL LAYER Signal Properties
******************************************************************************/

/******************************************************************************
             Choice of Amplitude <---> 8059 <---> -3.17 dBm.
Each Signal Level as per BELL -30 Req Ref :-13.5 dBm with 900 ohm termination.
******************************************************************************/
#define AMP     8159


/******************************************************************************
           Sampling Frequence Selection
		   Fs : 8000 kHz
           Up   Sampling it 3      = 24000 Hz.
		   Down Sampling it yields = 8000  Hz.
		   Phasor  rate : 24K.
******************************************************************************/
#define FS_LINE       8000 //8000 //24000
#define FS_USED      24000 //8000 //24000


/******************************************************************************
           V.21 Frequency Selection
******************************************************************************/
//#define FREQ0   600
//#define FREQ1   1200

//#define FREQ0   1200    // Commented to eliminate the conflict with CID_TX
//#define FREQ1   2200   

#if !BIT_TRANSMISSION_RATE
/******************************************************************************
           V.21 BIT TRANSMISSION RATE
		   1200 Baud.
******************************************************************************/
#define  BIT_TRANSMISSION_RATE        1200 
#endif


#if !NO_OF_SAMPLES_PER_BIT
/******************************************************************************
      W.R.T BIT TRANSMISSION RATE , NO OF SAMPLES PER EACH BIT
******************************************************************************/
#define  NO_OF_SAMPLES_PER_BIT      ( FS_USED /1200 )
#endif

/******************************************************************************
                       DOWN_SAMPLE_FACT
      W.R.T BIT TRANSMISSION RATE && SUPPOSED FS : 8K && USED FS :24 K
******************************************************************************/
#define  DOWN_SAMPLING_MOD_CONST      ( FS_USED / FS_LINE )



/******************************************************************************
                     FEW SIMULATION CONSTANTS
******************************************************************************/
#define MAX_32 (Word32)0x7fffffffL
#define MIN_32 (Word32)0x80000000L
#define MAX_16 (Word16)0x7fff
#define MIN_16 (Word16)0x8000
#define PHI     3.14159
#define Q15     32767



void cid_display(void);
void CidRxMain(UINT16 *pCallerIdData, Word16 CurChanNumCid);
void UpConvert_cid(UINT16 *pCallerIdData,Word16 CurChanNumCid);
Word16 FIR_cid(Word16 *UpCoefPtr, Word16 CurChanNumCid);
void Lpf_QuadMod(Word16 CurChanNumCid);
void CidRxExtPattern(Word16 Det12Bit,Word16 CurChanNumCid);
void CidRxExtBit(Word16 cidrx_op_samp,Word16 CurChanNumCid);
void cidrxBell_cw(Word16 CurChanNumCid);
void cidrxAppInit(Word16 CurChanNumCid);
void CidRxInit(Word16 CurChanNumCid);
void Init_Pre_Process(Word16 CurChanNumCid);
void Pre_Process(
  Word16 *signal,    /* input/output signal */
  Word16 lg,         /* length of signal    */
  Word16 CurChanNumCid);


void   L_Extract(Word32 L_32, Word16 *hi, Word16 *lo);
Word32 Mpy_32_16(Word16 hi, Word16 lo, Word16 n);

void cidrx_dump(void);
