
/*****************************************************************************
   DtmfrxFilt.c
   sivan.nagireddi@analog.com
*****************************************************************************/


//>>>>>>>>>>>>--------------------------------------------------------------
//#define DTMFRX_SIMULATOR
//>>>>>>>>>>>>--------------------------------------------------------------

#ifndef DTMFRX_SIMULATOR
#include <oswrapper.h>
#include <HDtmfrxConst.h>
#include <HDtmfrxThr.h>
#include <HDtmfrxExtVar.h>
#include <HDtmfrxProto.h>
  extern int dtmfCliArg1, dtmfCliArg2;
#if CALLER_IDTx
  extern CidTxType_  SMM_CidTx[MAX_VOICE_CHANNELS];
#endif
#else//--------->>>> SIMULATOR
  #include "DtmfrxProto.h"
  #include "HDtmfrxConst.h"
  #include "HDtmfrxProto.h"
  #include "HDtmfrxThr.h"
  #include "HDtmfrxExtVar.h"
  #include "Basic_op.h"
  #include "DtmfrxVarExt.h"
  #include "DtmfrxTest.h"



   #ifdef MATLAB_ENV
   extern Word32 Tem32_bin[DTMFRX_BIN_LEN];
   extern Word32 BinEne[DTMFRX_HISTORY_LEN][DTMFRX_BIN_LEN];

 extern Word16 LogCurEstDigEnergy;
 extern Word16 LogIP_EstdBm;
 extern Word16 LogOP_EstdBm;
  #endif
#endif //----------End of SIMULATOR


/*****************************************************************************
              Host Detection Main Function.
*****************************************************************************/
void HDtmfrxDet(Word16 PortNum )
{  

  Word16 i;
  Word16 temp1,temp2,temp,DtmfrxTempSum;        
  CommandQ  DtmfrxCmdList[MAX_VOICE_CHANNELS];

  //------------------------------------------------------------
				//----> LOCAL VARIABLES
  //------------------------------------------------------------  
    Word16 IP_EstdBm;
    Word16 OP_EstdBm;

    Word16 Dtmfrx_r_index1;
    Word16 Dtmfrx_c_index1;
    Word16 Dtmfrx_row_max1;
    Word16 Dtmfrx_col_max1;
    Word16 Dtmfrx_row_max2;
    Word16 Dtmfrx_col_max2;

	Word16 DTMFRX_POS_SIG_ROW;
	Word16 DTMFRX_POS_SIG_COL;

	Word16 DTMFRX_TALK_OFF_MIN_DIG_THR;
        Word16 DTMFRX_TALK_OFF_LIK_DIG_THR;
        Word16 DTMFRX_TALK_OFF_ABS_DIG_THR;
    Word16 DTMFRX_TALK_OFF_REJ_DIG_THR;

	Word16 Dtmfrx_MinEne, DtmfrxTwistMode;
    Word16 DtmfrxTwist_p, DtmfrxRowRel_p,DtmfrxColRel_p;
    Word16 DtmfrxTwist_f, DtmfrxRowRel_f,DtmfrxColRel_f;

	Word16 DtmfrxTestWord1;
	

    Word16 Dtmfrx_r_dtmf;
    Word16 Dtmfrx_digit_det;  
	  
	  
    Word16 DtmfrxAbsDigEnergy;
    Word16 DtmfrxJustDigEnergy;
    Word16 DtmfrxNullDigEnergy;
    Word16 DtmfDetMaxCnt;
    Word16 DtmfDetIndex;
    Word16 DtmfrxTotRevTwist;
    Word16 DtmfrxTotFarTwist;  
    Word16 TempWord1;
    Word16 frame;
    Word16 Dtmfrx_digit_op;
    Word16 DigLogIndex;
	
#if DTMFRX_CALL_FROM__APPLICATION
    Word16 WhileLoopErr=0;
#endif
        Word16 Temp16;
	Word16 TempIpEstdB;
        Word16 TempOpEstdB;
	uWord16 DSP2HOST_SEQNUM;

	uWord16 DtmfNextProbableDig;
	uWord16 DtmfProbableDig;

	uWord16 MinEnePassOffset;
        uWord16 TwistPassOffset;
        uWord16 RowRelPassOffset;
        uWord16 ColRelPassOffset;
        uWord16 TalkoffPassOffset;
  uWord16 Tone_off_offset;
	uWord16 DtmfNextProbableDigMaxCnt;
	Word16	DtmfrxMaxDiffDigsThr;
	Word16  DtmfNextProbableDigMaxCntThr;
	Word16	DtmfrxMinDetCnt = 0;
	Word16	DtmfrxMinAbsDetCnt = 0;
  
	Word16	DtmfrxCurFrame = 0;

/*******************************************************************
	             QUE  NOT YET RESET
 *******************************************************************/
   if( HDtmfrx_reset_on[PortNum] ==  0 )
     return;
   else if( HDtmfrx_reset_on[PortNum] ==  1 )
   {	
     DtmfrxIpcInit(PortNum);
     DtmfrxResetDet(PortNum);
   }
/*******************************************************************
		    END OF  QUE  NOT YET RESET
*******************************************************************/


 
 /*******************************************************************
		     CHECK DTMFRX RESET ON 
 *******************************************************************/
   if(  SMMDtmfrx[PortNum].Dtmfrx_reset_on   ==  0 )   
       DtmfrxResetDet(PortNum);
/*******************************************************************
		END OF  CHECK DTMFRX RESET ON 
 *******************************************************************/

#ifdef DTMFRX_CALL_FROM__APPLICATION

#ifdef HDTMFRX_LOG
   if( SMMDtmfrx[PortNum].QueWtFailCntr > 50 )
   { 
       printf("OF:%d",PortNum);
       SMMDtmfrx[PortNum].QueWtFailCntr = 0;
   }
#endif


/******************************************************************************
          READ IN LOOP STILL IPC QUE IS EMPTY
******************************************************************************/
 while(1)
 {
//----------------------------------------------------------------------------
	 //---> Look for any reset in btw
//----------------------------------------------------------------------------
   if( HDtmfrx_reset_on[PortNum] ==  0 )
     return;
   else if( HDtmfrx_reset_on[PortNum] ==  1 )
    {
      DtmfrxIpcInit(PortNum);
      DtmfrxResetDet(PortNum);
    }
//----------------------------------------------------------------------------
	//---> Look for any reset in btw
//----------------------------------------------------------------------------

 /*******************************************************************
		    READ THE DTMFRX DSP-IPC QUE 
 *******************************************************************/
    //--> Que for DSP_IPC_DTMFRX_QUE
    TempIndex =  SMMDtmfrx[PortNum].DtmfrxQueRdIndex;
    if (( SMMDtmfrx[PortNum].DtmfrxQueInitCntr <  DSP2HOST_DTMFRX_QUE_LEN  )
            && (SMMDtmfrx[PortNum].DtmfrxQueInitCntr  > TempIndex)
	    &&( SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][0] == DTMFRX_PACKET ))
    {
     //--->  First DSP2HOST_DTMFRX_QUE_LEN Read operations.  
       TempWord1       =  SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][1];
       IP_EstdBm       =  ( 0x00FF & ( TempWord1 >> 8 ));
       OP_EstdBm       =  ( 0x00FF &  TempWord1        );

       TempWord1       =  SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][2];
       Dtmfrx_r_index1 =  ( 0x00FF & ( TempWord1 >> 8 ) );
       Dtmfrx_c_index1 =  ( 0x00FF &  TempWord1 );

       Dtmfrx_row_max1 =  SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][3];
       Dtmfrx_col_max1 =  SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][4];
       Dtmfrx_row_max2 =  SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][5];
       Dtmfrx_col_max2 =  SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][6];
	   DSP2HOST_SEQNUM =  SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][7];
       SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][0] = DTMFRX_NULL_PACKET;	   
       TempIndex++;
       TempIndex       =  TempIndex % DSP2HOST_DTMFRX_QUE_LEN;
       SMMDtmfrx[PortNum].DtmfrxQueRdIndex = TempIndex;

       //---> End of First DSP2HOST_DTMFRX_QUE_LEN Read operations.  
	}else if( SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][0] == DTMFRX_PACKET )
    {  
       //---> Post DSP2HOST_DTMFRX_QUE_LEN Read operations.  
       TempWord1       =  SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][1];
       IP_EstdBm       =  ( 0x00FF & ( TempWord1 >> 8 ));
       OP_EstdBm       =  ( 0x00FF &  TempWord1        );

       TempWord1       =  SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][2];
       Dtmfrx_r_index1 =  ( 0x00FF & ( TempWord1 >> 8 ) );
       Dtmfrx_c_index1 =  ( 0x00FF &  TempWord1 );

       Dtmfrx_row_max1 =  SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][3];
       Dtmfrx_col_max1 =  SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][4];
       Dtmfrx_row_max2 =  SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][5];
       Dtmfrx_col_max2 =  SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][6];
       DSP2HOST_SEQNUM =  SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][7];
	   
       SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][0] = DTMFRX_NULL_PACKET;
       TempIndex++;
       TempIndex   =  TempIndex % DSP2HOST_DTMFRX_QUE_LEN; 
       SMMDtmfrx[PortNum].DtmfrxQueRdIndex = TempIndex;
       //---> End of Post  DSP2HOST_DTMFRX_QUE_LEN Read operations.  
    }//--> End of if ( == DTMFRX_PACKET )
    else
    {
       //--> No new packet to Process.
       return;
    }
/*******************************************************************
          END OF READING OF  NON -NULL PACKET IN QUE
*******************************************************************/
#else
//------------------------------------------------------------------
  //---> Read Frame 
//------------------------------------------------------------------
  
   if( SMMDtmfrxDSP2HostBuff[PortNum][0] == DTMFRX_PACKET ) 
   { 
       TempWord1       =  SMMDtmfrxDSP2HostBuff[PortNum][1];
       IP_EstdBm       =  ( 0x00FF & ( TempWord1 >> 8 ));
       OP_EstdBm       =  ( 0x00FF &  TempWord1        );

       TempWord1       =  SMMDtmfrxDSP2HostBuff[PortNum][2];
       Dtmfrx_r_index1 =  ( 0x00FF & ( TempWord1 >> 8 ) );
       Dtmfrx_c_index1 =  ( 0x00FF &  TempWord1 );

       Dtmfrx_row_max1 =  SMMDtmfrxDSP2HostBuff[PortNum][3];
       Dtmfrx_col_max1 =  SMMDtmfrxDSP2HostBuff[PortNum][4];
       Dtmfrx_row_max2 =  SMMDtmfrxDSP2HostBuff[PortNum][5];
       Dtmfrx_col_max2 =  SMMDtmfrxDSP2HostBuff[PortNum][6];
       DSP2HOST_SEQNUM =  SMMDtmfrxDSP2HostBuff[PortNum][7];

       //SMMDtmfrxDSP2HostBuff[PortNum][0] = DTMFRX_NULL_PACKET;
       //---> Do Frame Increment.
       
       DtmfrxHostFrame[PortNum] += 1;

  }
  else
    return;
//------------------------------------------------------------------
  //---> Read Frame 
//------------------------------------------------------------------
#endif






/*******************************************************************
                    START OF  DTMFRX-DETLOGIC 
*******************************************************************/
//------------------------------------------------------------------
  //---> Frame count updating.
//------------------------------------------------------------------
  if( SMMDtmfrx[PortNum].Dtmfrx_tone_on  > 0)
  {
#if 0
	    SeqNumDiff = DSP2HOST_SEQNUM - SMMDtmfrx[PortNum].DtmfrxSeqNum;
		SMMDtmfrx[PortNum].DtmfrxSeqNum = DSP2HOST_SEQNUM;
		if(( SeqNumDiff <  0 )||(SeqNumDiff > 2 ))
		{
		  SMMDtmfrx[PortNum].SeqNumErr += 1;
		  printf("SE\r\n");
		  return;
		}else
		{
			SMMDtmfrx[PortNum].SeqNumErr  = 0;		
		}       		
#endif

       //---> To Know the Total Period of Toneon + Tone off.
	   SMMDtmfrx[PortNum].DtmfrxFrameCntr += 1;

	   //---> SMMDtmfrx[PortNum].DtmfrxFrame is to Log The History.
    SMMDtmfrx[PortNum].DtmfrxFrame += 1;
    if( SMMDtmfrx[PortNum].DtmfrxFrame >= DTMFRX_HISTORY_LEN )
       SMMDtmfrx[PortNum].DtmfrxFrame =  DTMFRX_HISTORY_LEN-1;
  }  
  frame = SMMDtmfrx[PortNum].DtmfrxFrame;
//------------------------------------------------------------------
  //---> End of Frame count updating.         
//------------------------------------------------------------------
  
#ifdef MATLAB_ENV
  for( i= 0; i < DTMFRX_BIN_LEN; i++ )  
     BinEne[frame][i] =  Tem32_bin[i];
  SMMDtmfrx[PortNum].DtmfrxRowMax1[frame] = Dtmfrx_row_max1;
  SMMDtmfrx[PortNum].DtmfrxColMax1[frame] = Dtmfrx_col_max1;
  SMMDtmfrx[PortNum].DtmfrxRowMax2[frame] = Dtmfrx_row_max2;
  SMMDtmfrx[PortNum].DtmfrxColMax2[frame] = Dtmfrx_col_max2;
#endif

 /*******************************************************************
			10 ms  Data Analysis
 ********************************************************************/
#ifdef MATLAB_ENV
  LogCurEstDigEnergy    =   ( Dtmfrx_row_max1 << 8)+ Dtmfrx_col_max1;
  LogIP_EstdBm          =   IP_EstdBm;
  LogOP_EstdBm          =   OP_EstdBm;
#endif  

  SMMDtmfrx[PortNum].DtmfrxEneHistL[frame] = 
	                                 ( Dtmfrx_row_max1 << 8)+ Dtmfrx_col_max1;
  SMMDtmfrx[PortNum].DtmfrxIpOpdBm[frame]  = ( IP_EstdBm << 8 ) + OP_EstdBm;

  
  SMMDtmfrx[PortNum].CurFrameTestResult = 0;
  Dtmfrx_r_dtmf         =    0;
  Dtmfrx_digit_op       =   -1;
  DtmfrxTwistMode       =    0;	 
  DtmfrxTwist_p         =    0;
  DtmfrxRowRel_p        =    0;
  DtmfrxColRel_p        =    0;

  DtmfrxTwist_f         =    0;
  DtmfrxRowRel_f        =    0;
  DtmfrxColRel_f        =    0;
  Dtmfrx_MinEne         =    0; //----> CurEstDigEnergy / DTMFRX_DIG_ENERGY_STEP;



/**************************************************************************
		      DYNAMIC THRESHOLD FIXING
***************************************************************************/
#if 1
   temp1 =  IP_EstdBm;
     
   if(temp1 < 0 )
      temp1 = 0;
   else if( temp1 > 10)
		 temp1 = 10;
     
   DTMFRX_POS_SIG_ROW             =  DtmfrxThr[temp1][0];
   DTMFRX_POS_SIG_COL             =  DtmfrxThr[temp1][1];
     
   DTMFRX_TALK_OFF_MIN_DIG_THR    =  DtmfrxThr[temp1][2];
   DTMFRX_TALK_OFF_LIK_DIG_THR    =  DtmfrxThr[temp1][3];
   DTMFRX_TALK_OFF_ABS_DIG_THR    =  DtmfrxThr[temp1][4];
   DTMFRX_TALK_OFF_REJ_DIG_THR    =  DtmfrxThr[temp1][5];

#endif	
  
/*****************************************************************************
		   END OF THRESHOLD FIXING
******************************************************************************/




/******************************************************************************
		      TWIST & SIDE LOBE TESTS
******************************************************************************/	 
{
//----> TWIST TEST
/*
Requirement: The level of any tone in the DTMF high frequency group shall be -9,0 dBV +2,0/-2,5 dB and
the level of any tone in the low frequency group shall be -11,0 dBV +2,5/-2,0 dB when the TE interface is
terminated with the reference impedance ZR.
Requirement: During sending of any DTMF frequency combination, the level of the tone in the high
frequency group shall be 1 dB to 4 dB higher than the level of the tone in the low frequency group.
*/
   if( Dtmfrx_row_max1 > Dtmfrx_col_max1 )
   {
     /*
                          REVERSE TWIST
		             COLUMN TONE ENERGY < ROW TONE ENERGY  BY -8dB
     */
		   DtmfrxTotRevTwist = Dtmfrx_row_max1 - Dtmfrx_col_max1;
	       DtmfrxTotFarTwist = 0x1111;
		  
          DTMFRX_POS_SIG_COL   =  DTMFRX_POS_SIG_COL + 2 * DTMFRX_REV_TWI;
          if(( Dtmfrx_row_max1 >=  DTMFRX_POS_SIG_ROW )&&
			                   ( Dtmfrx_col_max1 >= DTMFRX_POS_SIG_COL  ))
          {
		    Dtmfrx_MinEne         =    2;
		    DtmfrxJustDigEnergy   =    0;
	 	    DtmfrxAbsDigEnergy    =    1;
	        DtmfrxNullDigEnergy   =    0;
          }		  
		  
		  temp =  (Dtmfrx_col_max1 - Dtmfrx_row_max1)/2;
		  
		  if( temp >= DTMFRX_REV_TWI  )    
       //--> reverse Twist Pass Bit Set.
       DtmfrxTwist_p =  1;
     else
       DtmfrxTwist_f =  1;
    	 } //--> end of reverse twist
  else
  {
    /*
           FARWARD TWIST (OR) STANDARD TWIST
      COLUMN TONE ENERGY > ROW TONE ENERGY  BY 8dB
    */
		   DtmfrxTotRevTwist  =  0;
		   DtmfrxTotFarTwist  =  Dtmfrx_col_max1 - Dtmfrx_row_max1;
	       
		   DTMFRX_POS_SIG_ROW   =  DTMFRX_POS_SIG_ROW - 2*DTMFRX_FOR_TWI;
           if(( Dtmfrx_row_max1 >=  DTMFRX_POS_SIG_ROW )&&
			                   ( Dtmfrx_col_max1 >= DTMFRX_POS_SIG_COL  ))
           {
		     Dtmfrx_MinEne         =    2;
		     DtmfrxJustDigEnergy   =    0;
	 	     DtmfrxAbsDigEnergy    =    1;
	         DtmfrxNullDigEnergy   =    0;
           }        


    //--> Set the Farward Twist Bit.		
    DtmfrxTwistMode  =  1;
 		   temp =  (Dtmfrx_col_max1 - Dtmfrx_row_max1)/2;

		   if( temp  <=  DTMFRX_FOR_TWI  ) //--> 4dB
      DtmfrxTwist_p   =  1;//--> Farward Twist Pass Bit Set.
    else
      DtmfrxTwist_f   =  1;//--> Farward Twist Fail Bit set.

  }//--> end of farward twist


		   temp1 =  (Dtmfrx_row_max1 - Dtmfrx_row_max2)/2;
		   temp2 =  (Dtmfrx_col_max1 - Dtmfrx_col_max2)/2;
		
		   //---> 20 dB
		   if( temp1 >=  DTMFRX_REL_RATIO  )
       DtmfrxRowRel_p  =  1;//--> Relative Ratio  Passed for Row.
    else
       DtmfrxRowRel_f  =  1;//--> Relative Ratio  failed for Row.

		   if( temp2 >= DTMFRX_REL_RATIO  )
       DtmfrxColRel_p      =  1;//--> Relative Ratio  Passed for Column
   else
       DtmfrxColRel_f      =  1;//--> Relative Ratio  failed for Column
/******************************************************************************
		END OF  TWIST & SIDE LOBE TESTS
******************************************************************************/		 
 }//--End of Test cases for Good Enegy detection case.


/*****************************************************************************
 	     PROBABLE  DIGIT  INDICATED IN CURRENT INSTANACE.
******************************************************************************/
   Dtmfrx_digit_det = -1;
   Dtmfrx_digit_det =  ( ( 0x000F ) & (4 * Dtmfrx_r_index1 + Dtmfrx_c_index1));





/******************************************************************************
		EXTRACT TONE ON &OFF PROPERTIES.
*******************************************************************************/
#if 1
if(( SMMDtmfrx[PortNum].Dtmfrx_tone_on == 1 )&&
                          (( Dtmfrx_MinEne  < DTMFRX_TONE_ON_THR)
			||( SMMDtmfrx[PortNum].Dtmfrx_DtmfLikelyDig != Dtmfrx_digit_det)
			||( OP_EstdBm < DTMFRX_TALK_OFF_MIN_DIG_THR )) )
{
       DtmfrxCurFrame  = 0;
       DtmfrxEarlyReset(PortNum);
       frame = 0;
}
#endif

// Pour plan (+3 -7) 5 si plan (0 -7)
if(( SMMDtmfrx[PortNum].Dtmfrx_tone_on == 0)&&(Dtmfrx_MinEne )	                
					&&( IP_EstdBm <=  DTMFRX_TONE_ON_TOT_SIG_THR )
					&&( OP_EstdBm >= DTMFRX_TALK_OFF_LIK_DIG_THR))
    {
    SMMDtmfrx[PortNum].Dtmfrx_tone_on = 1;
      SMMDtmfrx[PortNum].Dtmfrx_tone_off = 0;
	  
    SMMDtmfrx[PortNum].Dtmfrx_DtmfLikelyDig = Dtmfrx_digit_det;
	  SMMDtmfrx[PortNum].DtmfrxDigPrev        = Dtmfrx_digit_det;
	  SMMDtmfrx[PortNum].DtmfrxMaxDiffDigs    = 1;
	  SMMDtmfrx[PortNum].DtmfrxSeqNum = DSP2HOST_SEQNUM;
	  DtmfrxCurFrame  = 1;
	  SMMDtmfrx[PortNum].DtmfrxFrameCntr = 1;

 }else if((SMMDtmfrx[PortNum].Dtmfrx_tone_on > 0)
	                &&( Dtmfrx_MinEne > DTMFRX_TONE_OFF_THR)
	                &&( IP_EstdBm <= DTMFRX_TONE_ON_TOT_SIG_THR )
					&&( OP_EstdBm >= DTMFRX_TALK_OFF_MIN_DIG_THR))
    {
    SMMDtmfrx[PortNum].Dtmfrx_tone_on++;
    SMMDtmfrx[PortNum].Dtmfrx_tone_off = 0;
	 DtmfrxCurFrame  = 1;

 }else if((SMMDtmfrx[PortNum].Dtmfrx_tone_on > 0) //&&( IP_EstdBm > 7 )
	    &&(( Dtmfrx_MinEne < DTMFRX_TONE_OFF_THR ) ||
                                                  ( IP_EstdBm >= 12 )))
 {
   //-->Input Sig <= -36dBm (or) MinEneFail (or) OurputEne Fail. 
   DtmfrxCurFrame  = 0;
   SMMDtmfrx[PortNum].Dtmfrx_tone_off++;
   if( SMMDtmfrx[PortNum].Dtmfrx_tone_off == 1 )
    SMMDtmfrx[PortNum].ToneOffFrameCntr = 
	                    SMMDtmfrx[PortNum].DtmfrxFrameCntr;
    }


if(SMMDtmfrx[PortNum].Dtmfrx_tone_off >= DTMFRX_TONE_END_PAUSE_CNT )
{
        Dtmfrx_r_dtmf = 1;
   if(  SMMDtmfrx[PortNum].Dtmfrx_Rej_Flag > 0 )
   {
//--------------------------------------------------------------------
       DtmfrxCmdList[PortNum].command[0] = D2H_DTMF_DIGIT_TONE_END_REPORT;
       DtmfrxCmdList[PortNum].command[2] = SMMDtmfrx[PortNum].DtmfrxDigPrev;
       DtmfrxCmdList[PortNum].command[3] = SMMDtmfrx[PortNum].Dtmfrx_tone_on;
       dspipcCmdIntrpret(&DtmfrxCmdList[PortNum], PortNum);
//--------------------------------------------------------------------
   }
}


//--------> DTMF_REJECTION--------------------------------------------------
//--------> DTMF_REJECTION--------------------------------------------------
#ifndef DTMFRX_SIMULATOR 
if( Dtmfrx_c_index1 <= 3 )  //IKANOS_20JAN09 - added '=' condition to enable DTMF REJECTION for 4th column digits also - BUG #15617
{
 if((SMMDtmfrx[PortNum].Dtmfrx_tone_on > 0)&&(Dtmfrx_MinEne > 1)
           &&( DtmfrxTwist_p )&&( DtmfrxRowRel_p )&&( DtmfrxColRel_p )
                       &&(OP_EstdBm >= DTMFRX_TALK_OFF_REJ_DIG_THR   ))
{
     SMMDtmfrx[PortNum].Dtmfrx_Rej_on += 1;
}else
{
     SMMDtmfrx[PortNum].Dtmfrx_Rej_on = 0;
}

#if 0
if((SMMDtmfrx[PortNum].Dtmfrx_Rej_on >= 3 )||
         (( SMMDtmfrx[PortNum].Dtmfrx_Rej_Flag == 0)&&
                                 (SMMDtmfrx[PortNum].Dtmfrx_Rej_on >= 3)))
{
     SMMDtmfrx[PortNum].Dtmfrx_Rej_Flag = 1;
     SMMDtmfrx[PortNum].Dtmfrx_Rej_on = 0;

     dspipcSetDtmfRejHangOver(PortNum);
     temp1 = IP_EstdBm * 3;
       if(temp1 > 60 ) //--> > -60dBm limit to -60dBm
          temp1 = 60;
       else if (temp1 < 0 )
          temp1 = 0;
       SMMDtmfrx[PortNum].ToneLevel      = temp1;
}
#else

SMMDtmfrx[PortNum].ToneOnTimerCnt += 1;

if((SMMDtmfrx[PortNum].Dtmfrx_Rej_on >= 3 )||
         (( SMMDtmfrx[PortNum].Dtmfrx_Rej_Flag == 0)&&
                                 (SMMDtmfrx[PortNum].Dtmfrx_Rej_on >= 3)))
{
     SMMDtmfrx[PortNum].Dtmfrx_Rej_Flag += 1;
     SMMDtmfrx[PortNum].Dtmfrx_Rej_on = 0;

     dspipcSetDtmfRejHangOver(PortNum); 
     if(  SMMDtmfrx[PortNum].Dtmfrx_Rej_Flag == 1 )
     {
//--------------------------------------------------------------------
       DtmfrxCmdList[PortNum].command[0] = D2H_DTMF_DIGIT_TONE_START_REPORT;
       temp1 = IP_EstdBm * 3;
       if(temp1 > 60 ) //--> > -60dBm limit to -60dBm
          temp1 = 60;
       else if (temp1 < 0 )
          temp1 = 0;
       SMMDtmfrx[PortNum].ToneLevel      = temp1; 
       DtmfrxCmdList[PortNum].command[2] =  1; //sequence number //not assigned
       DtmfrxCmdList[PortNum].command[3] = SMMDtmfrx[PortNum].DtmfrxDigPrev;
       DtmfrxCmdList[PortNum].command[4] = temp1;//SigLevel
       dspipcCmdIntrpret(&DtmfrxCmdList[PortNum], PortNum);
       SMMDtmfrx[PortNum].ToneOnTimerCnt = 0;
//--------------------------------------------------------------------
     }
     else
     {
       if(SMMDtmfrx[PortNum].ToneOnTimerCnt >= DIGIT_CONT_REPORT_TIME) //update cont digit for every 5sec
       {
         SMMDtmfrx[PortNum].ToneOnTimerCnt = 0;
//--------------------------------------------------------------------
         DtmfrxCmdList[PortNum].command[0] = D2H_DTMF_DIGIT_TONE_CONT_REPORT;
         temp1 = IP_EstdBm * 3;
         if(temp1 > 60 ) //--> > -60dBm limit to -60dBm
          temp1 = 60;
         else if (temp1 < 0 )
          temp1 = 0;
         DtmfrxCmdList[PortNum].command[2] =  1; //sequence number //not assigned
         DtmfrxCmdList[PortNum].command[3] = SMMDtmfrx[PortNum].DtmfrxDigPrev;
         DtmfrxCmdList[PortNum].command[4] = temp1;//SigLevel
         dspipcCmdIntrpret(&DtmfrxCmdList[PortNum], PortNum);
       }
//--------------------------------------------------------------------
     }
}
#endif
}
//--------> DTMF_REJECTION--------------------------------------------------
#endif//--------> DTMF_REJ----------------------------------------------------
//--------> DTMF_REJECTION--------------------------------------------------
/*****************************************************************************
		END OF EXTRACTION OF  TONE ON &OFF PROPERTIES.
******************************************************************************/  



/*****************************************************************************
                     TEST SUMMARY FLAG
------------------------------------------------------------------------------
 0 1 2 3    4 5 6 7   8 9 A B   C D E F
------------------------------------------------------------------------------
Digit Det      X         0      X  No -Tone
Digit Det      X      x x x 1   X  Tone ON
Digit Det      X      x x 1 1   X  Good Energy &Tone ON
Digit Det    A B C D    x x x 1 X A --> rel ratio for row   1 -Pass  / 0- Fail.
	                          B --> rel ratio for column  1 -Pass  /0-Fail.
			          C --> Twist 0 --> Fail / 1 -Pass
				  D --> Twist 0 -> reverse Twist/1ForwardTwist.
Digit Det       X       x x x 1    X
******************************************************************************/
     TempOpEstdB =  OP_EstdBm ;  //--> Notch Filter Estimation
	 if( TempOpEstdB  > 15 )
         TempOpEstdB   = 15;

     TempIpEstdB =  IP_EstdBm ;  //--> Ip Estimation
	 if( TempIpEstdB  > 15 )
         TempIpEstdB   = 15;
 
     SMMDtmfrx[PortNum].DtmfrxDigHistL[frame]   =  
		 (  Dtmfrx_MinEne  )  +  ( TempOpEstdB << 4 ) 
      +  ( DtmfrxTwistMode  <<  8 ) + ( DtmfrxTwist_p  << 9 ) 
      +  ( DtmfrxRowRel_p   << 10 ) + ( DtmfrxColRel_p << 11);

     SMMDtmfrx[PortNum].DtmfrxDigHistL[frame]   = 
                         ( SMMDtmfrx[PortNum].DtmfrxDigHistL[frame] |
		                         ( 0xF000 & (Dtmfrx_digit_det << 12)));
     SMMDtmfrx[PortNum].CurFrameTestResult   = 
		                      SMMDtmfrx[PortNum].DtmfrxDigHistL[frame];
	 SMMDtmfrx[PortNum].DtmfrxSeqHist[frame]     =     DSP2HOST_SEQNUM;
/****************************************************************************
		  END OF TEST SUMMARY FLAG
*****************************************************************************/

 

/******************************************************************************
   LOG THE DIGIT PROPERTIES ON EVERY PROBABLE DIGIT DETECTION AFTER TONE ON
******************************************************************************/
if( SMMDtmfrx[PortNum].Dtmfrx_tone_on > 0 )
{
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
   if( DtmfrxCurFrame  >  0 )
   {

	 DigLogIndex = Dtmfrx_digit_det;

	 //--> Digit On Count
     SMMDtmfrx[PortNum].DtmfrxDigLog[DigLogIndex][0] += 1;

	 //--> Absolute Digit Count.
	 Temp16 = Dtmfrx_MinEne + DtmfrxTwist_p + DtmfrxRowRel_p + DtmfrxColRel_p;
	 if(( Temp16 == 5)&&( OP_EstdBm >= DTMFRX_TALK_OFF_ABS_DIG_THR ))
       SMMDtmfrx[PortNum].DtmfrxDigLog[DigLogIndex][1] += 1;
	
	 //--> Absolute Digit Energy  Count.
     SMMDtmfrx[PortNum].DtmfrxDigLog[DigLogIndex][2] += Dtmfrx_MinEne;

	 //--> TwistPass or Failure.
     SMMDtmfrx[PortNum].DtmfrxDigLog[DigLogIndex][3]  += DtmfrxTwist_p;

     //-->RowRelative Ratio Test.
     SMMDtmfrx[PortNum].DtmfrxDigLog[DigLogIndex][4] += DtmfrxRowRel_p;

     //-->Column Relative Ratio Test.
     SMMDtmfrx[PortNum].DtmfrxDigLog[DigLogIndex][5]   += DtmfrxColRel_p;

     //---> Talk off Test.
     SMMDtmfrx[PortNum].DtmfrxDigLog[DigLogIndex][6]   += OP_EstdBm;
     SMMDtmfrx[PortNum].DtmfrxDigLog[DigLogIndex][7]  += 
					     DTMFRX_TALK_OFF_LIK_DIG_THR;
	 //---> Last  Detection FrameCnt.
     SMMDtmfrx[PortNum].DtmfrxDigLog[DigLogIndex][8]  =
				       SMMDtmfrx[PortNum].DtmfrxFrameCntr;

     //---> No of Different Digit Detections.
	 if(( SMMDtmfrx[PortNum].DtmfrxDigPrev != -1 )&&
		     ( SMMDtmfrx[PortNum].DtmfrxDigPrev != Dtmfrx_digit_det))
  {
		 SMMDtmfrx[PortNum].DtmfrxMaxDiffDigs += 1;
		 SMMDtmfrx[PortNum].DtmfrxDigPrev      = Dtmfrx_digit_det;
	 }

     if( SMMDtmfrx[PortNum].ToneOFF_2_ON == SMMDtmfrx[PortNum].ToneON_2_OFF  )
        SMMDtmfrx[PortNum].ToneOFF_2_ON += 1;

  }//----> End of IP_EstdBm <= Threshold
//----------------------------------------------------------------------------  
//----------------------------------------------------------------------------   
  else
      {
//----------------------------------------------------------------------------  
//----------------------------------------------------------------------------
   if( SMMDtmfrx[PortNum].ToneOFF_2_ON > SMMDtmfrx[PortNum].ToneON_2_OFF  )
     SMMDtmfrx[PortNum].ToneON_2_OFF += 1;
  }//--> End of Else of Tone -On Dig Log
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
  }//--> End of DtmfrxTone_on > 0.
/******************************************************************************
END OF LOG THE DIGIT PROPERTIES ON EVERY PROBABLE DIGIT DETECTION AFTER TONE ON
******************************************************************************/



#if 1
/******************************************************************************
                  DIGIT VALIDATION EVENT
******************************************************************************/
  if(Dtmfrx_r_dtmf == 1)
  {

//-----De bug Trap
	  if( SMMDtmfrx[PortNum].Dtmfrx_DtmfLikelyDig == 12 )
           SMMDtmfrx[PortNum].Dtmfrx_DtmfLikelyDig = 12;
//-----De bug Trap

		
	 Dtmfrx_digit_op = -1;
	 DtmfDetIndex    = -1;
         DtmfDetMaxCnt   =  0;


//-----------------------------------------------------------------------------
//                              DIAL_MODE
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
	  //---> Deafaults
//-----------------------------------------------------------------------------
	 MinEnePassOffset  =  2;
         TwistPassOffset   =  2;
         RowRelPassOffset  =  2;
         ColRelPassOffset  =  2;
         TalkoffPassOffset =  1;
         Tone_off_offset   =  1;
		 DtmfrxMaxDiffDigsThr         = 2;
		 DtmfNextProbableDigMaxCntThr = 1;
//-----------------------------------------------------------------------------
     if( SMMDtmfrx[PortNum].Dtmfrx_tone_on  <   3 )
	 {
	    Dtmfrx_r_dtmf   = 0;
	    DtmfrxResetDet(PortNum);
	    return; 
	 }
	 else if( SMMDtmfrx[PortNum].Dtmfrx_tone_on  ==  3 )
	 {
	    DtmfrxMinDetCnt     =  3;
	    DtmfrxMinAbsDetCnt  =  2;

	 }else if( SMMDtmfrx[PortNum].Dtmfrx_tone_on  == 4 )
	  {         
	     DtmfrxMinDetCnt     =  4;
	     DtmfrxMinAbsDetCnt  =  2;
	  }
	  else if( SMMDtmfrx[PortNum].Dtmfrx_tone_on  == 5 )
	  {
	     DtmfrxMinDetCnt     =  4;
	     DtmfrxMinAbsDetCnt  =  2;

	  }else if( SMMDtmfrx[PortNum].Dtmfrx_tone_on  == 6 )
	  {
             DtmfrxMinDetCnt     =  5;
	     DtmfrxMinAbsDetCnt   =  3;	
             RowRelPassOffset  =  3;
		
	  }else if(( SMMDtmfrx[PortNum].Dtmfrx_tone_on  > 6 )
		               &&( SMMDtmfrx[PortNum].Dtmfrx_tone_on  <= 20 ))
	  { 
	     DtmfrxMinDetCnt    =  SMMDtmfrx[PortNum].Dtmfrx_tone_on - 2;
             DtmfrxMinAbsDetCnt =  SMMDtmfrx[PortNum].Dtmfrx_tone_on - 4;
              RowRelPassOffset  =  3;

	  }else if( SMMDtmfrx[PortNum].Dtmfrx_tone_on  > 20 )
	  { 
	    DtmfrxMinDetCnt    =  SMMDtmfrx[PortNum].Dtmfrx_tone_on - 5;
            DtmfrxMinAbsDetCnt =  SMMDtmfrx[PortNum].Dtmfrx_tone_on - 9;	  
		
	    MinEnePassOffset  =  6;
            TwistPassOffset   =  3;
            RowRelPassOffset  =  3;
            ColRelPassOffset  =  3;
            TalkoffPassOffset =  6;
		
	    DtmfrxMaxDiffDigsThr         = 3;
	    DtmfNextProbableDigMaxCntThr = 3;
	  } 


//-----------------------------------------------------------------------------
//                              DIALING MODE
//-----------------------------------------------------------------------------	
		
   DtmfNextProbableDig  = -1;
   DtmfProbableDig      = -1;
   DtmfNextProbableDigMaxCnt = 0;
   DtmfDetMaxCnt = 0;
//-----------------------------------------------------------------------------
//                       SEARCH FOR PEAK PEFORMANCE DIGIT
//-----------------------------------------------------------------------------
  for( i = 0; i < DTMFRX_DIAL_PAD_LEN ; i++ )
     {
	if( SMMDtmfrx[PortNum].DtmfrxDigLog[i][0] >  DtmfDetMaxCnt )
     {
		DtmfNextProbableDig    = DtmfProbableDig;
        DtmfNextProbableDigMaxCnt = DtmfDetMaxCnt;
		DtmfProbableDig        = i;
        DtmfDetMaxCnt   =  SMMDtmfrx[PortNum].DtmfrxDigLog[i][0];

	}
     }
//-----------------------------------------------------------------------------
//                 SEARCH PEAK PEFORMANCE DIGIT
//-----------------------------------------------------------------------------



	  
  i = DtmfProbableDig;
//-----------------------------------------------------------------------------
//           DIGIT DETECTION TEST HARNESS 
//-----------------------------------------------------------------------------
  DtmfrxTestWord1  = 0;
  DtmfrxTempSum    = 0;

//1.--> 0x0001  --> Minimun Digit Detections Check.
  if( SMMDtmfrx[PortNum].DtmfrxDigLog[i][0] >= DtmfrxMinDetCnt )
	    DtmfrxTestWord1 += 0x0001;
       
//2.---> 0x0002     Min Absolute Detections Cnt. 
 if( SMMDtmfrx[PortNum].DtmfrxDigLog[i][1] >= DtmfrxMinAbsDetCnt   )
	  DtmfrxTestWord1 += 0x0002;

//3.---> 0x0004     Min Absolute Detections Cnt. 
 DtmfrxTempSum = SMMDtmfrx[PortNum].DtmfrxDigLog[i][2] + MinEnePassOffset;
 Temp16 = 2 * SMMDtmfrx[PortNum].DtmfrxDigLog[i][0];

 if( DtmfrxTempSum >= Temp16   )
	  DtmfrxTestWord1 += 0x0004;

//4.---> 0x0008   Twist Fails Check.
 DtmfrxTempSum =   SMMDtmfrx[PortNum].DtmfrxDigLog[i][3] + TwistPassOffset;
 if( SMMDtmfrx[PortNum].DtmfrxDigLog[i][0] <= DtmfrxTempSum   )
	  DtmfrxTestWord1 += 0x0008;

//5.---> 0x0010   Row Rel ratio Check.
 DtmfrxTempSum =   SMMDtmfrx[PortNum].DtmfrxDigLog[i][4] + RowRelPassOffset;
 if( SMMDtmfrx[PortNum].DtmfrxDigLog[i][0] <= DtmfrxTempSum   )
	  DtmfrxTestWord1 += 0x0010;

//6.---> 0x0020   Col Rel ratio Check
 DtmfrxTempSum =   SMMDtmfrx[PortNum].DtmfrxDigLog[i][5] + ColRelPassOffset;
 if( SMMDtmfrx[PortNum].DtmfrxDigLog[i][0] <= DtmfrxTempSum   )
	  DtmfrxTestWord1 += 0x0020;

//7. Talk off Check.-------------------0x0040
 DtmfrxTempSum =   SMMDtmfrx[PortNum].DtmfrxDigLog[i][6] + TalkoffPassOffset;
 if( SMMDtmfrx[PortNum].DtmfrxDigLog[i][7] <= DtmfrxTempSum   )
	  DtmfrxTestWord1 += 0x0040;

//8 Maximum Allowed Diff Digits Check----0x0080
  if ((SMMDtmfrx[PortNum].DtmfrxMaxDiffDigs  < DtmfrxMaxDiffDigsThr )
                &&(DtmfNextProbableDigMaxCnt < DtmfNextProbableDigMaxCntThr))
       DtmfrxTestWord1 += 0x0080;

//9. Maximum Allowed Tone_OFF_2_ON Check----0x0100
  if (SMMDtmfrx[PortNum].ToneOFF_2_ON  <=  1  )
       DtmfrxTestWord1 += 0x00100;

//10. Maximum Allowed Tone_ON_2_OFF Check.---0x0200
  if (SMMDtmfrx[PortNum].ToneON_2_OFF <=  1 )
       DtmfrxTestWord1 += 0x0200;
//-----------------------------------------------------------------------------
//       END OF DIGIT DETECTION TEST HARNESS 
//-----------------------------------------------------------------------------

    DtmfrxTestWord1 = DtmfrxTestWord1 & 0x02FF;   
	SMMDtmfrx[PortNum].Dtmfrx_digit_op   =   i;
	SMMDtmfrx[PortNum].DtmfrxTestResult =  DtmfrxTestWord1;
	  
  if( DtmfrxTestWord1 == 0x02FF )
  {              
    DtmfrxPassLog(PortNum);
  }else
  {
    DtmfrxFailLog(PortNum);
  }

  Dtmfrx_r_dtmf   = 0;
  DtmfrxResetDet(PortNum);

 }/*----End of if( r_dtmf == 1) condition----*/
/******************************************************************************
                  DIGIT VALIDATION EVENT
******************************************************************************/
#endif///---> End of #if (r_dtmf == 1) SWITCH.


#if 0 //ndef DTMFRX_SIMULATOR   // 4th Jan
     //DtmfrxFrameLog(PortNum);
     if((dtmfCliArg1 == 8192)&&((( dtmfCliArg2 == 2 )&&(PortNum == 0))
                                || (( dtmfCliArg2 == 3 )&&(PortNum == 1))))
    {
     HDSPDebugCmdQue[0] = SMMDtmfrxDSP2HostBuff[PortNum][1];
     HDSPDebugCmdQue[1] = SMMDtmfrxDSP2HostBuff[PortNum][2];
     HDSPDebugCmdQue[2] = SMMDtmfrxDSP2HostBuff[PortNum][3];
     HDSPDebugCmdQue[3] = SMMDtmfrxDSP2HostBuff[PortNum][4];
     HDSPDebugCmdQue[4] = SMMDtmfrxDSP2HostBuff[PortNum][5];
     HDSPDebugCmdQue[5] = SMMDtmfrxDSP2HostBuff[PortNum][6];
     HDSPDebugCmdQueWt(PortNum);
    }
#endif


#ifdef DTMFRX_CALL_FROM__APPLICATION
//-----------------------------ERROR REPORT:1------------------------
  WhileLoopErr++;
  if( WhileLoopErr > 100 )
  {
#ifdef HDTMFRX_LOG
    printf("L_E\r\n");
#endif
    WhileLoopErr = 0;
    break;
  }
//-----------------------------ERROR REPORT:1------------------------
 }//----> End of While Loop.
#endif

} /*---end of dig_det Function---*/
/********************************************************************************
                   END OF HOST DIGIT DETECTION
*****************************************************************************/


 /*****************************************************************************
                                DTMFRX_RESET
 *****************************************************************************/
 void DtmfrxResetDet(Word16 PortNum)
 {

	Word16 i,j;
	
	SMMDtmfrx[PortNum].DtmfrxFrame       =   0;
	SMMDtmfrx[PortNum].DtmfrxFrameCntr   =   0;	

	SMMDtmfrx[PortNum].Dtmfrx_tone_on    =   0;
        SMMDtmfrx[PortNum].Dtmfrx_tone_off   =   0;
	
	SMMDtmfrx[PortNum].ToneOFF_2_ON      =   0;
        SMMDtmfrx[PortNum].ToneON_2_OFF      =   0;
	
	SMMDtmfrx[PortNum].Dtmfrx_digit_op   =  -1;
	SMMDtmfrx[PortNum].DtmfrxDigPrev     =  -1;
	SMMDtmfrx[PortNum].DtmfrxMaxDiffDigs =   0;

	SMMDtmfrx[PortNum].DtmfrxTestResult  =   0;

	for ( i =0 ; i < DTMFRX_HISTORY_LEN ; i++ )
	{ 
		 SMMDtmfrx[PortNum].DtmfrxDigHistL[i]  =   0;
		 SMMDtmfrx[PortNum].DtmfrxEneHistL[i]  =   0;
		 SMMDtmfrx[PortNum].DtmfrxIpOpdBm[i]   =   0;

	}//--> End of DtmfrxHistoryLen.

        for( i = 0; i < DTMFRX_DIAL_PAD_LEN; i++ )
	{ 
		 for( j = 0; j < DTMFRX_PARAMTER_LEN; j++)
			   SMMDtmfrx[PortNum].DtmfrxDigLog[i][j] =  0;
	}
        
        SMMDtmfrx[PortNum].Dtmfrx_reset_on   =  1;
        
        //--------------------DTMF REJECTION
        SMMDtmfrx[PortNum].Dtmfrx_Rej_on     =  0; 
        SMMDtmfrx[PortNum].Dtmfrx_Rej_Flag   =  0;

#ifdef HDTMFRX_LOG
        printf("R_D:%d\r\n",PortNum);
#endif
}//--> End of reset_all.
/******************************************************************************
                          END OF DTMFRX_RESET
******************************************************************************/





#ifdef DTMFRX_CALL_FROM__APPLICATION
/******************************************************************************
                          DSP-IPC DTMFRX_READ
******************************************************************************/
 void DtmfrxIpcRead(Word16 PortNum)
 {

  Word16 TempIndex;

/******************************************************************************
				  QUE  NOT YET RESET
******************************************************************************/
   if( HDtmfrx_reset_on[PortNum] ==  0 )
   return;
/******************************************************************************
				  END OF  QUE  NOT YET RESET
******************************************************************************/

 //---> Do Frame Increment.
 DtmfrxHostFrame[PortNum] += 1;


/******************************************************************************
			    CHECK  THE DTMFRX_BANK PROPERTY FIELD
******************************************************************************/
  if( DtmfrxDSP2HostBuff[0] == DTMFRX_PACKET )
  { ///---> A valid Dtmfrx Packet in IPC BANK.
      
   if ( SMMDtmfrx[PortNum].DtmfrxQueInitCntr <  DSP2HOST_DTMFRX_QUE_LEN  )
   { 
	  //--> First  DSP2HOST_DTMFRX_QUE_LEN Write operations.
     TempIndex  =  SMMDtmfrx[PortNum].DtmfrxQueWtIndex;
     SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][1] = DtmfrxDSP2HostBuff[1];
     SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][2] = DtmfrxDSP2HostBuff[2];
     SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][3] = DtmfrxDSP2HostBuff[3];
     SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][4] = DtmfrxDSP2HostBuff[4];
     SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][5] = DtmfrxDSP2HostBuff[5];
     SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][6] = DtmfrxDSP2HostBuff[6];
	  
	  SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][7] = DtmfrxDSP2HostBuff[7];
      SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][8] = DtmfrxDSP2HostBuff[8];
     SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][0] = DTMFRX_PACKET;
     TempIndex++;
     TempIndex       =  TempIndex % DSP2HOST_DTMFRX_QUE_LEN; 
     SMMDtmfrx[PortNum].DtmfrxQueWtIndex = TempIndex;

     SMMDtmfrx[PortNum].DtmfrxQueInitCntr += 1;
      //--> End of first  DSP2HOST_DTMFRX_QUE_LEN Write operations.

    }else
    {
	  //--> Post- first  DSP2HOST_DTMFRX_QUE_LEN Write operations.
      TempIndex =  SMMDtmfrx[PortNum].DtmfrxQueWtIndex;
      if( (Word16)(SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][0]) == 
                                                    (Word16)DTMFRX_NULL_PACKET )      
      {  
        SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][1] = 
                                                          DtmfrxDSP2HostBuff[1];
	SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][2] = 
                                                          DtmfrxDSP2HostBuff[2];
	SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][3] = 
                                                          DtmfrxDSP2HostBuff[3];
	SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][4] = 
                                                          DtmfrxDSP2HostBuff[4];
	SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][5] = 
                                                          DtmfrxDSP2HostBuff[5];
	SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][6] = 
                                                          DtmfrxDSP2HostBuff[6];
		SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][7] = 
                                                        DtmfrxDSP2HostBuff[7];
        
	SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][8] = 
                                                        DtmfrxDSP2HostBuff[8];

	SMMDtmfrx[PortNum].DSP2HostDtmfrxQue[TempIndex][0] = DTMFRX_PACKET;
	TempIndex++;
        TempIndex   =  TempIndex % DSP2HOST_DTMFRX_QUE_LEN; 
	SMMDtmfrx[PortNum].DtmfrxQueWtIndex = TempIndex;
      }else
      { 
        ///----> Error report: No Free DtmfrxQue cell for  Write operation.
         SMMDtmfrx[PortNum].QueWtFailCntr  += 1;
	    //printf("\n ERROR REPORT : DTMFRX_QUE_OVER_FLOW \n");
      }      
    }//--> End of  post - first  DSP2HOST_DTMFRX_QUE_LEN Write operations.
    DtmfrxDSP2HostBuff[0] = DTMFRX_NULL_PACKET;
  }//--> End of non-null packet read at DSP-IPC
 }//--> end of DtmfrxIpcRead.
/********************************************************************************
                       END OF DSP-IPC DTMFRX_READ
*********************************************************************************/
#endif


/******************************************************************************
                        INIT  DSP-IPC DTMFRX_READ
******************************************************************************/
 void DtmfrxIpcInit(Word16 PortNum)
 {

  Word16 i;
  
  //---> DSP_IPC2Application_Queue -Init.
  SMMDtmfrx[PortNum].QueWtFailCntr     =  0;
  SMMDtmfrx[PortNum].DtmfrxQueInitCntr =  0;
  SMMDtmfrx[PortNum].DtmfrxQueRdIndex  =  0;
  SMMDtmfrx[PortNum].DtmfrxQueWtIndex  =  0;
  
  
  SMMDtmfrx[PortNum].DtmfrxSeqNum     =  0;
  
  //---> DSP2Host Buff Null Packet Init.
  //SMMDtmfrxDSP2HostBuff[PortNum][0] = DTMFRX_NULL_PACKET;
 
  //------> HostDtmfrx 2 IPC Dtmf Digit report Que.
  for ( i = 0; i < HDTMFRX_2_IPC_QUE_LEN; i++)
      HDtmfrx_2_IPC[PortNum][i] = -1;
  HDtmfrx_2_IPCRdIndex[PortNum]   = 0;
  HDtmfrx_2_IPCWtIndex[PortNum]   = 0;
  IPCDtmfrxSeqNum[PortNum]        = 0;

  //---> Reset Disable.
  HDtmfrx_reset_on[PortNum]            =  2;
  
  //--> Decision Logic State Machine.
  SMMDtmfrx[PortNum].Dtmfrx_reset_on   =  0;
  DtmfrxHostFrame[PortNum]             =  0;
#ifdef HDTMFRX_LOG
  printf("R_I:%d\n",PortNum);
#endif
//--------------------------------------------------------------------------
//--------------------------------------------------------------------------
 }
/******************************************************************************
                        INIT  DSP-IPC DTMFRX_READ
******************************************************************************/


/*****************************************************************************
                              DTMFRX_EARLY_RESET 
*****************************************************************************/
 void DtmfrxEarlyReset(Word16 PortNum)
 {

    Word16 i,j;    
    SMMDtmfrx[PortNum].DtmfrxFrame        =   0;
    SMMDtmfrx[PortNum].DtmfrxFrameCntr    =   0;	
    
    SMMDtmfrx[PortNum].DtmfrxDigPrev     =  -1;
    SMMDtmfrx[PortNum].DtmfrxMaxDiffDigs =   0;

    SMMDtmfrx[PortNum].Dtmfrx_tone_on     =   0;
    SMMDtmfrx[PortNum].Dtmfrx_tone_off    =   0;
	
    SMMDtmfrx[PortNum].ToneOFF_2_ON       =   0;
    SMMDtmfrx[PortNum].ToneON_2_OFF       =   0;

    SMMDtmfrx[PortNum].DtmfrxDigHistL[0]  =   0;
    SMMDtmfrx[PortNum].DtmfrxEneHistL[0]  =   0;
    SMMDtmfrx[PortNum].DtmfrxIpOpdBm[0]   =   0;

    for( i = 0; i < DTMFRX_DIAL_PAD_LEN; i++ )
    { 
       for( j = 0; j < DTMFRX_PARAMTER_LEN; j++)
	   SMMDtmfrx[PortNum].DtmfrxDigLog[i][j] =  0;
    }
    //--------------------DTMF REJECTION
    SMMDtmfrx[PortNum].Dtmfrx_Rej_on     =  0;
    SMMDtmfrx[PortNum].Dtmfrx_Rej_Flag   =  0;


 }
 /*****************************************************************************
                              DTMFRX_EARLY_RESET
 *****************************************************************************/






#ifndef  DTMFRX_SIMULATOR

/******************************************************************************
                            DTMFRX LOG ON EVERY FRAME
******************************************************************************/
#ifdef DTMFRX_FRAME_LOG
 void DtmfrxFrameLog(Word16 PortNum)
 { 

  if((dtmfCliArg1 == 8192)&&((( dtmfCliArg2 == 2 )&&(PortNum == 0))
                                || (( dtmfCliArg2 == 3 )&&(PortNum == 1))))
  {
     DSPDebugWd[0] = SMMDtmfrxDSP2HostBuff[PortNum][1];
     DSPDebugWd[1] = SMMDtmfrxDSP2HostBuff[PortNum][2];
     DSPDebugWd[2] = SMMDtmfrxDSP2HostBuff[PortNum][3];
     DSPDebugWd[3] = SMMDtmfrxDSP2HostBuff[PortNum][4];
     DSPDebugWd[4] = SMMDtmfrxDSP2HostBuff[PortNum][5];
     DSPDebugWd[5] = SMMDtmfrxDSP2HostBuff[PortNum][6];
     HDSPDebugDisplay(PortNum);
  }else

  return;
#if 0
   if (DtmfrxHostFrame[PortNum] >  50 )
   {
   //---> Bin Energies.   
   //printf("[%5d]\n",   DtmfrxHostFrame[PortNum]);
   //printf("[%4hx]",  SMMDtmfrx[PortNum].DtmfrxPrevTestResult);  
   //--> Frame Nu,ber
   //printf("[%4hx] ", DtmfrxDSP2HostBuff[1]); //--> ip/opdBm
   //printf("( %4hx ) ",SMMDtmfrx[PortNum].CurFrameTestResult );  
   //--> Digit Test Summary
   //printf("[%4x] ",(DtmfrxDSP2HostBuff[3]+ DtmfrxDSP2HostBuff[4])); 
   //--> Digit Energy.
   //printf("[%4x] ",DtmfrxDSP2HostBuff[3]);  //---> Row Max1
   //printf("[%4x] ",DtmfrxDSP2HostBuff[4]);  //---> Col Max1
   //printf("[%4x] ",DtmfrxDSP2HostBuff[5]);  //---> Rwo Max2
   //printf("[%4x] ",DtmfrxDSP2HostBuff[6]);  //---> Col Max2
     printf("\r\n([%4hx][%4hx][%4hx][%4hx][%4hx][%4hx])",DtmfrxDSP2HostBuff[1],
                                                         DtmfrxDSP2HostBuff[2],
                                                         DtmfrxDSP2HostBuff[3],
                                                         DtmfrxDSP2HostBuff[4],
                                                         DtmfrxDSP2HostBuff[5],
                                                         DtmfrxDSP2HostBuff[6]);   
   //printf("\r\n");
   DtmfrxHostFrame[PortNum] = 0;
 }
#endif
 }  
#endif
/******************************************************************************
                        END OF DTMFRX LOG ON EVERY FRAME
******************************************************************************/




/******************************************************************************
                            DIGIT PASS LOG
******************************************************************************/
#ifdef DTMFRX_PASS_LOG
 void DtmfrxPassLog(Word16 PortNum)
 {
   Word16 TempDig,Dig;
   CommandQ  DtmfrxCmdList[MAX_VOICE_CHANNELS];


//--------------------------------------------------------------------
   TempDig = SMMDtmfrx[PortNum].Dtmfrx_digit_op;
       Dig = TempDig;
//--> BoundaryChecking : Any Negative or Greater than 15 will be 
//discarded ---------------------------------------------------------
   if((TempDig < 0 )||(TempDig>15))
   return;
//--------------------------------------------------------------------



//--------------------------------------------------------------------
#ifdef FIRMWARE_CONF_VOIP_STACK_H323
//----> 4-Column Digits will be Discarded. Exept A and D for caller ID ----------------------------

     TempDig = TempDig % 4;
     if(TempDig == 3 )
     {
#if CALLER_IDTx
       if(( SMM_CidTx[PortNum].CidTxState != CID_TX_STATE1)&&
                                           (( Dig != 3)||(Dig != 15)))
       return; 
#endif
     }
#endif     
//--------------------------------------------------------------------  


#if 0
//--------------------------------------------------------------------
//------> update to HostDtmfrx 2 IPC Dtmf Digit report Que------------
//--------------------------------------------------------------------
   HDtmfrx_2_IPC[PortNum][HDtmfrx_2_IPCWtIndex[PortNum]] =
                                  SMMDtmfrx[PortNum].Dtmfrx_digit_op;
   
   HDtmfrx_2_IPCWtIndex[PortNum]   += 1;
   HDtmfrx_2_IPCWtIndex[PortNum]   =
               HDtmfrx_2_IPCWtIndex[PortNum]%HDTMFRX_2_IPC_QUE_LEN;
//--------------------------------------------------------------------
//------> End Report Application.-------------------------------------- 
//--------------------------------------------------------------------
#else 
//--------------------------------------------------------------------
//------> update to HostDtmfrx 2 IPC Dtmf Digit report Que------------
//--------------------------------------------------------------------
   DtmfrxCmdList[PortNum].command[0] = D2H_DTMF_DIGIT_REPORT;
   DtmfrxCmdList[PortNum].command[2] = IPCDtmfrxSeqNum[PortNum];
   DtmfrxCmdList[PortNum].command[3] = SMMDtmfrx[PortNum].Dtmfrx_digit_op;
   DtmfrxCmdList[PortNum].command[4] = SMMDtmfrx[PortNum].ToneLevel;

   if( SMMDtmfrx[PortNum].Dtmfrx_tone_on > 6553 )
     DtmfrxCmdList[PortNum].command[5] = 65530; //in ms
   else if( SMMDtmfrx[PortNum].Dtmfrx_tone_on < 4 )
     DtmfrxCmdList[PortNum].command[5] = 40;//in ms
   else
     DtmfrxCmdList[PortNum].command[5] = 10 * SMMDtmfrx[PortNum].Dtmfrx_tone_on;

   IPCDtmfrxSeqNum[PortNum]      += 1;
   dspipcCmdIntrpret(&DtmfrxCmdList[PortNum], PortNum);
//--------------------------------------------------------------------
//------> End Report Application.-------------------------------------- 
//--------------------------------------------------------------------
#endif




   //printf("\r\n[%hx]",SMMDtmfrx[PortNum].Dtmfrx_digit_op);
   //printf("\r\nDD:[%hx][%hx]",SMMDtmfrx[PortNum].Dtmfrx_digit_op,PortNum);


#ifdef HDTMFRX_LOG
   printf("\r\n[%4hx]DD:[%4hx][%5d]\n",SMMDtmfrx[PortNum].DtmfrxTestResult,
      SMMDtmfrx[PortNum].Dtmfrx_digit_op,SMMDtmfrx[PortNum].DtmfrxFrame);
 
   for( i= 0; i < SMMDtmfrx[PortNum].DtmfrxFrame; i++ ) 
   { 
	   
	   //printf("%4hx      ",SMMDtmfrx[PortNum].DtmfrxTestResult);
	   //printf("%4hx      ",SMMDtmfrx[PortNum].DtmfrxIpOpdBm[i]);
	     printf("\r\n[%4hx]",SMMDtmfrx[PortNum].DtmfrxDigHistL[i]);
	   //printf("[%5d]     ",SMMDtmfrx[PortNum].DtmfrxEneHistL[i]);

	   //printf("[%5d]     ",SMMDtmfrx[PortNum].DtmfrxRowMax1[i]);
	   //printf("[%5d]     ",SMMDtmfrx[PortNum].DtmfrxColMax1[i]);
	   //printf("[%5d]     ",SMMDtmfrx[PortNum].DtmfrxRowMax2[i]);
   	   //printf("[%5d]     ",SMMDtmfrx[PortNum].DtmfrxColMax2[i]);
       //printf("\n");
   }//--. End of for Loop.
#endif
}//-->End of PassLogFunction.
#endif
/******************************************************************************
                         END OF DIGIT PASS LOG
******************************************************************************/


/******************************************************************************
                            DIGIT FAIL LOG
******************************************************************************/
 void DtmfrxFailLog(Word16 PortNum)
 {
   
#ifdef DTMFRX_FAIL_LOG
   Word16 PassFlag =0;
#endif

   if( SMMDtmfrx[PortNum].Dtmfrx_Rej_Flag   ==  1)
//      dspipcQuitDtmfRej(PortNum);
     dspipcResetDtmfRejHangOver(PortNum);
  
#ifdef DTMFRX_FAIL_LOG

#if 1
   printf("\r\n[%4hx]DF:[%5d]\n",SMMDtmfrx[PortNum].DtmfrxTestResult,
                                              SMMDtmfrx[PortNum].DtmfrxFrame);
#endif

   
#if 0
   printf("\nDigFail:[%4hx]....[%5d]\n", DtmfrxHostFrame[PortNum], 
	                              SMMDtmfrx[PortNum].DtmfrxFrame);
#endif

   for( i= 0; i < SMMDtmfrx[PortNum].DtmfrxFrame; i++ )
   { 	   
	   //printf("%4hx      ",SMMDtmfrx[PortNum].DtmfrxTestResult);
	   //printf("[%4hx]",SMMDtmfrx[PortNum].DtmfrxIpOpdBm[i]);
	     printf("\r\n[%4hx]",SMMDtmfrx[PortNum].DtmfrxDigHistL[i]);
      //printf("[%4hx]",SMMDtmfrx[PortNum].DtmfrxIpOpdBm[i]);            
       // printf("[%4hx]",SMMDtmfrx[PortNum].DtmfrxSeqHist[i]);

	     //printf("[%5d]",SMMDtmfrx[PortNum].DtmfrxEneHistL[i]);

	     //printf("[%5d]",SMMDtmfrx[PortNum].DtmfrxRowMax1[i]);
	     //printf("[%5d]",SMMDtmfrx[PortNum].DtmfrxColMax1[i]);
	     //printf("[%5d]",SMMDtmfrx[PortNum].DtmfrxRowMax2[i]);
	     //printf("[%5d]",SMMDtmfrx[PortNum].DtmfrxColMax2[i]);
	     //printf("\n");
   }   

   //FailCnt++;
#endif
 }  
/******************************************************************************
                            END OF DIGIT FAIL LOG
******************************************************************************/
#endif
