
/* 
 DtmfrxVar.c
 sivan.nagireddi@analog.com
*/


//>>>>>>------------------------------------------------------->>>>>>
//#define DTMFRX_SIMULATOR
//>>>>>>------------------------------------------------------->>>>>>


#ifdef DTMFRX_SIMULATOR 
  #include "typedef.h"
  #include "HDtmfrxConst.h"
  #include "HDtmfrxVar.h"
  #define MAX_VOICE_CHANNELS  MAX_CHAN
#else
#include <oswrapper.h>
  #include <HDtmfrxVar.h>
#endif

#if 1
//---->  90dB is Maximum for 4096 + 4096 --> 6.17  - 9dB of Twist Accounted.
Word16  DtmfrxThr[11][6] = {
	                          {  90,  90, 4,   5,  6, 6},  //[0]:[  0  &-3dBm ]
				  {  90,  90, 4,   5,  6, 6},  //[1]:[ -3  &-6dBm ]
				  {  87,  87, 4,   5,  5, 5},  //[2]:[ -6  &-9dBm ]

                                  {  84, 84,  4,   4,  5, 5},  //[3]:[-9  & -12dBm]
	        		  {  81, 81,  4,   4,  5, 5},  //[4]:[-12  &-15dBm]
				  {  78, 78,  4,   4,  5, 5},  //[5]:[-15  &-18dBm]

							  { 75, 75,   3,   4,  5, 5},  //[6]:[-18  &-21dBm]
							  { 72, 72,   2,   3,  5, 5},  //[7]:[-21  &-24dBm]
                              { 72, 72,   2,   3,  4, 5},  //[8]:[-24  &-27dBm]

							  { 69, 69,   2,   2,  4, 5},  //[9]:[-27  &-27dBm]
					          { 69, 69,   2,   2,  4, 5},  //[10]:[-30  &-30dBm]

		  };//---> end of DtmfrxThr.

#else
//---->  90dB is Maximum for 4096 + 4096 --> 6.17  - 9dB of Twist Accounted.
Word16  DtmfrxThr[11][3] = {  
	                          {  75,  75, 4 },  //[0]:[  0  &-3dBm ]
							  {  72,  72, 4 },  //[1]:[ -3  &-6dBm ]
							  {  69,  69, 4 },  //[2]:[ -6  &-9dBm ]

                              {  63, 63, 5 },  //[3]:[-9  & -12dBm]
							  {  60, 60, 5 },  //[4]:[-12  &-15dBm]
							  {  57, 57, 5 },  //[5]:[-15  &-18dBm]

							  { 54, 54, 5 },  //[6]:[-18  &-21dBm]
							  { 51, 51, 4 },  //[7]:[-21  &-24dBm]
                              { 48, 48, 4  },  //[8]:[-24  &-27dBm]
							  { 45, 45, 4 },  //[9]:[-27  &-27dBm]
					          { 45, 45, 4 },  //[10]:[-30  &-30dBm]

		  };//---> end of DtmfrxThr.
#endif
/******************************************************************************
                      BAORD VERSION.
******************************************************************************/
DtmfrxDataSt_  SMMDtmfrx[MAX_VOICE_CHANNELS];
Word16  HDtmfrx_reset_on[MAX_VOICE_CHANNELS] = {0};
uWord16 DtmfrxHostFrame[MAX_VOICE_CHANNELS] = {0};
uWord16 SMMDtmfrxDSP2HostBuff[MAX_VOICE_CHANNELS][DTMFRX_DSP2HOST_BUFF_LEN];

Word16  HDtmfrx_2_IPC[MAX_VOICE_CHANNELS][HDTMFRX_2_IPC_QUE_LEN];
Word16  HDtmfrx_2_IPCRdIndex[MAX_VOICE_CHANNELS];
Word16  HDtmfrx_2_IPCWtIndex[MAX_VOICE_CHANNELS];
uWord16 IPCDtmfrxSeqNum[MAX_VOICE_CHANNELS];


#ifndef DTMFRX_SIMULATOR 
Word16 Q15mult(Word16 var1, Word16 var2);
#if !G711_PLC 
Word16 sature(Word32 L_var1);
Word16 extract_l(Word32 L_var1);
#else
extern Word16 sature(Word32 L_var1);
#endif
/*___________________________________________________________________________
 |                                                                           |
 | Basics operators.                                                         |
 | sivan.nagireddi@analog.com                                                |
 |___________________________________________________________________________|
*/

/*___________________________________________________________________________
 |                                                                           |
 |   Include-Files                                                           |
 |___________________________________________________________________________|
*/

#define MAX_32 (Word32)0x7fffffffL
#define MIN_32 (Word32)0x80000000L

#define MAX_16 (Word16)0x7fff
#define MIN_16 (Word16)0x8000

/*___________________________________________________________________________
 |                                                                           |
 |   Function Name : mult                                                    |
 |                                                                           |
 |   Purpose :                                                               |
 |                                                                           |
 |    Performs the multiplication of var1 by var2 and gives a 16 bit result  |
 |    which is scaled i.e.:                                                  |
 |             mult(var1,var2) = shr((var1 times var2),15) and               |
 |             mult(-32768,-32768) = 32767.                                  |
 |                                                                           |
 |   Complexity weight : 1                                                   |
 |                                                                           |
 |   Inputs :                                                                |
 |                                                                           |
 |    var1                                                                   |
 |             16 bit short signed integer (Word16) whose value falls in the |
 |             range : 0xffff 8000 <= var1 <= 0x0000 7fff.                   |
 |                                                                           |
 |    var2                                                                   |
 |             16 bit short signed integer (Word16) whose value falls in the |
 |             range : 0xffff 8000 <= var1 <= 0x0000 7fff.                   |
 |                                                                           |
 |   Outputs :                                                               |
 |                                                                           |
 |    none                                                                   |
 |                                                                           |
 |   Return Value :                                                          |
 |                                                                           |
 |    var_out                                                                |
 |             16 bit short signed integer (Word16) whose value falls in the |
 |             range : 0xffff 8000 <= var_out <= 0x0000 7fff.                |
 |___________________________________________________________________________|
*/

Word16 Q15mult(Word16 var1, Word16 var2)
  {
   Word16 var_out;
   Word32 L_produit;

   L_produit = (Word32)var1 * (Word32)var2;

   L_produit = (L_produit & (Word32) 0xffff8000L) >> 15;

   if (L_produit & (Word32) 0x00010000L)
     L_produit = L_produit | (Word32) 0xffff0000L;

   var_out = sature(L_produit);
   return(var_out);
  }

#if !G711_PLC 
  /*___________________________________________________________________________
 |                                                                           |
 |   Function Name : sature                                                  |
 |                                                                           |
 |   Purpose :                                                               |
 |                                                                           |
 |    Limit the 32 bit input to the range of a 16 bit word.                  |
 |                                                                           |
 |   Inputs :                                                                |
 |                                                                           |
 |    L_var1                                                                 |
 |             32 bit long signed integer (Word32) whose value falls in the  |
 |             range : 0x8000 0000 <= L_var1 <= 0x7fff ffff.                 |
 |                                                                           |
 |   Outputs :                                                               |
 |                                                                           |
 |    none                                                                   |
 |                                                                           |
 |   Return Value :                                                          |
 |                                                                           |
 |    var_out                                                                |
 |             16 bit short signed integer (Word16) whose value falls in the |
 |             range : 0xffff 8000 <= var_out <= 0x0000 7fff.                |
 |___________________________________________________________________________|
*/

Word16 sature(Word32 L_var1)
  {
   Word16 var_out;

   if (L_var1 > 0X00007fffL)
     {
      //Overflow = 1;
      var_out = MAX_16;
     }
   else if (L_var1 < (Word32)0xffff8000L)
     {
      //Overflow = 1;
      var_out = MIN_16;
     }
   else
     {
      //Overflow = 0;
      var_out = extract_l(L_var1);
     }

   return(var_out);
  }


  /*___________________________________________________________________________
 |                                                                           |
 |   Function Name : extract_l                                               |
 |                                                                           |
 |   Purpose :                                                               |
 |                                                                           |
 |   Return the 16 LSB of L_var1.                                            |
 |                                                                           |
 |   Complexity weight : 1                                                   |
 |                                                                           |
 |   Inputs :                                                                |
 |                                                                           |
 |    L_var1                                                                 |
 |             32 bit long signed integer (Word32 ) whose value falls in the |
 |             range : 0x8000 0000 <= L_var1 <= 0x7fff ffff.                 |
 |                                                                           |
 |   Outputs :                                                               |
 |                                                                           |
 |    none                                                                   |
 |                                                                           |
 |   Return Value :                                                          |
 |                                                                           |
 |    var_out                                                                |
 |             16 bit short signed integer (Word16) whose value falls in the |
 |             range : 0xffff 8000 <= var_out <= 0x0000 7fff.                |
 |___________________________________________________________________________|
*/

Word16 extract_l(Word32 L_var1)
  {
   Word16 var_out;

   var_out = (Word16) L_var1;
   return(var_out);
  }
/******************************************************************************
                      END OF BAORD VERSION.
******************************************************************************/
#endif
#endif



