/***************************************************************************
File Name    :JitMain.c
Company      :Analog Devices
Authors      :sivan.nagireddi@analog.com &rajakumar.kulakarni@analog.com.
Description  :AJB Module.
BuildLog"file:saie-d01//c:\E-folder\Projects\Jitter\AJBVer3\Debug\BuildLog.htm"
AJBVer3 - 0 error(s), 0 warning(s)
----------------------------------------------------------------------------
Log :
Ver @ 1.0 Initial Version.
Date :              : 10/Aug/2002
1.Delay Tracking Events Added in JitPutPkt function& DelayEst Function.
2.WtDist Initialization was done.
3.ExpReadSeq made it usage than ExpSeqNum in JitPutPkt
4.While(1) Loop kept inside a RdJitBuffer() wrong seq case and No 
   Packet case are changed with break instead of return.
5.Protection Logic embedded in all infinity loops.
----------------------------------------------------------------------------
----------------------------------------------------------------------------
Date :              :  9/Aug/2004
Ver @ 1.1 revision -1
1. Spike Detection method  adopted in  Delay Estimation Module.
2. Gap-based Delay Tracking mechanisim incorporated.
3. Jit Write context Packet flooding handled.
4. Huge Memory Initializations simplified.
5. Demodulerized: Delay Tracking/JitPut/JistStatics.
6. PlayTable was replaced with List.
7. Duplicate packet History Build and checking was added.
8. Worst Delay hits support.
9. DebugTracing-Added.
----------------------------------------------------------------------------

----------------------------------------------------------------------------
Date :              :  19/Jan/2005
Ver @ 2 revision -1
----------------------------------------------------------------------------
0.Configurable Different Read rate support.
1.G726Codec - Support added.
2.CLI added for most of Tuning Parameters.
3.AJB- History statistic log increased up to Minutes.
4.optimization Code and orgnized few properties for scalblity of codecs.
5.Basic Access Services-non-QOS operated network worst cases Tuning.
6.Log the History of - Late/DelayT/Nulls play out events Frequency.
7.AJB -Config Srm Store/Restore feature.
8.AJBRdWtCLI- Config and Display parameter options.
9. rfc 3611 VQ monitoring Parameters :
    9.1.Incorparated the Markov4-StateModel for Burust/Gap density and 
	    length estimations.~ETSI-TS 101 329-5
    9.2.R -Model Estimations for Ie and Id.
	9.3.MOS-Listener Quality and Conversastional Quality Estimates.
***************************************************************************/

#include <oswrapper.h>
#include <voice_bitmap.h>
#ifndef AJB_SIMULATION
#ifdef CALLER_IDTx
 extern CidTxType_  SMM_CidTx[MAX_VOICE_CHANNELS];
 extern UCHAR ucCallerIdIntrHandler[];
 extern UCHAR ucG7115msIntrFlag[];
#include<slicapi.h>
#endif
#else
#include "JitCons.h"
#include "JitProto.h"
#endif

#if DRV_DEBUG_STAT
extern VoiceDebugStat_t VoiceDebugStat[];
#endif
extern uWord16   AJB_MIN_DELAY_MS[MAX_VOICE_CHANNELS];
UCHAR   ucJitterBuffType[MAX_VOICE_CHANNELS];

uWord16  AJBResetFlag[MAX_VOICE_CHANNELS]={0};
Word16   AJB_ISR_SCHEDULER_DURATION[MAX_VOICE_CHANNELS];

Word16   AJB_ISR_SCHEDULER_TABLE[2][6] = { 
{
  //----> 5ms Isr.
 G711_READ_SKIP_CNTR_5MS_ISR,G729_READ_SKIP_CNTR_5MS_ISR, G723_READ_SKIP_CNTR_5MS_ISR,
 G711_READ_REP_CNTR_5MS_ISR, G729_READ_REP_CNTR_5MS_ISR,  G723_READ_REP_CNTR_5MS_ISR
},
{
  //-----> 10ms Isr-Codec Attributes
 G711_READ_SKIP_CNTR_10MS_ISR, G729_READ_SKIP_CNTR_10MS_ISR,G723_READ_SKIP_CNTR_10MS_ISR,
 G711_READ_REP_CNTR_10MS_ISR,  G729_READ_REP_CNTR_10MS_ISR, G723_READ_REP_CNTR_10MS_ISR
}
};//--> End of AJB Isr Scheduler Tabel.


//--> Jitter Buffer Main Data Structure 
JitBuffType_  SMMJitBuff[MAX_VOICE_CHANNELS];

//-> RTP pkt Array & Memory Bitmap
RtpPktType_   JitBuff[MAX_VOICE_CHANNELS][JITBUFF_MAX_LEN];
UCHAR         JitBuffBitmap[MAX_VOICE_CHANNELS][BitmapSize(JITBUFF_MAX_LEN)];

//--> Voice PayLoad Buffer.
RTPPayLoadPktType_ JitPkt[MAX_VOICE_CHANNELS][JITBUFF_MAX_LEN];
UCHAR JitCellBitmap[MAX_VOICE_CHANNELS][BitmapSize(JITBUFF_MAX_LEN)];

//---> JitHistBuffer for Duplicate Packet Tests 
uWord16 JitQue[MAX_VOICE_CHANNELS][JITBUFF_MAX_LEN];


//---------------------------------------------------------------------
//---> Delay of AJB in terms of primary packet Cnt.
uWord16   AJB_READ_THRESHOLD[MAX_VOICE_CHANNELS];
//---------------------------------------------------------------------


//------------Allowed Max No of   Packet drops per one entry-----------
extern uWord16   AJB_TOTAL_PKTS_PER_SLOT[MAX_VOICE_CHANNELS];
//---------------------------------------------------------------------


Markov4StateType_  Markov4Data[MAX_VOICE_CHANNELS];
VQMonRtcpXR_Type_  VQMonRtcpXR_Data[MAX_VOICE_CHANNELS];

#if AJB_USE_CLI_CONFIGURATIONS
uWord32  AJB_WRITE_CNTR[MAX_VOICE_CHANNELS];
uWord32  AJB_READ_CNTR[MAX_VOICE_CHANNELS];
#endif

#if AJB_RTP_DUPLICATE_CHECK_ENABLED
uWord16 JitHistTab[MAX_VOICE_CHANNELS][JIT_HIST_BUFF_MAX_LEN];
#endif

inline void ReleaseRTPPkt(uWord16 PortNum, uWord16 TabWtIndex);
inline void ReleaseRTPCell(uWord16 PortNum, uWord16 CellIndex);

/********************************************************************
* Function         : WtJitBuffer()                                  *
* I/P Parameters   : RdVoicePkt* RdVoicePktPtr                      *
* O/P Parameters   : NONE                                           *
* Return Values    : NONE                                           *
* Description      : This function contains implementation of the   *
*   Jitter Buffer Write .                                           *
*   JIT_WT_ERROR REPORTS                                            *
*   0. WT_RST : %d --> ErrNum.                                      *
*          : ( SMMJitBuff[PortNum].WtErrFlag | 0x0001)              *
*   1. WT0   : FrameCntr and FrameMS initialization error.          *
*           ( SMMJitBuff[PortNum].WtErrFlag | 0x0002);              *
*   2. WT1   : No Free Rtp cells, drop the wtjit entered packet.    *
*         : ( SMMJitBuff[PortNum].WtErrFlag | 0x0004)               *
*   3. WT2   : No Free payload cell, drop the wtJit enetered packet *
*         :  ( SMMJitBuff[PortNum].WtErrFlag | 0x0008);             *
*   4. WT_G711_FLE[%d]",CurFillLen , No proper FramLen.             *
*         :  ( SMMJitBuff[PortNum].WtErrFlag | 0x0010);             *
*   5. WT_G729_FLE                                                  *
*         :  ( SMMJitBuff[PortNum].WtErrFlag | 0x0020);             *
*   6. AJB_G723_BAD_Pkt                                             *
*         :  ( SMMJitBuff[PortNum].WtErrFlag | 0x0040);             *
*   7. WT_G723_FLE                                                  *
*         :   ( SMMJitBuff[PortNum].WtErrFlag | 0x0080)             *
*   8.No Match for CODEC enum.                                      *
*         :   ( SMMJitBuff[PortNum].WtErrFlag | 0x0100);            *
*   9. WT3   :   JIT_WT_INF_LOOP_NOT_SAFE1                          *
*   10.WT4  : OverFlow List got OverFlow, Drop the oldest Packet.   *
*          ( SMMJitBuff[PortNum].WtErrFlag | 0x0400);               *
*   11.WT_QF : Que is Full.                                         *
*         : ( SMMJitBuff[PortNum].WtErrFlag | 0x0800);              *
*   12.WT5 : No enough rtp cells available to move OF buffer to Que.*
*       : ( SMMJitBuff[PortNum].WtErrFlag | 0x1000);                *
*   13.WT6 : No enough payload cells available to move OF buffer    *
*   to Que. ( SMMJitBuff[PortNum].WtErrFlag | 0x2000);              *
*   14.WT7 : while(1) Loop break in Overflow list to Que copy.      *
*   15. WT_DUP :                                                    *
*    Duplicate Drop.                                                *
*        :   ( SMMJitBuff[PortNum].WtErrFlag | 0x8000)              *
********************************************************************/
void WtJitBuffer(WtRtpPktType_ *WtRTPPkt , 
                 uWord16 PortNum , 
		 UCHAR  *pVoicePayload)
{	
  Word16 TabWtIndex,QueWtIndex;
  uWord16 OFListTop;
  uWord16 CurIndex;
  uWord16 PreIndex = 0;
  Word16 SeqNumDiff;

#if AJB_USE_CLI_CONFIGURATIONS
  /* TO KNOW THE WRITE IS ACTIVE or INACTIVE */
  AJB_WRITE_CNTR[PortNum] +=1;
#endif

  /* AJB -ISR TIMING SET FLAG CHECK */
  if( AJBResetFlag[PortNum] == 0 )
    return; /* This is the case when application has reset the AJB and 
               not accepting the packets to be written to DSP */

#ifdef AJB_RESET
  /********************************************************************
               TRACK - JITTER BUFFER ILL CONDITIONS.
  ********************************************************************/
  if(SMMJitBuff[PortNum].Reset == 1)
  {
    SMMJitBuff[PortNum].JitInitFlag = 0; //--> RESET THE JITTER BUFFER.	
#if AJB_ENABLE_STATISTICS
    SMMJitBuff[PortNum].WtErrFlag = ( SMMJitBuff[PortNum].WtErrFlag | 0x0001);
#endif
  }
#endif
  /********************************************************************
                READING A BASIC FRAME LENGTH 
  ********************************************************************/
  if(SMMJitBuff[PortNum].JitInitFlag == 0)
  {
    if(AJBInit(PortNum,WtRTPPkt) != 0)
      return;
  }


  /********************************************************************
           PacketArrivalCounterFor Debugging
  ********************************************************************/
  SMMJitBuff[PortNum].WtPktCnt += SMMJitBuff[PortNum].RxFrameCntr;

  if((TabWtIndex  = AJBEnqPkt(WtRTPPkt,PortNum,pVoicePayload)) ==  FAILURE)
     return;

#ifdef JIT_DELAY_ESTIMATION
  /****************************************************************
                      DELAY ESTIMATION 
  ****************************************************************/ 
  if( SMMJitBuff[PortNum].ResetDelayEstTimer >= 
                          DEF_AJB_RESET_DELAY_EST_MODULE_TIME )
     ResetDelayEst(( WtRtpPktType_ *)WtRTPPkt , PortNum);
  if(ucJitterBuffType[PortNum] == AJB )
    JitDelayEst(( WtRtpPktType_ *) WtRTPPkt, PortNum);
#endif


  //---> 1.1.CASE -List is empty.
  /* List is free, Append on Top. */
  OFListTop   =  SMMJitBuff[PortNum].OFListTop;

  if(OFListTop == JIT_IND_NULL )
  {
    //---> Set on List Top.
    SMMJitBuff[PortNum].OFListTop = TabWtIndex;
    SMMJitBuff[PortNum].OFCellMarkCnt    +=  JitBuff[PortNum][TabWtIndex].PktCnt;
    SMMJitBuff[PortNum].OFRtpMarkCnt     +=  1;
  }
  else
  { 
    /* Look for the current node on the top of the List. */
    /* We need to find the place to insert this node into the list at
       increasing order of the sequence number. */
    CurIndex  =  OFListTop;
    PreIndex  =  JIT_IND_NULL;    
    
    while(CurIndex !=  JIT_IND_NULL)
    {
      SeqNumDiff =  WtRTPPkt->SeqNum - JitBuff[PortNum][CurIndex].SeqNum;
      if(SeqNumDiff <= 0)
        break;
      PreIndex = CurIndex;
      CurIndex = JitBuff[PortNum][CurIndex].NextIndex;
    }

    if(CurIndex == JIT_IND_NULL)
    {
      /* We could not find the place in increasing order, add to the
         tail of the list */
      JitBuff[PortNum][PreIndex].NextIndex = TabWtIndex;
      SMMJitBuff[PortNum].OFCellMarkCnt  += JitBuff[PortNum][TabWtIndex].PktCnt;
      JitBuff[PortNum][TabWtIndex].NextIndex = JIT_IND_NULL;
      SMMJitBuff[PortNum].OFRtpMarkCnt     +=  1;
    }
    else 
    {
#if DRV_DEBUG_STAT
       VoiceDebugStat[PortNum].ajbOutofOrder++;
#endif
      if(JitBuff[PortNum][CurIndex].SeqNum == WtRTPPkt->SeqNum)
      {
        /* Ideally it would not happen as it will be either dropped
        at RTP level OR at the upper block , where we check for
        duplicate packets. */
#if AJB_ENABLE_STATISTICS
        SMMJitBuff[PortNum].WtDupDropCnt  +=  JitBuff[PortNum][TabWtIndex].PktCnt;
        SMMJitBuff[PortNum].WtErrFlag = ( SMMJitBuff[PortNum].WtErrFlag | 0x0200);
#endif
#ifdef AJB_DEBUG
        printk("Duplicate Pkt Entered\n");
#endif
        JitFreeMem(TabWtIndex,PortNum);
        return ;
      }
      /* We have got the node to add */
      else if(CurIndex == OFListTop)
      {
        /* Move the OFListTop pointer to the current one */
        SMMJitBuff[PortNum].OFListTop = TabWtIndex;
        JitBuff[PortNum][TabWtIndex].NextIndex = OFListTop;
        SMMJitBuff[PortNum].OFCellMarkCnt    += JitBuff[PortNum][TabWtIndex].PktCnt;
        SMMJitBuff[PortNum].OFRtpMarkCnt      +=  1;
      }
      else
      {
        JitBuff[PortNum][PreIndex].NextIndex   =  TabWtIndex;
        JitBuff[PortNum][TabWtIndex].NextIndex =  CurIndex;
        SMMJitBuff[PortNum].OFCellMarkCnt     +=  JitBuff[PortNum][TabWtIndex].PktCnt;
        SMMJitBuff[PortNum].OFRtpMarkCnt      +=  1;
      }    
    }
  }
  /* Look for the Overflow */
  if(SMMJitBuff[PortNum].OFCellMarkCnt  > JIT_OF_MAX_CELL_MARK)
  {
    /* Drop the packet from the top, it is the oldest packet
       received . */
    OFListTop = SMMJitBuff[PortNum].OFListTop;
    SMMJitBuff[PortNum].OFListTop = JitBuff[PortNum][OFListTop].NextIndex;
    SMMJitBuff[PortNum].OFCellMarkCnt -= JitBuff[PortNum][OFListTop].PktCnt;
    SMMJitBuff[PortNum].OFRtpMarkCnt  -=  1;
#if AJB_ENABLE_STATISTICS
    SMMJitBuff[PortNum].WtOFDropCnt +=  JitBuff[PortNum][OFListTop].PktCnt;
    SMMJitBuff[PortNum].WtErrFlag = ( SMMJitBuff[PortNum].WtErrFlag | 0x0400);
#endif
#ifdef AJB_DEBUG
    printk("Overflow is happening \n");
#endif
    JitFreeMem(OFListTop,PortNum);
  }
      
  /********************************************************************
                   JIT WT STATE -3.
   if( freeMemINQue && freeMemFORrtpPkts && freeMemFORcells  )
     3.1.Remove The pkt on OFListTop and update Top.
     3.2.Write into queue and update Que.

   This is the place where AJB puts the packet to the READ list .
  ********************************************************************/
 
  while(1)
  {
    //---> If List is emty/-No packet in List to update the Que Return.
    if( SMMJitBuff[PortNum].OFListTop == JIT_IND_NULL )
      break; 

    /*****************************************************************
      1. Look for free Que index.
    *****************************************************************/
    QueWtIndex = (SMMJitBuff[PortNum].QueWtIndex + 1 ) % JIT_QUE_MAX_LEN;
    if(QueWtIndex == SMMJitBuff[PortNum].QueRdIndex)
    {
#ifdef AJB_DEBUG
      printk("QueWtIndex should not happen \n");
#endif
      break;  //---> No Empty que Pointer available.
    }

    /* We need to maintain minimum number of packets to the write in 
       order to avoid dropping VAD packets or newly added packlets */
    /******************************************************************
       2. Look for free rtp cell
    ******************************************************************/
    if(SMMJitBuff[PortNum].FreeRtpCnt <= 
     (( JIT_OF_MAX_CELL_MARK + 1 ) - SMMJitBuff[PortNum].OFRtpMarkCnt))
    {
#if AJB_ENABLE_STATISTICS
      SMMJitBuff[PortNum].WtErrFlag = 
                             (SMMJitBuff[PortNum].WtErrFlag | 0x1000);
#endif
#ifdef AJB_DEBUG
      printk(".FreeRtpCnt should not happen \n");
#endif
      break;
    }

    /*****************************************************************
      3. Look for free PayLoad cell
    *****************************************************************/
    if(SMMJitBuff[PortNum].FreeCellCnt <= 
     ((JIT_OF_MAX_CELL_MARK + JIT_MAX_FRAMES) - 
                          SMMJitBuff[PortNum].OFCellMarkCnt))
    {
#if AJB_ENABLE_STATISTICS
      SMMJitBuff[PortNum].WtErrFlag = 
                             (SMMJitBuff[PortNum].WtErrFlag | 0x2000);
#endif
      break; //---> No Empty Cell packets available.
#ifdef AJB_DEBUG
      printk(".FreeCellCnt should not happen \n");
#endif
    }

    /****************************************************************
                       QUEUE   WRITE
     Packet is available -Free que/rtp /cells available to 
     send on Queue.
     1. Remove the ListTop and update ListTop.
     2. Add the removed ListTop to Que and update the Queue.
    *****************************************************************/
    OFListTop = SMMJitBuff[PortNum].OFListTop; 
    SMMJitBuff[PortNum].OFListTop = 
                           JitBuff[PortNum][OFListTop].NextIndex;
    JitBuff[PortNum][OFListTop].NextIndex = JIT_IND_NULL;
    JitQue[PortNum][QueWtIndex] = OFListTop;

    SMMJitBuff[PortNum].OFCellMarkCnt -= 
                                    JitBuff[PortNum][OFListTop].PktCnt;
    SMMJitBuff[PortNum].OFRtpMarkCnt  -=  1;
    SMMJitBuff[PortNum].QueWtIndex = QueWtIndex;
  }
}


/********************************************************************
* Function Name	:	AJBRead                                     *
* Description   :       Function to read the packet in ISR context. *
*   JIT READ ERROR REPORTS                                          *
*   0. Duplicate packet drop happend in Jit Put packets             *
*          :   ( SMMJitBuff[PortNum].RdErrFlag | 0x0001)            *
*   3.Reset Read Sequence Number.                                   *
*      SMMJitBuff[PortNum].RdErrFlag =                              *
*                   ( SMMJitBuff[PortNum].RdErrFlag | 0x0008);      *
*   4.Silence Zone under-run nulls.                                 *
*      SMMJitBuff[PortNum].RdErrFlag =                              *
*                    ( SMMJitBuff[PortNum].RdErrFlag | 0x0010);     *
*   5.under-run play out nulls.                                     *
*      SMMJitBuff[PortNum].RdErrFlag =                              *
*                    ( SMMJitBuff[PortNum].RdErrFlag | 0x0020);     *
*   6.Silence Zone :                                                *
*      SMMJitBuff[PortNum].RdErrFlag =                              *
*                    ( SMMJitBuff[PortNum].RdErrFlag | 0x0040);     *
*   7.Speech Zone :                                                 *
*      SMMJitBuff[PortNum].RdErrFlag =                              *
*                    ( SMMJitBuff[PortNum].RdErrFlag | 0x0080);     *
*   8.#ifdef JIT_RD_INF_LOOP_NOT_SAFE1                              *
*      SMMJitBuff[PortNum].RdErrFlag =                              *
*                    ( SMMJitBuff[PortNum].RdErrFlag | 0x0100);     *
*   9.Delay Hits observed for -1 second, then disable late packet   *
*     drops at readthreshold and hold the JitterBuffer grow         *
*     mechanisim. Delay hits will come, if delay estimation greater *
*     than 2-seconds. and consists for 1-second.                    *
       SMMJitBuff[PortNum].RdErrFlag =                              *
                    ( SMMJitBuff[PortNum].RdErrFlag | 0x0200);      *
*  10.Once AJB swiched back from FJB to AJB.                        *
*      SMMJitBuff[PortNum].RdErrFlag =                              *
*                   ( SMMJitBuff[PortNum].RdErrFlag | 0x0400);      *
*  11.reset the Rd sequence number, If Late packet drops            *
*     increased beyond 70% of packets in a 10 seconds interval.     *
*      SMMJitBuff[PortNum].RdErrFlag =                              *
*		    ( SMMJitBuff[PortNum].RdErrFlag | 0x0800);      *
*  12.if non-silence null play out incresed beyond 1 minute, reset  *
*     the AJB.                                                      *
*      SMMJitBuff[PortNum].RdErrFlag =                              *
*		     ( SMMJitBuff[PortNum].RdErrFlag | 0x1000);     *
*      SMMJitBuff[PortNum].ResetErrNum = 1;                         *
*  13. The Status of InitFlag :  1                                  *
*      SMMJitBuff[PortNum].RdErrFlag =                              *
*		     ( SMMJitBuff[PortNum].RdErrFlag | 0x2000);     *
*  14.The Status of InitFlag :  2                                   *
*      SMMJitBuff[PortNum].RdErrFlag =                              *
*		     ( SMMJitBuff[PortNum].RdErrFlag | 0x4000);     *
*  15.The Sever Error report of dummy Read Packet                   *
*      SMMJitBuff[PortNum].RdErrFlag =                              *
*		     ( SMMJitBuff[PortNum].RdErrFlag | 0x8000);     *
********************************************************************/
void AJBRead(uWord16 PortNum)
{
  Word16 i;  

#if AJB_USE_CLI_CONFIGURATIONS
  AJB_READ_CNTR[PortNum]   += 1;
#endif

#ifdef AJB_SIMULATOR  //--> Debug Traps.
  if( AJB_READ_CNTR[PortNum]  == 28)
    AJB_READ_CNTR[PortNum]  = 28;
#endif
  SMMJitBuff[PortNum].RxPktProp =  JIT_NO_PACKET;
  /*************************************************************
               AJB Read Expects -AJB_State at : 1
  *************************************************************/
  if( AJBResetFlag[PortNum] <  1 )
    return;

 /***********************************************************
    Look for Packet Insatance for Read a packet from List.
  ***********************************************************/
  if(SMMJitBuff[PortNum].RdSkipCntr <
                  SMMJitBuff[PortNum].RdSkipThr )
  {
    SMMJitBuff[PortNum].RdSkipCntr += 1;
  }
  else
  {
     SMMJitBuff[PortNum].RdSkipCntr = 0;
  /**********************************************************
    Set the Property and Padd the instance  Bits.
  **********************************************************/
  SMMJitBuff[PortNum].RxPktProp =
   (SMMJitBuff[PortNum].RxPktProp |
                          SMMJitBuff[PortNum].CodecInstProp);
  }


  /*************************************************************
                     JIT BUFFER NOT YET INIT
  *************************************************************/
  if( SMMJitBuff[PortNum].JitInitFlag == 0)
    return;

  /************************************************************
        AJB DELAY TRACKING & FORM THE ORDERED LIST TO READ
  *************************************************************/ 
  SMMJitBuff[PortNum].RdRepCntr  = 0;
  SMMJitBuff[PortNum].RxFrameLen = 0;
  SMMJitBuff[PortNum].RxPktProp =  JIT_NO_PACKET;

  if( ucJitterBuffType[PortNum]  == AJB )
    JitDelayTrack(PortNum);
  JitPutPkt(PortNum);

  /************************************************************
     RD-STATE:0
  ************************************************************/    
  SMMJitBuff[PortNum].RxPktProp = JIT_NO_PACKET;
  if(SMMJitBuff[PortNum].JitInitFlag  < 2 )
    return;

  SMMJitBuff[PortNum].ResetDelayEstTimer +=
	              AJB_ISR_SCHEDULER_DURATION[PortNum];

  if( SMMJitBuff[PortNum].RdSkipCntr != 0) return;
  /**********************************************************
    Set the Property and Padd the instance  Bits.
  **********************************************************/
  SMMJitBuff[PortNum].RxPktProp =
   (SMMJitBuff[PortNum].RxPktProp |
                          SMMJitBuff[PortNum].CodecInstProp);

  /***********************************************************
    Do RdRepeat :: RdJitBuffer() to Spool-Basic Codec Payload.
  ***********************************************************/
  SMMJitBuff[PortNum].RdRepCntr  = 0;
  SMMJitBuff[PortNum].RxFrameLen = 0;
  SMMJitBuff[PortNum].RxPktProp  = JIT_NO_PACKET;
  for( i = 0; i < SMMJitBuff[PortNum].RdRepThr; i++)
  { 
    RdJitBuffer(PortNum);
  }
  
  /********************************************************** 
     Estimate Continous NULL Playouts.
  **********************************************************/
  if(( SMMJitBuff[PortNum].RxPktProp == JIT_NO_PACKET )&&
                        ( SMMJitBuff[PortNum].SidRead  == 0))
  {
    SMMJitBuff[PortNum].TotalNULLPlayed++;
    SMMJitBuff[PortNum].NullPktCnt    += 1;
    if( SMMJitBuff[PortNum].NullPktCnt == 1 )
    { 
      SMMJitBuff[PortNum].NullPlayFreqCntr += 1;
    }
    Markov4Est(PortNum);
    Markov4Data[PortNum].RxPktCnt     = 0;
#if DRV_DEBUG_STAT
    VoiceDebugStat[PortNum].ajbReadNULLCnt++;
#endif
  }
  else
  {
    SMMJitBuff[PortNum].NullPktCnt    = 0;
    Markov4Data[PortNum].RxPktCnt     += 1;
    if( Markov4Data[PortNum].RxPktCnt  >=  16 )
      Markov4Data[PortNum].MARKOV4STATE =  MARKOV4STATE1;
#if DRV_DEBUG_STAT
    VoiceDebugStat[PortNum].ajbReadSpeechCnt++;
#endif
  }
  
  /********************************************************** 
    Set the Property and Padd the instance  Bits.
  **********************************************************/
  SMMJitBuff[PortNum].RxPktProp = 
   (SMMJitBuff[PortNum].RxPktProp |
                          SMMJitBuff[PortNum].CodecInstProp);


  /**********************************************************
    AJB  STATISTICS &DEBUG MONITORS
  **********************************************************/
#if AJB_ENABLE_STATISTICS
   JitStatics(PortNum);
#else
   AJBTrackNullPacketPlayOut(PortNum);
#endif

}

	 
/**********************************************************************
* Function         : JitPutPkt()                                      *
* I/P Parameters   : WtVoicePkt *SMMRxPacketPtr,UCHAR * VPayLoadPtr   *
* O/P Parameters   : NONE                                             *
* Return Values    : NONE                                             *
* Description      : To read the Que and form ordered List.           *
**********************************************************************/
void JitPutPkt( uWord16 PortNum)
{
  uWord16  RxSeqNum,ListTop,PktCnt;
  uWord16  TempIndex,TabWtIndex,CurIndex,PreIndex;
  Word16   QueRdIndex,SeqNumDiff;
  uWord16  LoopNotSafe1 = 0;
  
  TempIndex  = JIT_IND_NULL;
  TabWtIndex = JIT_IND_NULL;

  
  while(1)
  {
    /* Look if there are any packets in read Q. */
    if(SMMJitBuff[PortNum].QueRdIndex == SMMJitBuff[PortNum].QueWtIndex)
      break ;   
    /* There is a packet to Read */
    QueRdIndex = 
       (SMMJitBuff[PortNum].QueRdIndex + 1) % JIT_QUE_MAX_LEN;

    /* Sanity Check */
    if(JitQue[PortNum][QueRdIndex] == JIT_IND_NULL )
    {
#ifdef AJB_DEBUG
      printk("It should never happen \n");
#endif
      SMMJitBuff[PortNum].QueRdIndex  = QueRdIndex;
      break;
    }
    TabWtIndex = JitQue[PortNum][QueRdIndex];

    /* SID PACKETS CNTR INCREMENT */
    if( JitBuff[PortNum][TabWtIndex].PktProp == JIT_VAD_PACKET )
      SMMJitBuff[PortNum].PrevSidEnable +=1;

    /*  FIRST ARRIVED  PACKET INTO JITTER BUFFER */
    if(  SMMJitBuff[PortNum].JitInitFlag == 1)
    {
      SMMJitBuff[PortNum].ListTop = JIT_IND_NULL;
      SMMJitBuff[PortNum].ExpReadSeqNum  =
                        JitBuff[PortNum][TabWtIndex].SeqNum;
      SMMJitBuff[PortNum].LastReadSeqNum =
                 JitBuff[PortNum][TabWtIndex].SeqNum - 1;
      SMMJitBuff[PortNum].JitInitFlag = 2;
#if AJB_ENABLE_STATISTICS
      SMMJitBuff[PortNum].RdErrFlag = ( SMMJitBuff[PortNum].RdErrFlag | 0x4000);
#endif
    }//-> End of JitInitFlag.
  
    RxSeqNum  = JitBuff[PortNum][TabWtIndex].SeqNum;
    PktCnt    = JitBuff[PortNum][TabWtIndex].PktCnt;

    //---> 1.1.CASE -List is empty.
    ListTop   =  SMMJitBuff[PortNum].ListTop;
    if( ListTop  ==  JIT_IND_NULL )
    {
      //---> Set on List Top.
      SMMJitBuff[PortNum].ListTop = TabWtIndex;
      SMMJitBuff[PortNum].ListCellCnt    +=  PktCnt;
      SMMJitBuff[PortNum].ListRtpCnt     +=  1;
    }
    else 
    {
      /* Look for the current node on the top of the List. */
      /* We need to find the place to insert this node into the list at
         increasing order of the sequence number. */
         /* Look for the current node on the top of the List. */
      CurIndex  =  ListTop;
      PreIndex  =  JIT_IND_NULL;

      while(CurIndex !=  JIT_IND_NULL)
      {
        SeqNumDiff =  RxSeqNum - JitBuff[PortNum][CurIndex].SeqNum;
        if(SeqNumDiff <= 0)
          break;
        PreIndex = CurIndex;
        CurIndex = JitBuff[PortNum][CurIndex].NextIndex;
      }
      if(CurIndex == JIT_IND_NULL)
      {
        /* We could not find the place in increasing order, add to the
         tail of the list */
        JitBuff[PortNum][PreIndex].NextIndex = TabWtIndex;
        SMMJitBuff[PortNum].ListCellCnt  += JitBuff[PortNum][TabWtIndex].PktCnt;
        SMMJitBuff[PortNum].ListRtpCnt     +=  1;
      }
      else
      {
        if(JitBuff[PortNum][CurIndex].SeqNum == RxSeqNum)
        {
          /* Ideally it would not happen as it will be either dropped
             at RTP level OR at the upper block , where we check for
             duplicate packets. */
#if AJB_ENABLE_STATISTICS
          SMMJitBuff[PortNum].PutDupDropCnt  += 
                            JitBuff[PortNum][TabWtIndex].PktCnt;
          SMMJitBuff[PortNum].RdErrFlag = 
                 ( SMMJitBuff[PortNum].RdErrFlag | 0x0001);
#endif
          JitFreeMem(TabWtIndex,PortNum);
#ifdef AJB_DEBUG
          printk("DEUPLICATE PKT RD LIST \n");
#endif
          SMMJitBuff[PortNum].QueRdIndex  = QueRdIndex;
          break ;
        }
        /* We have got the node to add */
        else if(CurIndex == ListTop)
        {
          /* Move the OFListTop pointer to the current one */
          SMMJitBuff[PortNum].ListTop = TabWtIndex;
          JitBuff[PortNum][TabWtIndex].NextIndex = ListTop;
          SMMJitBuff[PortNum].ListCellCnt    += JitBuff[PortNum][TabWtIndex].PktCnt;
          SMMJitBuff[PortNum].ListRtpCnt     +=  1;
        }
        else
        {
          JitBuff[PortNum][PreIndex].NextIndex   =  TabWtIndex;
          JitBuff[PortNum][TabWtIndex].NextIndex =  CurIndex;
          SMMJitBuff[PortNum].ListCellCnt +=  JitBuff[PortNum][TabWtIndex].PktCnt;
          SMMJitBuff[PortNum].ListRtpCnt    +=  1;
        }
      }
    }
    /*  QueueRead Pointers Update   */
    JitQue[PortNum][QueRdIndex] = JIT_IND_NULL;
    SMMJitBuff[PortNum].QueRdIndex = QueRdIndex;
#ifdef JIT_PUT_INF_LOOP_NOT_SAFE1
    LoopNotSafe1++;
    if( LoopNotSafe1 > JITBUFF_MAX_LEN )
    {
#if AJB_ENABLE_STATISTICS
      SMMJitBuff[PortNum].RdErrFlag = ( SMMJitBuff[PortNum].RdErrFlag | 0x0004);
#endif
      break;
    }
#endif
  }//---> End of While(1) Loop.
}//--> End of JitPutPkt().

/****************************************************************************
* Function         : RdJitBuffer()                                          *
* I/P Parameters   : RdVoicePkt* RdVoicePktPtr                              *
* O/P Parameters   : NONE                                                   *
* Return Values    : NONE                                                   *
* Description      : This function contains implementation of               *
                     the jitter read operation                              *
****************************************************************************/
void RdJitBuffer(uWord16 PortNum)
{
  uWord16 RxFrameLen,NewSeqNum,WtIndex;
  uWord16 CellIndex;
  Word16 SeqNumDiff;
  uWord16 ListTop;
  /********************************************************************
               JIT_RD_DELAY TRACKING LOGIC
  ********************************************************************/
#ifdef JIT_RD_DELAY_TRACK
  if( SMMJitBuff[PortNum].SidRead == 1 )
  { 
    if(( SMMJitBuff[PortNum].ListCellCnt < AJB_READ_THRESHOLD[PortNum])
                         && (SMMJitBuff[PortNum].PrevSidEnable == 0) )
    {
      //----> Use  Silence Zone  to adjust AJB Buffer size
#if AJB_ENABLE_STATISTICS
      SMMJitBuff[PortNum].RdErrFlag = 
                       ( SMMJitBuff[PortNum].RdErrFlag | 0x0010); 
#endif
      if(SMMJitBuff[PortNum].ListCellCnt != 0)
        SMMJitBuff[PortNum].RTPThrCnt++;
      return;
    }
  }  //----> end of Sid Read ==1 case.
  else
  {
    //--> No Vad -Scheme running-Look for SilenceZone from History.
    if(( SMMJitBuff[PortNum].ListCellCnt < AJB_READ_THRESHOLD[PortNum])
          && (SMMJitBuff[PortNum].PrevSidEnable == 0 )
           && (SMMJitBuff[PortNum].Rd_state  ==  JIT_RD_STATE_UND ))
    {
      //----> under-run play out nulls.
#if AJB_ENABLE_STATISTICS
      SMMJitBuff[PortNum].RdErrFlag =
                             ( SMMJitBuff[PortNum].RdErrFlag | 0x0020);
#endif
      SMMJitBuff[PortNum].ListNullCnt += 1;
      if(SMMJitBuff[PortNum].ListCellCnt != 0)
         SMMJitBuff[PortNum].RTPThrCnt++;
      return;
    }
    else if(SMMJitBuff[PortNum].Rd_state  ==  JIT_RD_STATE_UND )
      SMMJitBuff[PortNum].RTPThrCnt++;
  }//--> End of else of non-sid case.
  if( (SMMJitBuff[PortNum].RTPThrCnt < AJB_READ_THRESHOLD[PortNum])
      &&  (SMMJitBuff[PortNum].Rd_state  ==  JIT_RD_STATE_UND ))
  {
    //----> under-run play out nulls.
#if AJB_ENABLE_STATISTICS
    SMMJitBuff[PortNum].RdErrFlag =
                             ( SMMJitBuff[PortNum].RdErrFlag | 0x0020);
#endif
    SMMJitBuff[PortNum].ListNullCnt += 1;
    SMMJitBuff[PortNum].RTPThrCnt++;
    return;
  }
#endif

  /******************************************************************
     RD-STATE:2
     IF CELL IS AVAILABLE IN PREVIOUS MULTI PACKET, SET IT TO 
     IPC-BUFFER
  ******************************************************************/
  if( SMMJitBuff[PortNum].RdPktIndex != JIT_IND_NULL )
  {
    CellIndex = SMMJitBuff[PortNum].RdPktIndex;
    SMMJitBuff[PortNum].RdPktIndex =  
		        JitPkt[PortNum][CellIndex].NextIndex;
    SMMJitBuff[PortNum].RxPktProp = 
    	                  JitPkt[PortNum][CellIndex].PktProp;
		  
    RxFrameLen = JitPkt[PortNum][CellIndex].FrameLen;
    WtIndex    = SMMJitBuff[PortNum].RxFrameLen;
    SMMJitBuff[PortNum].RxFrameLen  += RxFrameLen;
    memcpy(&SMMJitBuff[PortNum].RxBuff[WtIndex],
        JitPkt[PortNum][CellIndex].VoicePkt,RxFrameLen);
    //--> Free the Buffer.
    SMMJitBuff[PortNum].ListCellCnt    -=  1;    	
    JitPkt[PortNum][CellIndex].NextIndex = JIT_IND_NULL;
    ReleaseRTPCell(PortNum, CellIndex);
    return;
  }

  //--> Read The List Top.
  ListTop = SMMJitBuff[PortNum].ListTop;
  /***************************************************************
     RD-STATE:3
  ***************************************************************/
  if( ListTop == JIT_IND_NULL )
  {
    //---> LIST IS EMPTY TO READ
    if( SMMJitBuff[PortNum].SidRead ==  0 )
    {
      SMMJitBuff[PortNum].Rd_state  =  JIT_RD_STATE_UND;
      SMMJitBuff[PortNum].RTPThrCnt = 0;
      SMMJitBuff[PortNum].ListNullCnt += 1;
#if AJB_ENABLE_STATISTICS
      SMMJitBuff[PortNum].RdErrFlag=(SMMJitBuff[PortNum].RdErrFlag | 0x0020);
#endif
    }
    return; 
  }//---> LIST IS EMPTY TO READ 
  /**************************************************************
    RD-STATE: 4  LIST HAS PACKETS.
  **************************************************************/

  NewSeqNum =  JitBuff[PortNum][ListTop].SeqNum;
  /*  Check Weather Read Pkt is Pre / Post Read Packet. */
  SeqNumDiff = NewSeqNum - SMMJitBuff[PortNum].LastReadSeqNum;

  /*************************************************************
    LATE PACKET CHECK 
  *************************************************************/
#ifdef AJB_LATE_PKT_DROP
  if(( SeqNumDiff < 0 )&&( SMMJitBuff[PortNum].ResetRdSeqNumber != 1))
  {
    //--> Current Read packet is older prev Read Pkt drop it.
    SMMJitBuff[PortNum].ListTop = 
                         JitBuff[PortNum][ListTop].NextIndex;
#ifdef AJB_DEBUG
    printk("COMESE HERE  AJB_LATE_PKT_DROP \n");
#endif
    //JitFreeMem(ListTop,PortNum);
    SMMJitBuff[PortNum].ListCellCnt    -=  
                     JitBuff[PortNum][ListTop].PktCnt;;
    SMMJitBuff[PortNum].ListRtpCnt     -=  1;
    SMMJitBuff[PortNum].LateDropCnt    +=  
                     JitBuff[PortNum][ListTop].PktCnt;
    SMMJitBuff[PortNum].LateDropRunCnt +=  
                     JitBuff[PortNum][ListTop].PktCnt;
    SMMJitBuff[PortNum].LateDropFreqCntr  +=  1;
    SMMJitBuff[PortNum].Rd_state     =  JIT_RD_STATE_UND;
    SMMJitBuff[PortNum].RTPThrCnt = 0;
    SMMJitBuff[PortNum].ListNullCnt +=  1;
    JitFreeMem(ListTop,PortNum);
#if AJB_ENABLE_STATISTICS
    SMMJitBuff[PortNum].RdErrFlag = 
                  ( SMMJitBuff[PortNum].RdErrFlag | 0x0020);
#endif
    return;
  }
  else 
    SMMJitBuff[PortNum].LateDropRunCnt  =  0;

  if( SMMJitBuff[PortNum].ResetRdSeqNumber == 1) 
  {
    SMMJitBuff[PortNum].ResetRdSeqNumber   = 0;
#if AJB_ENABLE_STATISTICS
    //------> Reset Read Sequence Number.
    SMMJitBuff[PortNum].RdErrFlag = 
        	    ( SMMJitBuff[PortNum].RdErrFlag | 0x0008);
#endif
  }
#endif

  SMMJitBuff[PortNum].Rd_state  =  JIT_RD_STATE_PLAY;

  /* Update the Latest ReadSequence Number        */
  SMMJitBuff[PortNum].ListTop = JitBuff[PortNum][ListTop].NextIndex;
  SMMJitBuff[PortNum].LastReadSeqNum = NewSeqNum;

#ifdef JIT_VAD_ENABLED
  if( JitBuff[PortNum][ListTop].PktProp == JIT_VAD_PACKET )
  {
    SMMJitBuff[PortNum].PrevSidEnable -= 1;
    SMMJitBuff[PortNum].SidRead = 1;
    SMMJitBuff[PortNum].SilenceON  = JitBuff[PortNum][ListTop].SRTimeStamp;
    SMMJitBuff[PortNum].SidInterval = 0;
#if AJB_ENABLE_STATISTICS
    SMMJitBuff[PortNum].RdErrFlag = ( SMMJitBuff[PortNum].RdErrFlag | 0x0040);
#endif
  }
  else
  {
    SMMJitBuff[PortNum].SidRead = 0;
#if AJB_ENABLE_STATISTICS
    SMMJitBuff[PortNum].RdErrFlag =
                 ( SMMJitBuff[PortNum].RdErrFlag | 0x0080);
#endif
  }
#endif

  CellIndex = JitBuff[PortNum][ListTop].PktIndex;
  if( CellIndex == JIT_IND_NULL )
  {
    /* No PayLoad Pkt attached to Rtp pkt 
       It is SevereError-Report. */
#if AJB_ENABLE_STATISTICS
    SMMJitBuff[PortNum].NoCells2Rtp += SMMJitBuff[PortNum].RxFrameCntr;
    SMMJitBuff[PortNum].RdErrFlag = ( SMMJitBuff[PortNum].RdErrFlag | 0x8000);
#endif
    JitBuff[PortNum][ListTop].PktCnt = 0;
    JitBuff[PortNum][ListTop].PktIndex   = JIT_IND_NULL;
    JitBuff[PortNum][ListTop].NextIndex  = JIT_IND_NULL;
    JitPkt[PortNum][CellIndex].NextIndex = JIT_IND_NULL;
    ReleaseRTPPkt(PortNum,ListTop);
#ifdef AJB_DEBUG
    printk("NO PACKET ATTACHED TO THIS CELL \n");
#endif
    return;
  }
  SMMJitBuff[PortNum].RdPktIndex =  JitPkt[PortNum][CellIndex].NextIndex;   
  SMMJitBuff[PortNum].RxPktProp = JitPkt[PortNum][CellIndex].PktProp;
  RxFrameLen = JitPkt[PortNum][CellIndex].FrameLen;
  WtIndex    = SMMJitBuff[PortNum].RxFrameLen;
  SMMJitBuff[PortNum].RxFrameLen  += RxFrameLen;
  memcpy(&SMMJitBuff[PortNum].RxBuff[WtIndex],
           JitPkt[PortNum][CellIndex].VoicePkt,RxFrameLen);
  SMMJitBuff[PortNum].ListCellCnt    -=  1;
  SMMJitBuff[PortNum].ListRtpCnt     -=  1;

  /* Free RTP Packet */
  JitBuff[PortNum][ListTop].PktCnt     = 0;
  JitBuff[PortNum][ListTop].PktIndex   = JIT_IND_NULL;
  JitBuff[PortNum][ListTop].NextIndex  = JIT_IND_NULL;
  JitPkt[PortNum][CellIndex].NextIndex = JIT_IND_NULL;
  ReleaseRTPCell(PortNum, CellIndex);
  ReleaseRTPPkt(PortNum,ListTop);
}


int AJBEnqPkt(WtRtpPktType_ *WtRTPPkt , uWord16 PortNum , UCHAR *pVoicePayload)
{
  Word16 frameCnt = 0;
  Word16 payloadLen;
  Word16 FrameLen = WtRTPPkt->FrameLen;
  Word16 CurPayLoadIndex = 12;  /* RTP Offset */
  UCHAR TempProp;
  uWord16 pktType[JIT_MAX_FRAMES];
  uWord16 pktLen[JIT_MAX_FRAMES];
  Word16 WtCellInd[JIT_MAX_FRAMES];
  uWord16 SchTabelIndex;
  UCHAR JitWtErrState = 0;
  Word16 TabWtIndex;
  Word16 i;

  SchTabelIndex =  SMMJitBuff[PortNum].SchTabelIndex;
  payloadLen = FrameLen;

#if AJB_RTP_DUPLICATE_CHECK_ENABLED
  /********************************************************************
  CHECK FOR ANY DUPLICATE PACKET IN HISTORY BUFFER FOR HISTORY INTERVAL
  *********************************************************************/
  /* Duplicate packets are always discarded at RTP level itself so those
     packet never come here. In case you get duplicate packets at AJB
     level, then you have problem with RTP implementation */
  for(i =0; i < SMMJitBuff[PortNum].HistBuffLen; i++ )
  {
    if(WtRTPPkt->SeqNum == JitHistTab[PortNum][i] )
    {
      //---> Drop the Duplicate Packets
      SMMJitBuff[PortNum].WtDupDropCnt  += SMMJitBuff[PortNum].RxFrameCntr;
#if AJB_ENABLE_STATISTICS
      SMMJitBuff[PortNum].WtErrFlag = ( SMMJitBuff[PortNum].WtErrFlag | 0x8000);
#endif
      return FAILURE;
    }
  }//--> End of scan of Total JitterBuffer.
  i = SMMJitBuff[PortNum].HistWtIndex;
  JitHistTab[PortNum][i] = WtRTPPkt->SeqNum;
  i++;
  i = i % JIT_HIST_BUFF_MAX_LEN;
  SMMJitBuff[PortNum].HistWtIndex = i;

  if( SMMJitBuff[PortNum].HistBuffLen < JIT_HIST_BUFF_MAX_LEN )
    SMMJitBuff[PortNum].HistBuffLen++;
#endif


  /* GET FREE AJB Buffer Packet to hold Packet Properties. */
  TabWtIndex = GetJitBuffPkt(PortNum);
  if(TabWtIndex == FAILURE)
  {
    /* No Buffer remaining .. */
#if AJB_ENABLE_STATISTICS
    SMMJitBuff[PortNum].WtNoRtpMemDropCnt += SMMJitBuff[PortNum].RxFrameCntr;
    SMMJitBuff[PortNum].WtErrFlag = ( SMMJitBuff[PortNum].WtErrFlag | 0x0004);
#endif
    return FAILURE;
  }
  /* Look for the number of frames within the packet */
  switch(WtRTPPkt->CodecType)
  {
    case VAD_CNG:
      pktType[frameCnt] = JIT_VAD_PACKET;
      pktLen[frameCnt] = payloadLen;
      frameCnt = 1; /* FOR VAD packets only one frame. */
      break;
    case PCMU:
    case PCMA:
    case G722: // Sagem ICC
      while(payloadLen > 0)
      {
        if( (payloadLen == G711_ANNEX1_SILENCE_FRAME_LEN)
          || (payloadLen == G711_ANNEX2_SILENCE_FRAME_LEN))
        {
          pktType[frameCnt] = JIT_VAD_PACKET;
          pktLen[frameCnt] = payloadLen;
          frameCnt++;
          break;
        }
        else if(payloadLen >= G711_BASIC_SPEECH_FRAME_LEN)
        {
          pktType[frameCnt] = JIT_SPEECH_PACKET;
          pktLen[frameCnt] = G711_BASIC_SPEECH_FRAME_LEN;
          frameCnt++;
          payloadLen -= G711_BASIC_SPEECH_FRAME_LEN;
        }
        else if(payloadLen < G711_BASIC_SPEECH_FRAME_LEN)
        {
          JitWtErrState  = 1;
          break;
        }
        if(frameCnt >= JIT_MAX_FRAMES)
        {
          JitWtErrState  = 1;
          break;
        }
      }
      break;
    case G729A:
    case G729B:
    case G729 :
      while(payloadLen > 0)
      {
        if(payloadLen >= G729_BASIC_SPEECH_FRAME_LEN)
        {
          pktType[frameCnt] = JIT_SPEECH_PACKET;
          pktLen[frameCnt] = G729_BASIC_SPEECH_FRAME_LEN;
          payloadLen -= G729_BASIC_SPEECH_FRAME_LEN;
          frameCnt++;
        }  
        else if(payloadLen == G729_SILENCE_FRAME_LEN)
        {
          pktType[frameCnt] = JIT_VAD_PACKET;
          pktLen[frameCnt] = G729_SILENCE_FRAME_LEN;
          frameCnt++;
          payloadLen -= G729_SILENCE_FRAME_LEN;
        }
        else if(payloadLen > 0)
        {
          JitWtErrState  = 1;
#if AJB_ENABLE_STATISTICS
          SMMJitBuff[PortNum].WtErrFlag = ( SMMJitBuff[PortNum].WtErrFlag | 0x0020);
#endif
#ifdef AJB_DEBUG
          printk("\r\n WT_G729_FLE[%d]",payloadLen);
#endif

          break;
        }
        if(frameCnt >= JIT_MAX_FRAMES)
        {
          JitWtErrState  = 1;
#ifdef AJB_DEBUG
	  printk("PKT LEN More then Max Frames \n");
#endif
          break;
        }
      }
      break;
    case G723AH:
    case G723AL:
    case G723L :
    case G723H :
    case G723  :
      while(payloadLen > 0)
      {
#if KRTP
        memcpy(&TempProp,&pVoicePayload[CurPayLoadIndex],
                                sizeof(UCHAR));
#else
        copy_from_user(&TempProp,&pVoicePayload[CurPayLoadIndex],
                                sizeof(UCHAR));
#endif

        if((TempProp & 0x03) ==  0 )
        {
          pktType[frameCnt] = JIT_SPEECH_PACKET;
          pktLen[frameCnt] = G723H_BASIC_SPEECH_FRAME_LEN;
          frameCnt++;
          payloadLen -= G723H_BASIC_SPEECH_FRAME_LEN;
          CurPayLoadIndex += G723H_BASIC_SPEECH_FRAME_LEN;;
        }
        else if( (TempProp & 0x03) ==  1 )
        {
          pktType[frameCnt] = JIT_SPEECH_PACKET;
          pktLen[frameCnt] = G723L_BASIC_SPEECH_FRAME_LEN;
          frameCnt++;
          payloadLen -= G723L_BASIC_SPEECH_FRAME_LEN;
          CurPayLoadIndex += G723L_BASIC_SPEECH_FRAME_LEN;
        }
        else if (( TempProp & 0x03) ==  2 )
        {
          pktType[frameCnt] = JIT_VAD_PACKET;
          pktLen[frameCnt] = G723_SILENCE_FRAME_LEN;
          frameCnt++;
          CurPayLoadIndex += G723_SILENCE_FRAME_LEN; 
          if((payloadLen %G723H_BASIC_SPEECH_FRAME_LEN) == 0)
            payloadLen -= G723H_BASIC_SPEECH_FRAME_LEN;
          else if((payloadLen %G723L_BASIC_SPEECH_FRAME_LEN) == 0)
            payloadLen -= G723L_BASIC_SPEECH_FRAME_LEN;
          else
            payloadLen -= G723_SILENCE_FRAME_LEN;
        }
        else if (( TempProp & 0x03) ==  3 )
        {
#if AJB_ENABLE_STATISTICS
          SMMJitBuff[PortNum].WtFrameLenErr += SMMJitBuff[PortNum].RxFrameCntr;
          SMMJitBuff[PortNum].WtErrFlag = ( SMMJitBuff[PortNum].WtErrFlag | 0x0040);
#endif
          ReleaseRTPPkt(PortNum,TabWtIndex);
#ifdef AJB_DEBUG
          printk("Wrong Packet Length G-723 => 1 \n");
#endif

          return FAILURE;
        }
        else 
        {
          JitWtErrState  = 1;
          break;
        }        
        if(frameCnt >= JIT_MAX_FRAMES)
        {
          JitWtErrState  = 1;
          break;
        }
      }
      break;
    default:
#if AJB_ENABLE_STATISTICS
      SMMJitBuff[PortNum].WtFrameLenErr += SMMJitBuff[PortNum].RxFrameCntr;
      SMMJitBuff[PortNum].WtErrFlag = ( SMMJitBuff[PortNum].WtErrFlag | 0x010);
#endif
      ReleaseRTPPkt(PortNum,TabWtIndex);
#ifdef AJB_DEBUG
      printk("Wrong Packet Unknown Codec Type \n");
#endif
      return FAILURE;
  }
  if(JitWtErrState == 1)
  {
#if AJB_ENABLE_STATISTICS
    SMMJitBuff[PortNum].WtFrameLenErr += SMMJitBuff[PortNum].RxFrameCntr;
    SMMJitBuff[PortNum].WtErrFlag = ( SMMJitBuff[PortNum].WtErrFlag | 0x080);
#endif
    ReleaseRTPPkt(PortNum,TabWtIndex);
#ifdef AJB_DEBUG
    printk("Wrong Packet Unknown Codec Type \n");
#endif
    return FAILURE;
  }

  /* Allocate Require cells to store the frames */
  for(CurPayLoadIndex = 0; CurPayLoadIndex <frameCnt; CurPayLoadIndex++)
  {
    WtCellInd[CurPayLoadIndex] = GetFreePkt(PortNum);
    if(WtCellInd[CurPayLoadIndex] == FAILURE)
    {
      /* We need to release all the cells allocated as we could not get required 
         number of cell allocations */
      for(i=0; i<CurPayLoadIndex; i++)
      {
        ReleaseRTPCell(PortNum, WtCellInd[i]);
      }
#if AJB_ENABLE_STATISTICS
      SMMJitBuff[PortNum].WtNoCellMemDropCnt += SMMJitBuff[PortNum].RxFrameCntr;
      SMMJitBuff[PortNum].WtErrFlag = ( SMMJitBuff[PortNum].WtErrFlag | 0x0008);
#endif
#ifdef AJB_DEBUG
      printk("Release RTP Packet \n");
#endif
      ReleaseRTPPkt(PortNum,TabWtIndex);
      return FAILURE;
    }
  }

  /* We have all the required allocations , go ahead and enqueue the packet
     to the Jitter Buffer */

 /********************************************************************
    WRITE ARRIVED NEW RTP PACKET/PAYLOADS INTO  NEW MEM CELLS
  ********************************************************************/
  JitBuff[PortNum][TabWtIndex].PktProp     =  JIT_SPEECH_PACKET;
  JitBuff[PortNum][TabWtIndex].SeqNum      =  WtRTPPkt->SeqNum;;
  JitBuff[PortNum][TabWtIndex].SRTimeStamp =  WtRTPPkt->SR_TIMESTAMP;
  JitBuff[PortNum][TabWtIndex].WtDelay     =  AJB_READ_THRESHOLD[PortNum];
  JitBuff[PortNum][TabWtIndex].PktIndex    =  WtCellInd[0];
  JitBuff[PortNum][TabWtIndex].PktCnt      =  frameCnt;
  JitBuff[PortNum][TabWtIndex].NextIndex   =  JIT_IND_NULL;

  payloadLen = FrameLen;
  CurPayLoadIndex = 12;

/* SAGEM -> [ DEBUG ] { */
  if ((1 << DEBUG_KRTP) & gDebugLevel) {
    printk(	"%s: lg(%d) codec(%d) frameCnt(%d)\n",
			__FUNCTION__,
			FrameLen,
			WtRTPPkt->CodecType,
			frameCnt);
  }
/* } */

  for(i = 0; i<frameCnt; i++)
  {  
    JitBuff[PortNum][TabWtIndex].PktProp =  pktType[i];
    if(i > 0)
      JitPkt[PortNum][WtCellInd[i-1]].NextIndex    =  WtCellInd[i];   
    JitPkt[PortNum][WtCellInd[i]].NextIndex = JIT_IND_NULL;
    JitPkt[PortNum][WtCellInd[i]].PktProp   = pktType[i];

    /* Fill the Payload */
/* SAGEM -> [ SAGEM_KRTP INTEGRATION ] { */
#if KERNEL_RTP_INTERFACE
/* } */
/* SAGEM -> [ DEBUG ] { */
	if ((1 << DEBUG_KRTP) & gDebugLevel) {
		int _z = 0;

		for (_z = CurPayLoadIndex; _z < CurPayLoadIndex + pktLen[i]; _z++) {
			printk(	"%02x ",
					(unsigned char)pVoicePayload[_z]);
		}
	}
/* } */

    memcpy(JitPkt[PortNum][WtCellInd[i]].VoicePkt,
             &pVoicePayload[CurPayLoadIndex],pktLen[i]);
#else
    copy_from_user(JitPkt[PortNum][WtCellInd[i]].VoicePkt,
          &pVoicePayload[CurPayLoadIndex],pktLen[i]);
#endif

    JitPkt[PortNum][WtCellInd[i]].FrameLen  = pktLen[i];
    CurPayLoadIndex += pktLen[i];
#if DRV_DEBUG_STAT
    VoiceDebugStat[PortNum].ajbEnqCnt++;
#endif
  }
  return TabWtIndex;
}


/* Function to Initialize / Reset AJB parameters . */
int AJBInit(Word16 PortNum, WtRtpPktType_ *WtRTPPkt)
{
  uWord16 JitWtErrState = 1;
  Word16 CurFillLen =  WtRTPPkt->FrameLen;
  uWord16 SchTabelIndex   =  SMMJitBuff[PortNum].SchTabelIndex;

  SMMJitBuff[PortNum].CodecInstProp = AJB_CODEC_NULL_INSTANCE;
  SMMJitBuff[PortNum].FrameLen   =  WtRTPPkt->FrameLen;
  switch(WtRTPPkt->CodecType)
  {
    case  PCMU :
    case  PCMA :
    case  G722 : // Sagem ICC
      SMMJitBuff[PortNum].CodecIeOffset    = R_MODEL_IE_G711_OFFSET;
      SMMJitBuff[PortNum].CodecIePolyIndex = 0;
      if((CurFillLen % G711_BASIC_SPEECH_FRAME_LEN == 0)&&(CurFillLen != 0))
      {
        SMMJitBuff[PortNum].RxFrameCntr  = CurFillLen/G711_BASIC_SPEECH_FRAME_LEN;
        SMMJitBuff[PortNum].DelIntStepMS = G711_BASIC_SPEECH_FRAME_MS;
        SMMJitBuff[PortNum].DelRemStepMS = G711_BASIC_SPEECH_FRAME_MS;

        SMMJitBuff[PortNum].RdRepCntr    =  0;
        SMMJitBuff[PortNum].RdSkipCntr
                                         =  AJB_ISR_SCHEDULER_TABLE[SchTabelIndex][0];
        SMMJitBuff[PortNum].RdSkipThr
                                         =  AJB_ISR_SCHEDULER_TABLE[SchTabelIndex][0];
        SMMJitBuff[PortNum].RdRepThr
                                         =  AJB_ISR_SCHEDULER_TABLE[SchTabelIndex][3];
        JitWtErrState = 0;
      }//---> CurFillLen in terms of 5msPayLoads.
      break;
    case  G729A:
    case  G729B:
    case  G729 :
      SMMJitBuff[PortNum].CodecIeOffset    = R_MODEL_IE_G729_OFFSET;
      SMMJitBuff[PortNum].CodecIePolyIndex = 1;
      if(( CurFillLen%G729_BASIC_SPEECH_FRAME_LEN == 0 )&&(CurFillLen != 0))
      {
        SMMJitBuff[PortNum].DelIntStepMS =  G729_BASIC_SPEECH_FRAME_MS;
        SMMJitBuff[PortNum].DelRemStepMS =  G729_BASIC_SPEECH_FRAME_MS;
        SMMJitBuff[PortNum].RxFrameCntr
                                         = CurFillLen/G729_BASIC_SPEECH_FRAME_LEN;
        SMMJitBuff[PortNum].RdRepCntr    =  0;
        SMMJitBuff[PortNum].RdSkipCntr
                                         =  AJB_ISR_SCHEDULER_TABLE[SchTabelIndex][1];
        SMMJitBuff[PortNum].RdSkipThr
                                         =  AJB_ISR_SCHEDULER_TABLE[SchTabelIndex][1];
        SMMJitBuff[PortNum].RdRepThr
                                         =  AJB_ISR_SCHEDULER_TABLE[SchTabelIndex][4];
        JitWtErrState = 0;
      }
      break;
    case G723AH:
    case G723AL:
    case G723L :
    case G723H :
    case G723  :
      SMMJitBuff[PortNum].DelIntStepMS  = G723_BASIC_SPEECH_FRAME_MS;
      SMMJitBuff[PortNum].DelRemStepMS  = G723_BASIC_SPEECH_FRAME_MS;
      SMMJitBuff[PortNum].CodecInstProp = AJB_G723_CODEC_INSTANCE;
      if(( CurFillLen % G723L_BASIC_SPEECH_FRAME_LEN == 0)&&(CurFillLen != 0))
      {
        SMMJitBuff[PortNum].RxFrameCntr =
                                           CurFillLen/G723L_BASIC_SPEECH_FRAME_LEN;
        SMMJitBuff[PortNum].CodecIeOffset    = R_MODEL_IE_G723_L_OFFSET;
        SMMJitBuff[PortNum].CodecIePolyIndex = 2;
        JitWtErrState = 0;
      }
      else if((CurFillLen % G723H_BASIC_SPEECH_FRAME_LEN == 0)
                                                         &&( CurFillLen != 0))
      {
        SMMJitBuff[PortNum].RxFrameCntr =
                                        CurFillLen/G723H_BASIC_SPEECH_FRAME_LEN;
        SMMJitBuff[PortNum].CodecIeOffset    = R_MODEL_IE_G723_H_OFFSET;
        SMMJitBuff[PortNum].CodecIePolyIndex = 2;
        JitWtErrState = 0;
      }
      SMMJitBuff[PortNum].RdRepCntr    =  0;
      SMMJitBuff[PortNum].RdSkipCntr
                                       =  AJB_ISR_SCHEDULER_TABLE[SchTabelIndex][2];
      SMMJitBuff[PortNum].RdSkipThr
                  =  AJB_ISR_SCHEDULER_TABLE[SchTabelIndex][2];
      SMMJitBuff[PortNum].RdRepThr
                                       =  AJB_ISR_SCHEDULER_TABLE[SchTabelIndex][5];
      break;
    default:
      break;
  }//---> End of Switch Statement.

  /* Need to wait till we get First SPEECH packet */
  if(JitWtErrState == 1)
  {
#if AJB_ENABLE_STATISTICS
    SMMJitBuff[PortNum].WtErrFlag = ( SMMJitBuff[PortNum].WtErrFlag | 0x0002);
#endif
    return FAILURE;
  }

  SMMJitBuff[PortNum].CodecType  = WtRTPPkt->CodecType;
  SMMJitBuff[PortNum].RxFrameMS  =
                SMMJitBuff[PortNum].DelRemStepMS*SMMJitBuff[PortNum].RxFrameCntr;
  //----> List Initialization
  SMMJitBuff[PortNum].ListTop        =  JIT_IND_NULL;
  SMMJitBuff[PortNum].OFListTop      =  JIT_IND_NULL;

  //---->Que initialization.
  SMMJitBuff[PortNum].QueRdIndex     = 0;
  SMMJitBuff[PortNum].QueWtIndex     = 0;
  JitQue[PortNum][0]                 = JIT_IND_NULL;

  //---> OverflowList Counters.
  SMMJitBuff[PortNum].OFCellMarkCnt      =  0;
  SMMJitBuff[PortNum].OFRtpMarkCnt       =  0;

#if AJB_ENABLE_STATISTICS
   //---> No of WtJit-call Arrivals
  SMMJitBuff[PortNum].WtPktCnt        =  0;
  SMMJitBuff[PortNum].PreWtPktCnt     =  0;

  //--> Duplicate Drops at Write Side.
  SMMJitBuff[PortNum].WtDupDropCnt         = 0;
  SMMJitBuff[PortNum].PreWtDupDropCnt      = 0;


  //---> Wt Context packet drops due to FrameLen Error.
  SMMJitBuff[PortNum].PreWtFrameLenErr  =  0;
  SMMJitBuff[PortNum].WtFrameLenErr     =  0;

  //---> Wt Contexet Packet Drops due to Codec Type Error.
  SMMJitBuff[PortNum].PreWtCodecErr     =  0;
  SMMJitBuff[PortNum].WtCodecErr        =  0;

  //---> Wt Context drops due to Buffer OcerFlows.
  SMMJitBuff[PortNum].WtOFDropCnt          = 0;
  SMMJitBuff[PortNum].PreWtOFDropCnt    = 0;

  //---> Wt Context drops due to No Free rtp cells
  SMMJitBuff[PortNum].WtNoRtpMemDropCnt    = 0;
  SMMJitBuff[PortNum].PreWtNoRtpMemDropCnt    = 0;


  //---> Wt Context drops due to No Free payload cells
  SMMJitBuff[PortNum].PreWtNoCellMemDropCnt   = 0;
  SMMJitBuff[PortNum].WtNoCellMemDropCnt   = 0;

  SMMJitBuff[PortNum].PutDupDropCnt        = 0;

  //---> Timers.
  SMMJitBuff[PortNum].StatisticsResetTimer   = 0;

  //--> Jit Delay Track Module
  SMMJitBuff[PortNum].DelayEstMax          = 0;
  SMMJitBuff[PortNum].DelayEstMin          = 65535;

  SMMJitBuff[PortNum].PlayOutDelay         = 0;
  SMMJitBuff[PortNum].AJBRdCntr            = 0;
  SMMJitBuff[PortNum].DelayTrackPktDropCnt  = 0;
  SMMJitBuff[PortNum].NoCells2Rtp     =  0;
  SMMJitBuff[PortNum].WtErrFlag       =  0;
  SMMJitBuff[PortNum].RdErrFlag       =  0;
#endif

  //--> Jit Put Pkt Module
  SMMJitBuff[PortNum].ListCellCnt          = 0;
  SMMJitBuff[PortNum].ListRtpCnt           = 0;
  SMMJitBuff[PortNum].ListNullCnt          = 0;
  SMMJitBuff[PortNum].ListCellMax          = 0;
  SMMJitBuff[PortNum].ListCellMin          = 65535;

  //----> VAD counters.
  SMMJitBuff[PortNum].PrevSidEnable        = 0;
  SMMJitBuff[PortNum].SidRead              = 0;

  //----> dsp-ipc parameters.
  SMMJitBuff[PortNum].RdPktIndex           = JIT_IND_NULL;

  SMMJitBuff[PortNum].JitDelayEstTimer       = 0;
  SMMJitBuff[PortNum].DelayDropTimer         = 0;



  SMMJitBuff[PortNum].MaxDelay             = 0;
  SMMJitBuff[PortNum].CurWtDelay           = 0;

  SMMJitBuff[PortNum].GapOffset            = 0;

  //--> Jit Read Module
  SMMJitBuff[PortNum].DelayTrackFreqCntr    = 0;
  SMMJitBuff[PortNum].LateDropFreqCntr      = 0;
  SMMJitBuff[PortNum].NullPlayFreqCntr      = 0;
  SMMJitBuff[PortNum].LateDropCnt           = 0;
  SMMJitBuff[PortNum].LateDropRunCnt        = 0;


  //----> Delay Estimation Module
  SMMJitBuff[PortNum].ResetDelayEstTimer = 0;
  SMMJitBuff[PortNum].CodecType    = WtRTPPkt->CodecType;
  SMMJitBuff[PortNum].RR_TIMESTAMP = WtRTPPkt->RR_TIMESTAMP;
  SMMJitBuff[PortNum].SR_TIMESTAMP = WtRTPPkt->SR_TIMESTAMP;
  SMMJitBuff[PortNum].EstCumJit  = 0;
  SMMJitBuff[PortNum].EstCumJit32  = 0;

  SMMJitBuff[PortNum].EstInitJit = 0;
  SMMJitBuff[PortNum].d_hat_prev = 0;
  SMMJitBuff[PortNum].v_hat_prev = 0;
  SMMJitBuff[PortNum].nd_prev    = 0;
  SMMJitBuff[PortNum].nd_2       = 0;
  SMMJitBuff[PortNum].p_hat      = 0;
  SMMJitBuff[PortNum].ReadThreshold = 0;

  //---> Duplicate Packet Tracking Module.
  SMMJitBuff[PortNum].Reset           =  0;
  SMMJitBuff[PortNum].ResetRdSeqNumber = 0;

  SMMJitBuff[PortNum].Rd_state        =  JIT_RD_STATE_UND;
  SMMJitBuff[PortNum].RTPThrCnt = 0;

  SMMJitBuff[PortNum].RxFrameFlag     =  0;
  SMMJitBuff[PortNum].NullPktCnt      =  0;
  SMMJitBuff[PortNum].FreeCellCnt     =  0;

  //--> Estimation Module Limits-----------------------------------------
#if AJB_USE_CLI_CONFIGURATIONS 
  AJBLoadCLIConf(PortNum);
#else
  InitDelayEst(PortNum);
#if AJB_ENABLE_STATISTICS
  InitAJBStat(PortNum);
#endif

#endif

  //----> JitInitFlag
  SMMJitBuff[PortNum].JitInitFlag  =  1;
#if AJB_ENABLE_STATISTICS
  SMMJitBuff[PortNum].RdErrFlag = ( SMMJitBuff[PortNum].RdErrFlag | 0x2000);
#endif

  /**************************************************************
       ->  END OF INITIALIZATION OF AJB, AFTER FIRST PACKET ARRIVAL
       ->  END_WT_JIT_PRE_INIT_FLAG
   **************************************************************/
  SMMJitBuff[PortNum].FreeCellCnt = JITBUFF_MAX_LEN;
  SMMJitBuff[PortNum].FreeRtpCnt = JITBUFF_MAX_LEN;
  memset(JitCellBitmap[PortNum],0,sizeof(JitCellBitmap[PortNum]));
  memset(JitBuffBitmap[PortNum],0,sizeof(JitBuffBitmap[PortNum]));
  SMMJitBuff[PortNum].TotalNULLPlayed = 0;
  return 0;
}

/*********************************************************************
        CALLER ID
**********************************************************************/
#if CALLER_IDTx
extern SLICInfo_t gaSlicInfo[MAX_SLIC_CHANNELS];

void CidTxPlay1(uWord16 PortNum)
{
  uWord16 i;
  SLICInfo_t *pSLIC = NULL;
  UINT16 uiCountry;

  if(SMM_CidTx[PortNum].CidTxState > CID_TX_STATE0 )
  {
    SMMJitBuff[PortNum].RxPktProp = JIT_NO_PACKET; 
    SMMJitBuff[PortNum].RxFrameLen = 0; 
    if( SMM_CidTx[PortNum].CidTxState == CID_TX_STATE2 )
    {
      if( SMM_CidTx[PortNum].CidTxFrameLen > 0)
      {
        if(ucG7115msIntrFlag[PortNum] == 1)
        {
          if(ucCallerIdIntrHandler[PortNum] == 0)
          {
            CidTxPlay(PortNum);
            mu_compress_short(SMM_CidTx[PortNum].CidTxPayLoad,
                                 SMM_CidTx[PortNum].CidTxPayLoad);
            for(i=0;i<40;i++)
              SMMJitBuff[PortNum].RxBuff[i] = SMM_CidTx[PortNum].CidTxPayLoad[i];
            SMMJitBuff[PortNum].RxPktProp =  CIDTX_PACKET;
            SMMJitBuff[PortNum].RxFrameLen = 40;  // CID_TX_PAY_LOAD_LEN;
            ucCallerIdIntrHandler[PortNum] = 1;
          }
          else if(ucCallerIdIntrHandler[PortNum] == 1)
          {
	      for(i=0;i<40;i++)
              SMMJitBuff[PortNum].RxBuff[i] = SMM_CidTx[PortNum].CidTxPayLoad[i+40];
            SMMJitBuff[PortNum].RxPktProp =  CIDTX_PACKET;
            SMMJitBuff[PortNum].RxFrameLen = 40;  // CID_TX_PAY_LOAD_LEN;
            ucCallerIdIntrHandler[PortNum] = 0;
          }
        }
        else
        {
          CidTxPlay(PortNum);
          mu_compress_short(SMM_CidTx[PortNum].CidTxPayLoad,
                                          SMM_CidTx[PortNum].CidTxPayLoad);
          for(i=0;i<80;i++)
             SMMJitBuff[PortNum].RxBuff[i] = SMM_CidTx[PortNum].CidTxPayLoad[i];
          SMMJitBuff[PortNum].RxPktProp =  CIDTX_PACKET;
          SMMJitBuff[PortNum].RxFrameLen = 80;  // CID_TX_PAY_LOAD_LEN;
        }
      }
      else
      {
        SMMJitBuff[PortNum].RxPktProp = JIT_NO_PACKET; // CIDTX_PACKET;
        SMMJitBuff[PortNum].RxFrameLen = 0; //CID_TX_PAY_LOAD_LEN;
        SMM_CidTx[PortNum].CidTxState = CID_TX_STATE3;
      }
    } //---->End of State2 Loop
    else if(SMM_CidTx[PortNum].CidTxState == CID_TX_STATE3)
    {
      SMMJitBuff[PortNum].RxPktProp = JIT_NO_PACKET; 
      SMMJitBuff[PortNum].RxFrameLen = 0; 
      SMM_CidTx[PortNum].TimerCntr++;
       if( SMM_CidTx[PortNum].TimerCntr >= END_OF_CID_DISPLAY)
			{
			dspipcCidTxPlayDone(PortNum);
			SMM_CidTx[PortNum].CidTxState = CID_TX_STATE0;
			SMM_CidTx[PortNum].TimerCntr = 0;
// Sagem ICC : Bug 3242 2006/01/09
            if (SMM_CidTx[PortNum].bVMWI == TRUE)
            {
               slicVoiceRingOff((UCHAR)PortNum, FALSE);
			/*FCLUZEAU*/
			dspipcVMWIPlayDone(PortNum);
            }
            else
            { 
    		    pSLIC = &gaSlicInfo[PortNum];
			    confGetCountryOpts(&uiCountry);
			    pSLIC->uiT4SCntr = confFirstCadenceOff(uiCountry) + 1;
		    }
		}
    }
  } //-------->End of CidTxState >State0 Loop
}
#endif  //-->end of CALLER_IDTx


/********************************************************************
MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
 * Function         : GetFreePkt
MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
********************************************************************/
int GetFreePkt(uWord16 PortNum)
{
  UINT32    index;
  if(GetFreeElement(JitCellBitmap[PortNum],JITBUFF_MAX_LEN,&index) == FAILURE)
    return FAILURE;
  JitPkt[PortNum][index].NextIndex = JIT_IND_NULL;
  osLockTasklet(PortNum);
  SMMJitBuff[PortNum].FreeCellCnt--;
  osUnlockTasklet(PortNum);
  return index;
}


/********************************************************************
MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
Function         : GetJitBuffPkt
MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
********************************************************************/
int GetJitBuffPkt(uWord16 PortNum)
{
  UINT32 index;
  INT16 result = GetFreeElement(JitBuffBitmap[PortNum],
                                    JITBUFF_MAX_LEN,&index);
  if(result == FAILURE)
  {
    return FAILURE;
  }
  JitBuff[PortNum][index].PktCnt     =  0;
  JitBuff[PortNum][index].PktIndex   =  JIT_IND_NULL;
  JitBuff[PortNum][index].NextIndex  =  JIT_IND_NULL;
  osLockTasklet(PortNum);
  SMMJitBuff[PortNum].FreeRtpCnt--;
  osUnlockTasklet(PortNum);
  return index;
}

/********************************************************************
MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
 * Function         : JitFreeMem()
MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM 
********************************************************************/
void JitFreeMem(uWord16 TempIndex ,uWord16 PortNum )
{
  uWord16 CellIndex,LoopCnt=0;
  uWord16 TempIndex1;
  /* Free all frame cells attached to this packet */
  if(TempIndex != JIT_IND_NULL)
  {
    CellIndex = JitBuff[PortNum][TempIndex].PktIndex;
    for(LoopCnt = 0; LoopCnt < JitBuff[PortNum][TempIndex].PktCnt;
               LoopCnt++)
    {
      if(CellIndex == JIT_IND_NULL)
      {
#ifdef AJB_DEBUG
        printk("It shsould not happen MAN \n");
#endif
        break;
      }
      TempIndex1 = CellIndex;
      CellIndex = JitPkt[PortNum][CellIndex].NextIndex;
      ReleaseRTPCell(PortNum, TempIndex1);
    }
    if( JitBuff[PortNum][TempIndex].PktProp == JIT_VAD_PACKET)
      SMMJitBuff[PortNum].PrevSidEnable -= 1;
    JitBuff[PortNum][TempIndex].PktCnt    =  0;
    JitBuff[PortNum][TempIndex].PktIndex  =  JIT_IND_NULL;
    JitBuff[PortNum][TempIndex].NextIndex =  JIT_IND_NULL;
    ReleaseRTPPkt(PortNum,TempIndex);
  }
}


/********************************************************************
* Function         : AJBSet                                         *
* I/P Parameters   : RdVoicePkt* RdVoicePktPtr                      *
* O/P Parameters   : NONE                                           *
* Return Values    : NONE                                           *
* Description      : This function contains implementation of the   *
*    jitter read operation.                                         *
********************************************************************/
void AJBSet(uWord16 PortNum, Word16 AjbRdIsrEventDur )
{
  AJBResetFlag[PortNum]             = 0;
  SMMJitBuff[PortNum].JitInitFlag   = 0;

  AJB_MIN_DELAY_MS[PortNum]  =  confGetJitterThreshold();
  ucJitterBuffType[PortNum] = confGetJBType();

#if DRV_DEBUG_STAT
  memset(&VoiceDebugStat[PortNum],0,sizeof(VoiceDebugStat[PortNum]));
  VoiceDebugStat[PortNum].bLog = TRUE;
#endif

#if AJB_ENABLE_STATISTICS
  SMMJitBuff[PortNum].RdErrFlag     = 0;
  SMMJitBuff[PortNum].WtErrFlag     = 0;
#endif
  //--> Isr Read event interval in ms.
  AJB_ISR_SCHEDULER_DURATION[PortNum]   =  AjbRdIsrEventDur;
  switch(AjbRdIsrEventDur )
  {
    case 5 : 
    //--> 5ms 
      SMMJitBuff[PortNum].SchTabelIndex = 0;
      AJBResetFlag[PortNum]             = 1;
      break;
    case 10 :
    //--> 10ms
      SMMJitBuff[PortNum].SchTabelIndex = 1;
      AJBResetFlag[PortNum]             = 1;
      break;
    default :
      printk("\r\nUNDEF_AJB_READ_RATE:%d",AjbRdIsrEventDur);
      return;
   }//--> End of Switch Statment.
}


void switchJitterBuffToFjb(UCHAR ucPortNum)
{
    /* BUG ID: 4456*/
    AJBSet(ucPortNum, AJB_READ_RATE_MS );
    AJB_MIN_DELAY_MS[ucPortNum]  =  confGetJitterPassThrThreshold();
    ucJitterBuffType[ucPortNum] = FJB;
}


inline void ReleaseRTPPkt(uWord16 PortNum, uWord16 TabWtIndex)
{
  ReleaseElement(JitBuffBitmap[PortNum],JITBUFF_MAX_LEN,TabWtIndex);
  osLockTasklet(PortNum);
  SMMJitBuff[PortNum].FreeRtpCnt++;
  osUnlockTasklet(PortNum);
}

inline void ReleaseRTPCell(uWord16 PortNum, uWord16 CellIndex)
{
  ReleaseElement(JitCellBitmap[PortNum],JITBUFF_MAX_LEN,CellIndex);
  osLockTasklet(PortNum);
  SMMJitBuff[PortNum].FreeCellCnt++;
  osUnlockTasklet(PortNum);
}

void AJBReset(uWord16 PortNum)
{
  AJBResetFlag[PortNum] = 0;
#if DRV_DEBUG_STAT
  VoiceDebugStat[PortNum].bLog = FALSE;
#endif
}

