
/**************************************************************
File Name       :   SinGen.c
Description     :   This file Sine Generation Routine
                    using the Taylor Series Method
Version Number  :   1.0
**************************************************************/

#include <oswrapper.h>
#include "ToneGenCons.h"

#if TONE_GEN

#define Mul(a,b) (((int) (a) * (int) (b)) << 1)
#define Round(a) ((Word16)(((a)+0x00008000L)>>16))

Word16 ToneGenSin(Word16 x,Word16 tone_scale)
{
	Word16	x1;
	uWord16 y,z;
	y = ((x & 0x4000) ? -x : x) & 0x7fff;
	z = y;
	x1 = Round(0x08B70000L+Mul(0x1CCE,y));
	x1 = Round(0xAACC0000L+Mul(x1,y));
	x1 = Round(0x00530000L+Mul(x1,y));
	x1 = Round(0x32400000L+Mul(x1,y));
	x1 = Round(0L+Mul(x1,y));
	//x1 = (x1 >> 1);	//to get 2048 as output
	x1 = Round(Mul(x1,tone_scale));
//	x1 = x1 * tone_scale;
	x1 = (x1 << 3);
	if (x1 < 0) y = 0x7fff;
	else y = x1;
	if (x<0) y = -y;
	return (y);
}

#endif
