/******************************************************************************
File Name	:   ToneGen.c
Description    	:   This file contains the API for Tone Generation module 	
Version Number	:   1.0	
******************************************************************************/
#include <oswrapper.h>
#include "ToneGenCons.h"
#include "Toneparam.h"
#include "ToneProto.h"
#include "ToneGenVar.h"


extern Word16 SMM_CadCnt[];
extern FOURCADENCE_TONE_TYPE ToneParams[];
extern Word16 SMM_continuousToneFlg[];

void InitUSATones(Word16 ToneVal, Word16 CurChanNum);
void InitFranceTones(Word16 ToneVal, Word16 CurChanNum);
void InitJapanTones(Word16 ToneVal, Word16 CurChanNum);
void InitKoreaTones(Word16 ToneVal, Word16 CurChanNum);
void InitDTMFTones(Word16 ToneVal, Word16 CurChanNum);
void InitRomaniaTones(Word16 ToneVal, Word16 CurChanNum);

//extern Word16 ToneArray[MAX_NUM_COUNTRY][MAX_NUM_TONES][6];
extern Word16 ToneArray[5][MAX_NUM_TONES][6];

extern UCHAR ucG7115msIntrFlag[];
Word16 *ToneBuffPtr,ToneVal;
Word16 SMM_continuousToneFlg[MAX_CHAN];
Word16 SMM_ToneEvtFlag[MAX_CHAN] = {0};
Word16 SMM_OldToneEvtFlag[MAX_CHAN] = {0};

uWord16 countryType;

extern void dspipcGenToneInDsp(unsigned portNum,
                        unsigned short ToneEvent,   //Tone or Pause Event
                        unsigned short phase1,      //Phase Advance value of Tone1
                        unsigned short phase2,      //Phase Advance value of Tone2
                        unsigned short amp1,        //Amplitude value of Tone1
                        unsigned short amp2);       //Amplitude value of Tone2


/******************************************************************************
Function Name	:	ToneGen()
Description	:	This function calculates the parameters for 
		        the Tone Generation module and calls the Assembly module
Input		: 	ToneTime
			PauseTime
			ToneGen_Phase1
			ToneGen_Phase2
			ToneGen_Scale1
			ToneGen_Scale2
			TonePrevTime
			PausePrevTime
Output		:	speech[]
Version		:	1.0
******************************************************************************/

void ToneGen(Word16 CurChanNum, Word16 ucToneLen)
{    	

        if(SMM_ToneGenEna[CurChanNum] != TONE_GEN_ACTIVE )
  		return;  
    			
        //--> To continuosly generate configured Tones 
	if(( SMM_ToneGenState[CurChanNum] == TONE2DECODER )||(SMM_ToneGenState[CurChanNum] == TONE_CYCLE_END))
	{


                if(SMM_bUseGeneric[CurChanNum]==1)
          	{
                  if(ucG7115msIntrFlag[CurChanNum] == 1)
                  {
			if(SMM_CadPlayStopFlag[CurChanNum]==1)
			{
			     SMM_ToneDurationCntr[CurChanNum]++;
			if(ToneParams[CurChanNum].ulCadenceDuration== (SMM_ToneDurationCntr[CurChanNum]/2))
			   SMM_CadPlayStopFlag[CurChanNum]=2;
		        }
                  }
		  else
		  {
	                if(SMM_CadPlayStopFlag[CurChanNum]==1)
			{
		          SMM_ToneDurationCntr[CurChanNum]++;
		     	if(ToneParams[CurChanNum].ulCadenceDuration==SMM_ToneDurationCntr[CurChanNum])
			   SMM_CadPlayStopFlag[CurChanNum]=2;
			}	

		  }
          	   
          	    ToneGenGeneral(CurChanNum);

		  }
		 else
		 {
        

		/** USA TONES FSM **/
		if(countryType == TONE_GEN_USA)
		{
			if((SMM_ToneType[CurChanNum] == STUTTER_TONE)&&(SMM_StutterToneCntr[CurChanNum] < 10))
			   SMM_StutterToneCntr[CurChanNum]++;

			//if((SMM_ToneType[CurChanNum] != DIAL_TONE)&&(SMM_ToneType[CurChanNum] < DIG_0_TONE))
			if(SMM_ToneType[CurChanNum] != DIAL_TONE)
			   ToneInit(CurChanNum);

		}


    // General API for for sending one cadence irrespective of the country 
       // if(SMM_continuousToneFlg[CurChanNum]!=CONTINUOUS_TONE)
	  //ToneInitGeneral(unsigned ToneCad, unsigned CurChan,unsigned ContFlag, unsigned bPha3 ,unsigned bPha4);
    
		if(countryType == TONE_GEN_ROMANIA)
		{

		    if((SMM_ToneType[CurChanNum] == SPL_DIAL_TONE))
		     SMM_SplDlToneCntr[CurChanNum]++;

			
			

                  if(SMM_ToneType[CurChanNum] == CALL_WAITING_TONE1)
		   {
			  SMM_CallWaitingCntr[CurChanNum]++;
			  //--> Generate 1 burst of with required ON Time
			  //--> and then proceed with normal voice processing
			  if(SMM_CallWaitingCntr[CurChanNum] == 2)
			  {
				 SMM_CallWaitingCntr[CurChanNum] = 0;
				 SMM_ToneGenEna[CurChanNum] = TONE_GEN_INACTIVE;
			  }		   
		   }
			
			//if((SMM_ToneType[CurChanNum] != DIAL_TONE)&&(SMM_ToneType[CurChanNum] < DIG_0_TONE))
			if((SMM_ToneType[CurChanNum] != DIAL_TONE) ||(SMM_SplDlToneCntr[CurChanNum] <3))
			   ToneInit(CurChanNum);

			

		}
	

		/** FRANCE TONES FSM **/
                if(countryType == TONE_GEN_FRANCE)
		{
			if(SMM_ToneType[CurChanNum] == MESG_WAITING_INDICATOR_TONE)
				SMM_MesgIndToneCntr[CurChanNum]++;
			
			if(SMM_ToneType[CurChanNum] == ROC_TONE)
			    SMM_RocToneCntr[CurChanNum]++;

			if(SMM_ToneType[CurChanNum] == VOIP_DIAL_TONE)
				VOIPDailToneCntr[CurChanNum]++;

			if(SMM_ToneType[CurChanNum] == SPL_INFO_TONE)
				SMM_SplInfoToneCntr[CurChanNum]++;

                        if(SMM_ToneType[CurChanNum] != SPECIAL_DIAL_TONE)
                               ToneInit(CurChanNum);
		}

		/** KOREA TONES FSM **/
		if(countryType == TONE_GEN_KOREA)
		{
		  if((SMM_ToneType[CurChanNum] != DIAL_TONE)&&(SMM_ToneType[CurChanNum] != BIT_TONE)
                                                      && (SMM_ToneType[CurChanNum] != IMM_RING_BACK_TONE))
			 ToneInit(CurChanNum);
		}

		/** JAPAN TONES FSM **/
                if(countryType == TONE_GEN_JAPAN)
		{

		   if((SMM_ToneType[CurChanNum] == WAITING_TONE_I)||(SMM_ToneType[CurChanNum] == WAITING_TONE_II)
                                                      ||(SMM_ToneType[CurChanNum] == WAITING_TONE_II_1))
		   {
			  SMM_WaitingToneCntr[CurChanNum]++;
			  //--> Generate 1 burst of required ON Time
			  //--> each separated by required OFF Time
			  //--> and then proceed with normal voice processing
			  if(SMM_WaitingToneCntr[CurChanNum] == 2)
			  {
				 SMM_WaitingToneCntr[CurChanNum] = 0;
				 SMM_ToneGenEna[CurChanNum] = TONE_GEN_INACTIVE;
			  }
		   }

		   if((SMM_ToneType[CurChanNum] == CALL_WAITING_TONE1)||(SMM_ToneType[CurChanNum] == CALL_WAITING_TONE3))
		   {
			  SMM_CallWaitingCntr[CurChanNum]++;
			  if(SMM_CallWaitingCntr[CurChanNum] == 5)
			  {
				 SMM_CallWaitingCntr[CurChanNum] = 0;
				 SMM_ToneGenEna[CurChanNum] = TONE_GEN_INACTIVE;
			  }			
		   }

		   if((SMM_ToneType[CurChanNum] == PAY_TONE_I)||(SMM_ToneType[CurChanNum] == PAY_TONE_II))
		   {
			  SMM_ToneGenEna[CurChanNum] = TONE_GEN_INACTIVE;
		   }

		   if(SMM_ToneType[CurChanNum] == POSITIVE_INDI_TONE)
		   {
			  SMM_PosIndToneCntr[CurChanNum]++;
			  if(SMM_PosIndToneCntr[CurChanNum] == 2)
			  {
				 SMM_PosIndToneCntr[CurChanNum] = 0;
				 SMM_ToneGenEna[CurChanNum] = TONE_GEN_INACTIVE;
			  }
		   }

		   if((SMM_ToneType[CurChanNum] != DIAL_TONE)||(SMM_ToneType[CurChanNum] != RECALL_DIAL_TONE))
			   ToneInit(CurChanNum);

		}//end of JAPAN FSM


		/**********************************************************
		  CallWaiting Characteristic common for USA/FRANCE/KOREA
		  For example give a beep every 10 seconds and proceed with
		  normal voice processing until CallWaiting is Quit by the
		  application
		***********************************************************/
		if((countryType == TONE_GEN_USA)||(countryType == TONE_GEN_FRANCE)||(countryType == TONE_GEN_KOREA))
		{
		   //--> CALL WAITING TONE CONFIGURATION <--//
		   if(SMM_ToneType[CurChanNum] == CALL_WAITING_TONE1)
		   {
			  SMM_CallWaitingCntr[CurChanNum]++;
			  //--> Generate 1 burst of with required ON Time
			  //--> and then proceed with normal voice processing
			  if(SMM_CallWaitingCntr[CurChanNum] == 1)
			  {
				 SMM_CallWaitingCntr[CurChanNum] = 0;
				 SMM_ToneGenEna[CurChanNum] = TONE_GEN_INACTIVE;
			  }		   
		   }
		}


		 	}
		/*************************************************************
	          CPE Altering Signal TONE CONFIGURATION for OffHook CallerID
		  Common for All countries
		**************************************************************/
                 if(SMM_ToneType[CurChanNum] == CPE_ALERTING_TONE)
                    SMM_ToneGenEna[CurChanNum] = TONE_GEN_INACTIVE;

#if 0 //Application will Quit the Tone instead of Quitting automatically
		/*************************************************************
		  FSM for Generation of DTMF Tones. Once a DTMF Tone is 
		  generated for a particular digit, quit the tone automatically
                **************************************************************/
 		if((SMM_ToneType[CurChanNum] >= DIG_0_TONE)&&(SMM_ToneType[CurChanNum] <= DIG_HASH_TONE))
		{
			SMM_ToneGenEna[CurChanNum] = TONE_GEN_INACTIVE;
			SMM_ToneDuration[CurChanNum] = 0;
		}
#endif

	}//end of TONE2DECODER / TONE_CYCLE_END case
       									//---> Get Current Channel Instance    		
        ToneGen_GetCurChan_Instance(CurChanNum);


        /***************************************************************
         FSM to calculate the remaining number of TONE/PAUSE samples
         for Tone generation.
        ***************************************************************/

	   //check for continuous Tone Flag is set or not
	   if(SMM_continuousToneFlg[CurChanNum]  == CONTINUOUS_TONE)
	   {
                //SMM_ToneEvtFlag[CurChanNum] = TONE_EVENT; //Tone Flag
		ToneGenState = TONE;
		ToneSampCnt = ucToneLen;
		PauseSampCnt = 0;
	   }
	   else
	   {

	       ToneRemSampleCtr   = ToneSampleCtr  - TonePrevSampleCtr;
	       PauseRemSampleCtr  = PauseSampleCtr - PausePrevSampleCtr;
	    
	                   
	       if(ToneRemSampleCtr  > ucToneLen )
	       {
		 //--> TONE state
                 //SMM_ToneEvtFlag[CurChanNum] = TONE_EVENT; //Tone Flag
		 ToneGenState   =  TONE;
		 TonePrevSampleCtr   =  TonePrevSampleCtr + ucToneLen;
		 ToneSampCnt     =  ucToneLen;
		 PauseSampCnt    =  0;
	       }     							//--> End of ToneON State
	       else
	       {
		  //--> May be Tone2Pause (or) Pause state
		  if( ToneRemSampleCtr > 0 )
		  {
			// --> Tone2Phase
                        //SMM_ToneEvtFlag[CurChanNum] = TONE_EVENT; //Tone Flag
		 	ToneGenState  =    TONE2PAUSE;
	                ToneSampCnt  =    ToneRemSampleCtr;
			PauseSampCnt =    ucToneLen - ToneRemSampleCtr;
			PausePrevSampleCtr =    PausePrevSampleCtr + PauseSampCnt;
			TonePrevSampleCtr   =   TonePrevSampleCtr + ToneSampCnt;
		   }
	           else
		   {

                        //SMM_ToneEvtFlag[CurChanNum] = PAUSE_EVENT; //Tone Flag

		        ToneSampCnt  =    ToneRemSampleCtr;
		        //--> Pause state
		        if (PauseRemSampleCtr > ucToneLen )
			{
			   //--> Pause state
			   ToneGenState = PAUSE;
			   PauseSampCnt  =    ucToneLen;
			   PausePrevSampleCtr  =    PausePrevSampleCtr + ucToneLen;
		        }//---> End of pause state.
			else
			{
			    //--> End of Pause State
			    if(PauseRemSampleCtr > 0)
			    {
				ToneGenState   =    TONE_CYCLE_END;
				PauseSampCnt   =    ucToneLen;
				PauseRemSampleCtr  =    PauseRemSampleCtr + ucToneLen;
			    }
			    else
			    {
				ToneGenState   =    TONE2DECODER;
				PauseSampCnt   =    0;

                                if(countryType == TONE_GEN_FRANCE)
			        {
				   if((SMM_ToneType[CurChanNum] == MESG_WAITING_INDICATOR_TONE)||
                                                        (SMM_ToneType[CurChanNum] == VOIP_DIAL_TONE))
				   {
				       ToneGenState = TONE_CYCLE_END;
				       ToneSampCnt = ucToneLen;
				       PauseSampCnt = 0;
				   }
				}
		             }
			 }//--> PauseRemTime else case
	
		      }	//---> ToneRemTime else case
		   }	//--> End of May be Tone2Pause (or)
			//--> Pause state
		}//--> End of else part

        if(countryType == TONE_GEN_FRANCE)
	{
            if(SMM_ToneType[CurChanNum] == ROC_TONE)  //vijay 23/12/03
            {
               if(SMM_RocToneCntr[CurChanNum] == -1)
               {
                 SMM_RocToneCntr[CurChanNum] = 0;
                 ToneGenState = TONE2DECODER; 
               }
            }
	}


	if(ToneGenState != TONE2DECODER )
	{
#if 1
	    ToneGeneration(ucToneLen);  // Generation of both Tone and Silence
#else
            if(SMM_ToneEvtFlag[CurChanNum] != SMM_OldToneEvtFlag[CurChanNum])
            { 
               SMM_OldToneEvtFlag[CurChanNum] = SMM_ToneEvtFlag[CurChanNum];
               dspipcGenToneInDsp(CurChanNum,SMM_ToneEvtFlag[CurChanNum],ToneGen_Phase1,ToneGen_Phase2,
                                          ToneGen_Scale1,ToneGen_Scale2);
            }
#endif

        } //--> If ToneGenState != TONE2DECODER

	//---> Update Channel Instances
	ToneGen_PutCurChan_Instance(CurChanNum);

  }//--> end of Tone Generation Module


/******************************************************************************
Function Name		:	ToneGen_GetCurChan_Instance()
Description		:	This function gets the channel instances for 
				Tone Generation module
Input			: 	none						
Output			:	none
Version			:	1.0
*****************************************************************************/

void ToneGen_GetCurChan_Instance(Word16 CurChanNum)
{

   ToneSampleCtr  	=  SMM_ToneSampleCtr[CurChanNum];
   PauseSampleCtr   	=  SMM_PauseSampleCtr[CurChanNum];
		
   TonePrevSampleCtr   	=  SMM_TonePrevSampleCtr[CurChanNum];
   PausePrevSampleCtr  	=  SMM_PausePrevSampleCtr[CurChanNum];
		
   ToneGen_Phase1 	=  SMM_ToneGen_Phase1[CurChanNum];
   ToneGen_Phase2 	=  SMM_ToneGen_Phase2[CurChanNum];
   ToneGen_Scale1 	=  SMM_ToneGen_Scale1[CurChanNum];
   ToneGen_Scale2 	=  SMM_ToneGen_Scale2[CurChanNum];
   ToneGen_Phasetemp[0] =  SMM_ToneGen_Phasetemp[CurChanNum][0];
   ToneGen_Phasetemp[1] =  SMM_ToneGen_Phasetemp[CurChanNum][1];


   if(countryType == TONE_GEN_KOREA)
   {
	 ToneGen_Phase3  	=  SMM_ToneGen_Phase3[CurChanNum];
	 ToneGen_Phase4  	=  SMM_ToneGen_Phase4[CurChanNum];
	 ToneGen_Scale3  	=  SMM_ToneGen_Scale3[CurChanNum];
	 ToneGen_Scale4  	=  SMM_ToneGen_Scale4[CurChanNum];
	 ToneGen_Phasetemp1[0]  =  SMM_ToneGen_Phasetemp1[CurChanNum][0];
	 ToneGen_Phasetemp1[1]  =  SMM_ToneGen_Phasetemp1[CurChanNum][1];
   }
  
   if(countryType == TONE_GEN_ROMANIA)
   {
	 ToneGen_Phase3  	=  SMM_ToneGen_Phase3[CurChanNum];
	
	 ToneGen_Scale3  	=  SMM_ToneGen_Scale3[CurChanNum];
	
	 ToneGen_Phasetemp1[0]  =  SMM_ToneGen_Phasetemp1[CurChanNum][0];
	 
   }

}		

/******************************************************************************
Function Name		:	ToneGen_PutCurChan_Instance()
Description		:	This function updates the channel instances.
Input			: 	none						
Output			:	none
Version			:	1.0
*****************************************************************************/

void ToneGen_PutCurChan_Instance(Word16 CurChanNum)
{

	SMM_ToneSampleCtr[CurChanNum] 		=  ToneSampleCtr;
	SMM_PauseSampleCtr[CurChanNum] 		=  PauseSampleCtr;
	SMM_ToneGen_Phase1[CurChanNum] 		=  ToneGen_Phase1;
	SMM_ToneGen_Phase2[CurChanNum] 		=  ToneGen_Phase2;
	SMM_ToneGen_Scale1[CurChanNum] 		=  ToneGen_Scale1;
	SMM_ToneGen_Scale2[CurChanNum] 		=  ToneGen_Scale2;
	SMM_TonePrevSampleCtr[CurChanNum] 	=  TonePrevSampleCtr;
	SMM_PausePrevSampleCtr[CurChanNum] 	=  PausePrevSampleCtr;
	SMM_ToneGenState[CurChanNum] 		=  ToneGenState;
	SMM_ToneGen_Phasetemp[CurChanNum][0] 	=  ToneGen_Phasetemp[0];
	SMM_ToneGen_Phasetemp[CurChanNum][1] 	=  ToneGen_Phasetemp[1];

   if(countryType == TONE_GEN_KOREA)
   {

	 SMM_ToneGen_Phase3[CurChanNum] 	=  ToneGen_Phase3;
	 SMM_ToneGen_Phase4[CurChanNum] 	=  ToneGen_Phase4;
	 SMM_ToneGen_Scale3[CurChanNum] 	=  ToneGen_Scale3;
	 SMM_ToneGen_Scale4[CurChanNum] 	=  ToneGen_Scale4;
	 SMM_ToneGen_Phasetemp1[CurChanNum][0] 	=  ToneGen_Phasetemp1[0];
	 SMM_ToneGen_Phasetemp1[CurChanNum][1] 	=  ToneGen_Phasetemp1[1];		
   }
   
   if(countryType == TONE_GEN_ROMANIA)
   {

	 SMM_ToneGen_Phase3[CurChanNum] 	=  ToneGen_Phase3;	
	 SMM_ToneGen_Scale3[CurChanNum] 	=  ToneGen_Scale3;	
	 SMM_ToneGen_Phasetemp1[CurChanNum][0] 	=  ToneGen_Phasetemp1[0];
	
   }
 
}		

/******************************************************************************
Function Name	:ToneInit()
Description	:This function initializes all the parameters
		 required by the Tone Generation module.
Input		:countryType,ToneVal
Output		:none
******************************************************************************/

void ToneInit(Word16 CurChanNum)
 {

#if 0
    getCountryOpts(&countryType);
    printf("\rCountryType = %d \n",countryType);
    if(countryType > MAX_NUM_COUNTRY)
    {
       countryType = 0; //assign Default Country type = USA
       printf("\rUNKNOWN CountryType for TONES, set to Default(USA)\n");
    }
#endif

    //added by Vijay 22/04/04
    SMM_OldToneEvtFlag[CurChanNum] = -1;
    SMM_ToneEvtFlag[CurChanNum] = 0;

    //default set to Non Continuous Tone
    SMM_continuousToneFlg[CurChanNum] = NON_CONTINUOUS_TONE;

	ToneVal = SMM_ToneType[CurChanNum];
	switch(countryType)
	{
	  case TONE_GEN_USA:
		  if(ToneVal <= MAXTONES_USA)
		    InitUSATones(ToneVal,CurChanNum);
		  else
		  {
		     DEBUG(PRINT("\rUnknown ToneVal = %x for Country = USA\n",
                           ToneVal), DEBUG_INFO);
		     return;
		  }
		  break;

	  case TONE_GEN_FRANCE:
		  if(ToneVal <= MAXTONES_FRANCE)
		     InitFranceTones(ToneVal,CurChanNum);
		  else
		  {
		     DEBUG(PRINT("\rUnknown ToneVal = %x for Country = FRANCE\n",ToneVal), DEBUG_INFO);
		     return;
		  }
		  break;

	  case TONE_GEN_JAPAN:
		  if(ToneVal <= MAXTONES_JAPAN)
		     InitJapanTones(ToneVal,CurChanNum);
		  else
		  {
		     DEBUG(PRINT("\rUnknown ToneVal = %x for Country = JAPAN\n", ToneVal), DEBUG_INFO);
		     return;
		  }
		  break;

	  case TONE_GEN_KOREA:
		  if(ToneVal <= MAXTONES_KOREA)
		     InitKoreaTones(ToneVal,CurChanNum);
		  else
		  {
		     DEBUG(PRINT("\rUnknown ToneVal = %x for Country = KOREA\n", ToneVal), DEBUG_INFO);
		     return;
		  }
		  break;

	    case TONE_GEN_ROMANIA:
		  if(ToneVal <= MAXTONES_ROMANIA)
		     InitRomaniaTones(ToneVal,CurChanNum);
		  else
		  {
		     DEBUG(PRINT("\rUnknown ToneVal = %x for Country = Romania\n", ToneVal), DEBUG_INFO);
		     return;
		  }
		  break;

	  default:
		   //Give Error Message for Unknown Country Type
		   DEBUG(PRINT(" Unknown Country Opt for Tone \n"), DEBUG_INFO);
		   break;
	}

	/** Initialize the ToneGeneration Core Variables **/
	SMM_ToneSampleCtr[CurChanNum]	     = *ToneBuffPtr++ << 3; //--> ms to Sample Count
	SMM_PauseSampleCtr[CurChanNum] 	     = *ToneBuffPtr++ << 3; //--> ms to Sample Count
	SMM_ToneGen_Phase1[CurChanNum]       = *ToneBuffPtr++ ;	//Phase1
	SMM_ToneGen_Phase2[CurChanNum]       = *ToneBuffPtr++ ; //Phase2
	SMM_ToneGen_Scale1[CurChanNum]       = *ToneBuffPtr++ ; //Amp1
	SMM_ToneGen_Scale2[CurChanNum]       = *ToneBuffPtr++ ; //Amp2
	SMM_TonePrevSampleCtr[CurChanNum]    = 0; //Counter to maintain Remaining Tone samples
	SMM_PausePrevSampleCtr[CurChanNum]   = 0; //Counter to maintain Remaining Pause samples
	SMM_ToneGenState[CurChanNum]	     = INACTIVE; //Initial State
	SMM_ToneGen_Phasetemp[CurChanNum][0] = 0; //Accumulated Phase of Phase1
	SMM_ToneGen_Phasetemp[CurChanNum][1] = 0; //Accumulated Phase of Phase2


  }//end of ToneInit()

/**************************************************************
Function Name	:InitUSATones()
Description	:This function initializes all the parameters
		 required by the Tone Generation module for
		 USA Country type.
Input		:ToneVal
Output		:none
**************************************************************/

void InitUSATones(Word16 ToneVal, Word16 CurChanNum)
{

   if((ToneVal >= DIG_0_TONE)&&(ToneVal <= DIG_HASH_TONE))
      InitDTMFTones(ToneVal,CurChanNum);   
   else
   {
     switch(ToneVal)
     {
	/*case TEST_1K_TONE :       				  
            ToneBuffPtr = Test1Buff;
	    break;*/

	case DIAL_TONE:
		//ToneBuffPtr = (Word16 *) DialBuff;
		ToneBuffPtr = (Word16 *) ToneArray[countryType][DIAL_TONE];
		SMM_continuousToneFlg[CurChanNum] = CONTINUOUS_TONE; //Flag for continuous tone
		break;

	case RING_BACK_TONE:
		//ToneBuffPtr = (Word16 *) RingBackBuff;
		ToneBuffPtr = (Word16 *) ToneArray[countryType][RING_BACK_TONE];
		break;
	case BUSY1_TONE:
		//ToneBuffPtr = (Word16 *) Busy1Buff;
		ToneBuffPtr = (Word16 *) ToneArray[countryType][BUSY1_TONE];
		break;

	case BUSY2_TONE:
		//ToneBuffPtr = (Word16 *) Busy2Buff;
		ToneBuffPtr = (Word16 *) ToneArray[countryType][BUSY2_TONE];
		break;

        case CALL_WAITING_TONE1:
	        //case CALL_WAITING_TONE2:  --> Make sure this Tone is now not used in application
		//ToneBuffPtr = (Word16 *) CallWaitingBuff;
		ToneBuffPtr = (Word16 *) ToneArray[countryType][CALL_WAITING_TONE1];
		break;

        case REORDER_TONE:
                //ToneBuffPtr = (Word16 *) ReorderBuff;
		ToneBuffPtr = (Word16 *) ToneArray[countryType][REORDER_TONE];
                break;

        case STUTTER_TONE:
                //--> After 10 bursts of Stutter Tone
                //--> Generate continuous Dial Tone
                if(SMM_StutterToneCntr[CurChanNum] < 10)
                     //ToneBuffPtr = (Word16 *) StutterBuff;
		     ToneBuffPtr = (Word16 *) ToneArray[countryType][STUTTER_TONE];					    
                else
		{
                     //ToneBuffPtr = (Word16 *) DialBuff;
		     SMM_continuousToneFlg[CurChanNum] = CONTINUOUS_TONE;
		     ToneBuffPtr = (Word16 *) ToneArray[countryType][DIAL_TONE];
		}
                break;

        case OFFHOOK_WARNING_TONE:
                //ToneBuffPtr = (Word16 *) OffHookWarnBuff;
		ToneBuffPtr = (Word16 *) ToneArray[countryType][OFFHOOK_WARNING_TONE];
                break;

	case MELODY_TONE:
		if(SMM_MelodyToneCntr[CurChanNum] == 0)
		        //ToneBuffPtr = (Word16 *) MelodyToneBuff1;
		        ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 0];
		else if(SMM_MelodyToneCntr[CurChanNum] == 1)
			//ToneBuffPtr = (Word16 *) MelodyToneBuff2;
			ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 1];
		else if(SMM_MelodyToneCntr[CurChanNum] == 2)
			//ToneBuffPtr = (Word16 *) MelodyToneBuff3;
			ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 2];
		else if(SMM_MelodyToneCntr[CurChanNum] == 3)
			//ToneBuffPtr = (Word16 *) MelodyToneBuff4;
			ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 3];
		else if(SMM_MelodyToneCntr[CurChanNum] == 4)
			//ToneBuffPtr = (Word16 *) MelodyToneBuff5;
			ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 4];
		else if(SMM_MelodyToneCntr[CurChanNum] == 5)
			//ToneBuffPtr = (Word16 *) MelodyToneBuff6;
			ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 5];

		if(SMM_MelodyToneCntr[CurChanNum] == 5)
			SMM_MelodyToneUpDonwFlag[CurChanNum] = 1;	//Tones Descending Flag
		else if(SMM_MelodyToneCntr[CurChanNum] == 0)
			SMM_MelodyToneUpDonwFlag[CurChanNum] = 0;	//Tones Ascending Flag

		if(SMM_MelodyToneUpDonwFlag[CurChanNum] == 0)
	        	SMM_MelodyToneCntr[CurChanNum]++;
	        else
			SMM_MelodyToneCntr[CurChanNum]--;

       		break;

	case CPE_ALERTING_TONE:
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][CPE_ALERTING_TONE];
		break;

	default:
	        //Give Error Message Indicating unknown ToneVal
	        //printf("\rUnknown ToneVal for Country = USA\n");
		break;
      }//end of switch case
   }//end of else case
}//end of InitUSATones()

/******************************************************************
Function Name	:   InitDTMFTones()
Description	:   This function initializes all the parameters
		    required by the Tone Generation module for
		    generating DTMF Tones
	            This API is common for all Country types
		    namely USA,FRANCE,JAPAN,KOREA
Input		:   ToneVal
Output		:   none
******************************************************************/

void InitDTMFTones(Word16 ToneVal, Word16 CurChanNum)
{

   //vijay 20/04/04
   //Application will quit the tone instead of quitting
   //automatially.
   SMM_continuousToneFlg[CurChanNum]  = CONTINUOUS_TONE;

   switch(ToneVal)
   {
	case DIG_1_TONE:
		ToneBuffPtr = (Word16 *) ToneArray[countryType][DIG_1_TONE];
		break;

	case DIG_2_TONE:
		ToneBuffPtr = (Word16 *) ToneArray[countryType][DIG_2_TONE];
		break;

	case DIG_3_TONE:
		ToneBuffPtr = (Word16 *) ToneArray[countryType][DIG_3_TONE];
		break;

        case DIG_4_TONE:
		ToneBuffPtr = (Word16 *) ToneArray[countryType][DIG_4_TONE];
		break;

        case DIG_5_TONE:
		ToneBuffPtr = (Word16 *) ToneArray[countryType][DIG_5_TONE];
		break;

	case DIG_6_TONE:
		ToneBuffPtr = (Word16 *) ToneArray[countryType][DIG_6_TONE];
		break;

	case DIG_7_TONE:
		ToneBuffPtr = (Word16 *) ToneArray[countryType][DIG_7_TONE];
		break;

	case DIG_8_TONE:
		ToneBuffPtr = (Word16 *) ToneArray[countryType][DIG_8_TONE];
		break;

	case DIG_9_TONE:
		ToneBuffPtr = (Word16 *) ToneArray[countryType][DIG_9_TONE];
		break;

	case DIG_A_TONE:
		ToneBuffPtr = (Word16 *) ToneArray[countryType][DIG_A_TONE];
		break;

	case DIG_B_TONE:
		ToneBuffPtr = (Word16 *) ToneArray[countryType][DIG_B_TONE];
		break;

	case DIG_C_TONE:
		ToneBuffPtr = (Word16 *) ToneArray[countryType][DIG_C_TONE];
		break;

	case DIG_D_TONE:
		ToneBuffPtr = (Word16 *) ToneArray[countryType][DIG_D_TONE];
		break;

	case DIG_STAR_TONE:
		ToneBuffPtr = (Word16 *) ToneArray[countryType][DIG_STAR_TONE];
		break;

	case DIG_0_TONE:
		ToneBuffPtr = (Word16 *) ToneArray[countryType][DIG_0_TONE];
		break;

        case DIG_HASH_TONE:
		ToneBuffPtr = (Word16 *) ToneArray[countryType][DIG_HASH_TONE];
		break;

    }//end of switch case
}//end of InitDTMFTones()

/**************************************************************
Function Name   :InitFranceTones()
Description     :This function initializes all the parameters
                 required by the Tone Generation module for
                 FRANCE Country type.
Input           :ToneVal
Output          :none
**************************************************************/
//extern Word16 v_amp_test_tone,v_freq_test_tone;
void InitFranceTones(Word16 ToneVal, Word16 CurChanNum)
{
	
   if((ToneVal >= DIG_0_TONE)&&(ToneVal <= DIG_HASH_TONE))
      InitDTMFTones(ToneVal, CurChanNum);   
   else
   {
     switch(ToneVal)
     {
	/*case TEST_1K_TONE :       				  
            ToneBuffPtr = Test1Buff;
        break;*/
	case DIAL_TONE:
//		ToneBuffPtr = (Word16 *) DialBuff;
		ToneBuffPtr = (Word16 *) ToneArray[countryType][DIAL_TONE];
		SMM_continuousToneFlg[CurChanNum] = CONTINUOUS_TONE;
		break;
	case RING_BACK_TONE:
		//ToneBuffPtr = (Word16 *) RingBackBuff;
		ToneBuffPtr = (Word16 *) ToneArray[countryType][RING_BACK_TONE];
		break;
	case BUSY1_TONE:
		//ToneBuffPtr = (Word16 *) Busy1Buff;
		ToneBuffPtr = (Word16 *) ToneArray[countryType][BUSY1_TONE];
		break;
        case BUSY2_TONE:
	//case ERROR_TONE:
		//ToneBuffPtr = (Word16 *) Busy2Buff;
		ToneBuffPtr = (Word16 *) ToneArray[countryType][BUSY2_TONE];
		break;
        case CALL_WAITING_TONE1:
		//case CALL_WAITING_TONE2:  --> Make sure this Tone is now not used in application
		//ToneBuffPtr = (Word16 *) CallWaitingBuff;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][CALL_WAITING_TONE1];
		break;
	case OFFHOOK_WARNING_TONE:
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][OFFHOOK_WARNING_TONE];
		break;

	case MELODY_TONE:
		if(SMM_MelodyToneCntr[CurChanNum] == 0)
		        //ToneBuffPtr = (Word16 *) MelodyToneBuff1;
			ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 0];
		else if(SMM_MelodyToneCntr[CurChanNum] == 1)
			//ToneBuffPtr = (Word16 *) MelodyToneBuff2;
			ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 1];
		else if(SMM_MelodyToneCntr[CurChanNum] == 2)
			//ToneBuffPtr = (Word16 *) MelodyToneBuff3;
			ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 2];
		else if(SMM_MelodyToneCntr[CurChanNum] == 3)
			//ToneBuffPtr = (Word16 *) MelodyToneBuff4;
			ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 3];
		else if(SMM_MelodyToneCntr[CurChanNum] == 4)
			//ToneBuffPtr = (Word16 *) MelodyToneBuff5;
			ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 4];
		else if(SMM_MelodyToneCntr[CurChanNum] == 5)
			//ToneBuffPtr = (Word16 *) MelodyToneBuff6;
			ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 5];

	        if(SMM_MelodyToneCntr[CurChanNum] == 5)
			SMM_MelodyToneUpDonwFlag[CurChanNum] = 1;	//Tones Descending Flag
		else if(SMM_MelodyToneCntr[CurChanNum] == 0)
			SMM_MelodyToneUpDonwFlag[CurChanNum] = 0;	//Tones Ascending Flag

		if(SMM_MelodyToneUpDonwFlag[CurChanNum] == 0)
	        	SMM_MelodyToneCntr[CurChanNum]++;
	        else
		        SMM_MelodyToneCntr[CurChanNum]--;

       		break;

        case SPECIAL_DIAL_TONE:
                //ToneBuffPtr = (Word16 *) SpecialDialBuff;
	        SMM_continuousToneFlg[CurChanNum] = CONTINUOUS_TONE;
		ToneBuffPtr = (Word16 *) ToneArray[countryType][SPECIAL_DIAL_TONE];
                break;
        case ROC_TONE:
	        if(SMM_RocToneCntr[CurChanNum] == 0)
	            ToneBuffPtr = (Word16 *) ToneArray[countryType][ROC_TONE  + 0];
	        else if(SMM_RocToneCntr[CurChanNum] == 1)
		    ToneBuffPtr = (Word16 *) ToneArray[countryType][ROC_TONE  + 1];
		else if(SMM_RocToneCntr[CurChanNum] == 2)
		    ToneBuffPtr = (Word16 *) ToneArray[countryType][ROC_TONE  + 2];
		else if(SMM_RocToneCntr[CurChanNum] == 3)
		    ToneBuffPtr = (Word16 *) ToneArray[countryType][ROC_TONE  + 0];
		else if(SMM_RocToneCntr[CurChanNum] == 4)
		    ToneBuffPtr = (Word16 *) ToneArray[countryType][ROC_TONE  + 3];
		else if(SMM_RocToneCntr[CurChanNum] == 5)
		    ToneBuffPtr = (Word16 *) ToneArray[countryType][ROC_TONE  + 0];
                else
                {
                    SMM_RocToneCntr[CurChanNum] = -1;
                    SMM_ToneGenEna[CurChanNum] = TONE_GEN_INACTIVE;
                    ToneBuffPtr = (Word16 *) ToneArray[countryType][ROC_TONE  + 0];
                }   
                break;     
         case SPL_INFO_TONE:
		if(SMM_SplInfoToneCntr[CurChanNum] == 0)
			ToneBuffPtr = (Word16 *) ToneArray[countryType][SPL_INFO_TONE + 0];
		else if(SMM_SplInfoToneCntr[CurChanNum] == 1)
			ToneBuffPtr = (Word16 *) ToneArray[countryType][SPL_INFO_TONE + 1];
		else if(SMM_SplInfoToneCntr[CurChanNum] == 2)
		{
			ToneBuffPtr = (Word16 *) ToneArray[countryType][SPL_INFO_TONE + 2];
			SMM_SplInfoToneCntr[CurChanNum] = -1; 
		}
		break;

         case MESG_WAITING_INDICATOR_TONE:				    
	       if(SMM_MesgIndToneCntr[CurChanNum] == 0)
			ToneBuffPtr = (Word16 *) ToneArray[countryType][MESG_WAITING_INDICATOR_TONE + 0];
	       else if(SMM_MesgIndToneCntr[CurChanNum] == 1)
			ToneBuffPtr = (Word16 *) ToneArray[countryType][MESG_WAITING_INDICATOR_TONE + 1];
	       else if(SMM_MesgIndToneCntr[CurChanNum] == 2)
	                ToneBuffPtr = (Word16 *) ToneArray[countryType][MESG_WAITING_INDICATOR_TONE + 0];
	       else if(SMM_MesgIndToneCntr[CurChanNum] == 3)
	                ToneBuffPtr = (Word16 *) ToneArray[countryType][MESG_WAITING_INDICATOR_TONE + 2];

	       else if(SMM_MesgIndToneCntr[CurChanNum] == 4)
			ToneBuffPtr = (Word16 *) ToneArray[countryType][MESG_WAITING_INDICATOR_TONE + 0];
	       else if(SMM_MesgIndToneCntr[CurChanNum] == 5)
			ToneBuffPtr = (Word16 *) ToneArray[countryType][MESG_WAITING_INDICATOR_TONE + 1];
	       else if(SMM_MesgIndToneCntr[CurChanNum] == 6)
	                ToneBuffPtr = (Word16 *) ToneArray[countryType][MESG_WAITING_INDICATOR_TONE + 0];
	       else if(SMM_MesgIndToneCntr[CurChanNum] == 7)
	                ToneBuffPtr = (Word16 *) ToneArray[countryType][MESG_WAITING_INDICATOR_TONE + 2];

	       else if(SMM_MesgIndToneCntr[CurChanNum] == 8)
			ToneBuffPtr = (Word16 *) ToneArray[countryType][MESG_WAITING_INDICATOR_TONE + 0];
	       else if(SMM_MesgIndToneCntr[CurChanNum] == 9)
			ToneBuffPtr = (Word16 *) ToneArray[countryType][MESG_WAITING_INDICATOR_TONE + 1];
	       else if(SMM_MesgIndToneCntr[CurChanNum] == 10)
	                ToneBuffPtr = (Word16 *) ToneArray[countryType][MESG_WAITING_INDICATOR_TONE + 0];
	       else if(SMM_MesgIndToneCntr[CurChanNum] == 11)
	                ToneBuffPtr = (Word16 *) ToneArray[countryType][MESG_WAITING_INDICATOR_TONE + 2];

	       else if(SMM_MesgIndToneCntr[CurChanNum] == 12)
			ToneBuffPtr = (Word16 *) ToneArray[countryType][MESG_WAITING_INDICATOR_TONE + 0];
	       else if(SMM_MesgIndToneCntr[CurChanNum] == 13)
			ToneBuffPtr = (Word16 *) ToneArray[countryType][MESG_WAITING_INDICATOR_TONE + 1];
	       else if(SMM_MesgIndToneCntr[CurChanNum] == 14)
	                ToneBuffPtr = (Word16 *) ToneArray[countryType][MESG_WAITING_INDICATOR_TONE + 0];
	       else if(SMM_MesgIndToneCntr[CurChanNum] == 15)
	                ToneBuffPtr = (Word16 *) ToneArray[countryType][MESG_WAITING_INDICATOR_TONE + 2];


	       else if(SMM_MesgIndToneCntr[CurChanNum] == 16)
	                ToneBuffPtr = (Word16 *) ToneArray[countryType][VOIP_DIAL_TONE + 0];
	       else if(SMM_MesgIndToneCntr[CurChanNum] == 17)
	                ToneBuffPtr = (Word16 *) ToneArray[countryType][VOIP_DIAL_TONE + 1];
	       else if(SMM_MesgIndToneCntr[CurChanNum] == 18)
	       {
	            ToneBuffPtr = (Word16 *) ToneArray[countryType][VOIP_DIAL_TONE + 2];
	            SMM_MesgIndToneCntr[CurChanNum] = -1;
	       } 
               break;

        case VOIP_DIAL_TONE:
               if(VOIPDailToneCntr[CurChanNum] == 0)
                    ToneBuffPtr = (Word16 *) ToneArray[countryType][VOIP_DIAL_TONE + 0];
               else if(VOIPDailToneCntr[CurChanNum] == 1)
                    ToneBuffPtr = (Word16 *) ToneArray[countryType][VOIP_DIAL_TONE + 1];
               else if(VOIPDailToneCntr[CurChanNum] == 2)
                    ToneBuffPtr = (Word16 *) ToneArray[countryType][VOIP_DIAL_TONE + 2];
               else if(VOIPDailToneCntr[CurChanNum] == 3)
               {
                    ToneBuffPtr = (Word16 *) ToneArray[countryType][VOIP_DIAL_TONE + 3];
                    VOIPDailToneCntr[CurChanNum] = 0;
               }
	       break;
    case TEST_TONE :
           //  ToneBuffPtr = (Word16 *) ToneArray[countryType][TEST_TONE];
            // ToneBuffPtr[2] = v_freq_test_tone;
             //ToneBuffPtr[4] = v_amp_test_tone;
             break;
             
	case CPE_ALERTING_TONE:
	       ToneBuffPtr = (Word16 *) ToneArray[countryType][CPE_ALERTING_TONE];
	       
	       break;

	case DIG_1_TONE_CONT:
	       ToneBuffPtr = (Word16 *) ToneArray[countryType][DIG_1_TONE_CONT];
		SMM_continuousToneFlg[CurChanNum] = CONTINUOUS_TONE;
      
	       break;

	default:
	       DEBUG(PRINT("\rUnknown ToneVal = %x for Country = FRANCE\n",ToneVal), DEBUG_INFO);
	       break;

       }//end of switch case
   }//end of else case
}//end of InitFranceTones()

//Added By Gowri

/**************************************************************
Function Name   :InitRomaniaTones()
Description     :This function initializes all the parameters
                 required by the Tone Generation module for
                 Romania Country type.
Input           :ToneVal
Output          :none
**************************************************************/
//extern Word16 v_amp_test_tone,v_freq_test_tone;
void InitRomaniaTones(Word16 ToneVal, Word16 CurChanNum)
{
	
   if((ToneVal >= DIG_0_TONE)&&(ToneVal <= DIG_HASH_TONE))
      InitDTMFTones(ToneVal, CurChanNum);   
   else
   {
     switch(ToneVal)
     {
	
	case DIAL_TONE:
	//case SPL_DIAL_TONE:

		ToneBuffPtr = (Word16 *) ToneArray[countryType][DIAL_TONE];
		SMM_continuousToneFlg[CurChanNum] = CONTINUOUS_TONE;
		// printf("\r ToneVal dial = %x for Country = Romania\n",ToneVal);

		
		break;
	case RING_BACK_TONE:
		
		ToneBuffPtr = (Word16 *) ToneArray[countryType][RING_BACK_TONE];
		 //printf("\r ToneVal ringback = %x for Country = Romania\n",ToneVal);
		break;
	case BUSY1_TONE:
	
		ToneBuffPtr = (Word16 *) ToneArray[countryType][BUSY1_TONE];
		 //printf("\r ToneVal busy1 = %x for Country = Romania\n",ToneVal);
		break;
        case BUSY2_TONE:
	
		ToneBuffPtr = (Word16 *) ToneArray[countryType][BUSY2_TONE];
		 //printf("\r ToneVal busy2 = %x for Country = Romania\n",ToneVal);
			break;

     
	case SPL_DIAL_TONE:
		   
		   if(SMM_SplDlToneCntr[CurChanNum] == 0)		   
		   ToneBuffPtr = (Word16 *) ToneArray[countryType][SPL_DIAL_TONE + 0];
		else if(SMM_SplDlToneCntr[CurChanNum] == 1)		  
		    ToneBuffPtr = (Word16 *) ToneArray[countryType][SPL_DIAL_TONE + 1];
		else if(SMM_SplDlToneCntr[CurChanNum] == 2)		
	           ToneBuffPtr = (Word16 *) ToneArray[countryType][SPL_DIAL_TONE + 2];
		else if(SMM_SplDlToneCntr[CurChanNum] == 3)
			{
		   ToneBuffPtr = (Word16 *) ToneArray[countryType][SPL_DIAL_TONE + 3];
		   SMM_continuousToneFlg[CurChanNum] = CONTINUOUS_TONE;
			}
		break;
		
           case CALL_WAITING_TONE1:
		if(SMM_CallWaitingCntr[CurChanNum] == 0)
			ToneBuffPtr = (Word16 *) ToneArray[countryType][CALL_WAITING_TONE1 + 0];
		else if(SMM_CallWaitingCntr[CurChanNum] == 1)
			ToneBuffPtr = (Word16 *) ToneArray[countryType][CALL_WAITING_TONE1+ 1];
		   break;
		   
       case SPL_INFO_TONE_ROMANIA:
	
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][SPL_INFO_TONE_ROMANIA];

		SMM_ToneGen_Phase3[CurChanNum] 	=   ToneArray[countryType][SPL_INFO_TONE_ROMANIA + 1][2];
		SMM_ToneGen_Scale3[CurChanNum] 	=   ToneArray[countryType][SPL_INFO_TONE_ROMANIA + 1][4];
		
		SMM_ToneGen_Phasetemp1[CurChanNum][0] 	=   0;
		
		break;

         case SPL_CNF_TONE:
		 ToneBuffPtr = (Word16 *) ToneArray[countryType][SPL_CNF_TONE];
			break;
             
	case CPE_ALERTING_TONE:
	       ToneBuffPtr = (Word16 *) ToneArray[countryType][CPE_ALERTING_TONE];
	       
	       break;

	default:
	       DEBUG(PRINT("\rUnknown ToneVal IN INIT = %x for Country = Romania\n",ToneVal), DEBUG_INFO);
	       break;

       }//end of switch case
   }//end of else case
}//end of InitFranceTones()


/**************************************************************
Function Name   :InitKoreaTones()
Description     :This function initializes all the parameters
                 required by the Tone Generation module for
                 KOREA Country type.
Input           :ToneVal
Output          :none
**************************************************************/

void InitKoreaTones(Word16 ToneVal, Word16 CurChanNum)
{

  if((ToneVal >= DIG_0_TONE)&&(ToneVal <= DIG_HASH_TONE))
      InitDTMFTones(ToneVal, CurChanNum);
  else
  {
    switch(ToneVal)
    {
	case DIAL_TONE:
		//ToneBuffPtr = (Word16 *) DialBuff;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][DIAL_TONE];
		SMM_continuousToneFlg[CurChanNum] = CONTINUOUS_TONE;
		break;

	case RING_BACK_TONE:
		//ToneBuffPtr = (Word16 *) RingBackBuff;
                ToneBuffPtr = (Word16 *) ToneArray[countryType][RING_BACK_TONE];
		break;

        case BUSY_TONE:
		//ToneBuffPtr = (Word16 *) BusyBuff;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][BUSY_TONE];
		break;

	case CONGESTION_TONE:
		//ToneBuffPtr = (Word16 *) CongestBuff;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][CONGESTION_TONE];
		break;

	case CALL_WAITING_TONE1:
		//ToneBuffPtr = (Word16 *) CallWaitingBuff1;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][CALL_WAITING_TONE1];
		break;

	case CALL_WAITING_TONE_2:
		//ToneBuffPtr = (Word16 *) CallWaitingBuff2;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][CALL_WAITING_TONE_2];
		break;

	case INTERN_DIAL_TONE:
		//ToneBuffPtr = (Word16 *) InternDialBuff;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][INTERN_DIAL_TONE];
		break;
	
	case IMM_RING_BACK_TONE:
		//ToneBuffPtr = (Word16 *) ImmRingBackBuff;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][IMM_RING_BACK_TONE];
		SMM_continuousToneFlg[CurChanNum] = CONTINUOUS_TONE;
		break;

	case MELODY_TONE:
		if(SMM_MelodyToneCntr[CurChanNum] == 0)
		   //ToneBuffPtr = (Word16 *) MelodyToneBuff1;
		   ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 0];
		else if(SMM_MelodyToneCntr[CurChanNum] == 1)
		   //ToneBuffPtr = (Word16 *) MelodyToneBuff2;
		    ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 1];
		else if(SMM_MelodyToneCntr[CurChanNum] == 2)
		   //ToneBuffPtr = (Word16 *) MelodyToneBuff3;
	           ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 2];
		else if(SMM_MelodyToneCntr[CurChanNum] == 3)
	           //ToneBuffPtr = (Word16 *) MelodyToneBuff4;
		   ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 3];
		else if(SMM_MelodyToneCntr[CurChanNum] == 4)
	           //ToneBuffPtr = (Word16 *) MelodyToneBuff5;
		   ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 4];
		else if(SMM_MelodyToneCntr[CurChanNum] == 5)
		   //ToneBuffPtr = (Word16 *) MelodyToneBuff6;
		   ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 5];

		if(SMM_MelodyToneCntr[CurChanNum] == 5)
			SMM_MelodyToneUpDonwFlag[CurChanNum] = 1;//Tones Descending Flag
		else if(SMM_MelodyToneCntr[CurChanNum] == 0)
			SMM_MelodyToneUpDonwFlag[CurChanNum] = 0;//Tones Ascending Flag

		if(SMM_MelodyToneUpDonwFlag[CurChanNum] == 0)
	        	SMM_MelodyToneCntr[CurChanNum]++;
	        else
			SMM_MelodyToneCntr[CurChanNum]--;

       		break;

	case CPE_ALERTING_TONE:
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][CPE_ALERTING_TONE];
		break;


	case CALL_HOLD_TONE1:	
		//ToneBuffPtr = (Word16 *) CallHoldBuff1;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][CALL_HOLD_TONE1];
		break;

	case CALL_HOLD_TONE2:
		//ToneBuffPtr = (Word16 *) CallHoldBuff2;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][CALL_HOLD_TONE2];
		break;

	case INTERCEPT_TONE1:
		//ToneBuffPtr = (Word16 *) InterceptBuff1;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][INTERCEPT_TONE1];
		break;

	case INTERCEPT_TONE2:
		//ToneBuffPtr = (Word16 *) InterceptBuff2;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][INTERCEPT_TONE2];
		break;

	case BIT_TONE:
		//ToneBuffPtr = (Word16 *) BitBuff;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][BIT_TONE];
		SMM_continuousToneFlg[CurChanNum] = CONTINUOUS_TONE;
		break;

	case RESERVE_TONE:
		//ToneBuffPtr = (Word16 *) ReserveBuff;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][RESERVE_TONE];
		break;

	case FAILURE_TONE:
		//ToneBuffPtr = (Word16 *) FailureBuff;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][FAILURE_TONE];
		break;

	case HOLD_RELEASE_TONE:
		//ToneBuffPtr = (Word16 *) HoldReleaseBuff;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][HOLD_RELEASE_TONE];
		break;
/*
	case COFIRM_TONE1:
		ToneBuffPtr = (Word16 *) ConfirmBuff1;
		break;

	case COFIRM_TONE2:
		ToneBuffPtr = (Word16 *) ConfirmBuff2;
		break;

	case COFIRM_TONE3:
		ToneBuffPtr = (Word16 *) ConfirmBuff3;
		break;
	case AUTO_ANSWER_TONE:
		ToneBuffPtr = (Word16 *) AutoAnswerBuff;
		break;
*/

	case HOWLER_TONE:
		//ToneBuffPtr = (Word16 *) HowlerBuff1;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][HOWLER_TONE];

		SMM_ToneGen_Phase3[CurChanNum] 	=   ToneArray[countryType][HOWLER_TONE + 1][2];
		SMM_ToneGen_Phase4[CurChanNum] 	=   ToneArray[countryType][HOWLER_TONE + 1][3];
		SMM_ToneGen_Scale3[CurChanNum] 	=   ToneArray[countryType][HOWLER_TONE + 1][4];
		SMM_ToneGen_Scale4[CurChanNum] 	=   ToneArray[countryType][HOWLER_TONE + 1][5];
		SMM_ToneGen_Phasetemp1[CurChanNum][0] 	=   0;
		SMM_ToneGen_Phasetemp1[CurChanNum][1]   =   0;
		break;

	default:
	        DEBUG(PRINT("Unknown ToneVal for Country = KOREA\n"), DEBUG_INFO);
		break;


     }//end of switch case
  }//end of else case
}//end of InitKoreaTones()

/**************************************************************
Function Name   :InitJapanTones()
Description     :This function initializes all the parameters
                 required by the Tone Generation module for
                 JAPAN Country type.
Input           :ToneVal
Output          :none
**************************************************************/

void InitJapanTones(Word16 ToneVal, Word16 CurChanNum)
{

  if((ToneVal >= DIG_0_TONE)&&(ToneVal <= DIG_HASH_TONE))
      InitDTMFTones(ToneVal, CurChanNum);
  else
  {
     switch(ToneVal)
     {
	case DIAL_TONE:
		//ToneBuffPtr = (Word16 *) DialBuff;
		ToneBuffPtr = (Word16 *) ToneArray[countryType][DIAL_TONE];
		SMM_continuousToneFlg[CurChanNum] = CONTINUOUS_TONE;
		break;

	case RING_BACK_TONE:
		//ToneBuffPtr = (Word16 *) RingingBuff;
	       ToneBuffPtr = (Word16 *) ToneArray[countryType][RING_BACK_TONE];
		break;

	case BUSY1_TONE:	
		//ToneBuffPtr = (Word16 *) BusyBuff;
	       ToneBuffPtr = (Word16 *) ToneArray[countryType][BUSY1_TONE];
		break;

	case CONGESTION_TONE:
	//case BUSY2_TONE:
		//ToneBuffPtr = (Word16 *) CongestionBuff;
	       ToneBuffPtr = (Word16 *) ToneArray[countryType][BUSY2_TONE];
		break;

	case CALL_WAITING_TONE1: //--> 400 Hz
	//case CALL_WAITING_TONE2: //--> 400 Hz
		if(SMM_CallWaitingCntr[CurChanNum] == 0)
			ToneBuffPtr = (Word16 *) ToneArray[countryType][CALL_WAITING_TONE1 + 0];
		else if(SMM_CallWaitingCntr[CurChanNum] == 1)
			ToneBuffPtr = (Word16 *) ToneArray[countryType][CALL_WAITING_TONE1 + 1];
		else if(SMM_CallWaitingCntr[CurChanNum] == 2)
			ToneBuffPtr = (Word16 *) ToneArray[countryType][CALL_WAITING_TONE1 + 2];
		else if(SMM_CallWaitingCntr[CurChanNum] == 3)
			ToneBuffPtr = (Word16 *) ToneArray[countryType][CALL_WAITING_TONE1 + 1];
		else if(SMM_CallWaitingCntr[CurChanNum] == 4)
			ToneBuffPtr = (Word16 *) ToneArray[countryType][CALL_WAITING_TONE1 + 2];
		break;


	case DIAL_TONE_PABX:
		//ToneBuffPtr = (Word16 *) DialBuffPABX;
		ToneBuffPtr = (Word16 *) ToneArray[countryType][DIAL_TONE_PABX];
		break;
		
	case SECOND_DIAL_TONE_I:	
		//ToneBuffPtr = (Word16 *) SecondDialBuff_I;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][SECOND_DIAL_TONE_I];
		break;

	case SECOND_DIAL_TONE_II:
		//ToneBuffPtr = (Word16 *) SecondDialBuff_II;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][SECOND_DIAL_TONE_II];
		break;

	case SECOND_DIAL_TONE_III:
		//ToneBuffPtr = (Word16 *) SecondDialBuff_III;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][SECOND_DIAL_TONE_III];
		break;

	case RECALL_DIAL_TONE:
		//ToneBuffPtr = (Word16 *) RecallDialBuff;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][RECALL_DIAL_TONE];
		SMM_continuousToneFlg[CurChanNum] = 0x2; //Flag for continuous tone
		break;

	case CPE_ALERTING_TONE:
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][CPE_ALERTING_TONE];
		break;


	case RINGING_TONE_PABX:
		//ToneBuffPtr = (Word16 *) RingingBuffPABX;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][RINGING_TONE_PABX];
		break;

	case SPECIAL_INFO_TONE:	
		//ToneBuffPtr = (Word16 *) SpecialInfoBuff;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][SPECIAL_INFO_TONE];
		break;

	case WAITING_TONE_I:	//--> 440 Hz
		if(SMM_WaitingToneCntr[CurChanNum] == 0)
		    //ToneBuffPtr = (Word16 *) WaitingBuff_I_1;
		    ToneBuffPtr = (Word16 *) ToneArray[countryType][WAITING_TONE_I + 0];
		else
		    //ToneBuffPtr = (Word16 *) WaitingBuff_I_2;
	            ToneBuffPtr = (Word16 *) ToneArray[countryType][WAITING_TONE_I + 1];
		break;

	case WAITING_TONE_II:	//--> 400 x 16 Hz
		if(SMM_WaitingToneCntr[CurChanNum] == 0)
		    //ToneBuffPtr = (Word16 *) WaitingBuff_II_1;
		    ToneBuffPtr = (Word16 *) ToneArray[countryType][WAITING_TONE_II + 0];
		else
		    //ToneBuffPtr = (Word16 *) WaitingBuff_II_2;
		    ToneBuffPtr = (Word16 *) ToneArray[countryType][WAITING_TONE_II + 1];
		break;

	case WAITING_TONE_II_1:	//--> 400 Hz
		if(SMM_WaitingToneCntr[CurChanNum] == 0)
		    //ToneBuffPtr = (Word16 *) WaitingBuff_II_3;
		    ToneBuffPtr = (Word16 *) ToneArray[countryType][WAITING_TONE_II_1 + 0];
		else
		    //ToneBuffPtr = (Word16 *) WaitingBuff_II_4;
	            ToneBuffPtr = (Word16 *) ToneArray[countryType][WAITING_TONE_II_1 + 1];
		break;


	case CALL_WAITING_TONE3: //--> 400x16 Hz
	//case CALL_WAITING_TONE4: //--> 400x16 Hz
		if(SMM_CallWaitingCntr[CurChanNum] == 0)
		    ToneBuffPtr = (Word16 *) ToneArray[countryType][CALL_WAITING_TONE3 + 0];
		else if(SMM_CallWaitingCntr[CurChanNum] == 1)
		    ToneBuffPtr = (Word16 *) ToneArray[countryType][CALL_WAITING_TONE3 + 1];
		else if(SMM_CallWaitingCntr[CurChanNum] == 2)
		    ToneBuffPtr = (Word16 *) ToneArray[countryType][CALL_WAITING_TONE3 + 2];
		else if(SMM_CallWaitingCntr[CurChanNum] == 3)
		    ToneBuffPtr = (Word16 *) ToneArray[countryType][CALL_WAITING_TONE3 + 1];
		else if(SMM_CallWaitingCntr[CurChanNum] == 4)
		    ToneBuffPtr = (Word16 *) ToneArray[countryType][CALL_WAITING_TONE3 + 2];
		break;

	case PAY_TONE_I:
		//ToneBuffPtr = (Word16 *) PayToneBuff_I;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][PAY_TONE_I];
		break;

	case PAY_TONE_II:
		//ToneBuffPtr = (Word16 *) PayToneBuff_II;
	        ToneBuffPtr = (Word16 *) ToneArray[countryType][PAY_TONE_II];
		break;

	case POSITIVE_INDI_TONE:
		if(SMM_PosIndToneCntr[CurChanNum] == 0)
		   //ToneBuffPtr = (Word16 *) PositiveIndBuff_1;
		   ToneBuffPtr = (Word16 *) ToneArray[countryType][POSITIVE_INDI_TONE + 0];
		else
		   //ToneBuffPtr = (Word16 *) PositiveIndBuff_2;
		   ToneBuffPtr = (Word16 *) ToneArray[countryType][POSITIVE_INDI_TONE + 1];
		break;

	case MELODY_TONE:
		if(SMM_MelodyToneCntr[CurChanNum] == 0)
		   //ToneBuffPtr = (Word16 *) MelodyToneBuff1;
		   ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 0];
		else if(SMM_MelodyToneCntr[CurChanNum] == 1)
		   //ToneBuffPtr = (Word16 *) MelodyToneBuff2;
		   ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 1];
		else if(SMM_MelodyToneCntr[CurChanNum] == 2)
		   //ToneBuffPtr = (Word16 *) MelodyToneBuff3;
		   ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 2];
		else if(SMM_MelodyToneCntr[CurChanNum] == 3)
		   //ToneBuffPtr = (Word16 *) MelodyToneBuff4;
		   ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 3];
		else if(SMM_MelodyToneCntr[CurChanNum] == 4)
		   //ToneBuffPtr = (Word16 *) MelodyToneBuff5;
		   ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 4];
		else if(SMM_MelodyToneCntr[CurChanNum] == 5)
		   //ToneBuffPtr = (Word16 *) MelodyToneBuff6;
		   ToneBuffPtr = (Word16 *) ToneArray[countryType][MELODY_TONE + 5];

	        if(SMM_MelodyToneCntr[CurChanNum] == 5)
		   SMM_MelodyToneUpDonwFlag[CurChanNum] = 1;	//Tones Descending Flag
		else if(SMM_MelodyToneCntr[CurChanNum] == 0)
		   SMM_MelodyToneUpDonwFlag[CurChanNum] = 0;	//Tones Ascending Flag

		if(SMM_MelodyToneUpDonwFlag[CurChanNum] == 0)
	           SMM_MelodyToneCntr[CurChanNum]++;
	        else
		   SMM_MelodyToneCntr[CurChanNum]--;

       		break;

	default:
	        DEBUG(PRINT("Unknown ToneVal for Country = JAPAN\n"), DEBUG_INFO);
		break;


     }//end of switch case
   }//end of else case
}//end of InitJapanTones()

#if !FXS_ToneDtmf_ACTIVE
void ToneResetVars(Word16 CurChanNum)
{

  uWord16 uiCountry;
  confGetCountryOpts(&uiCountry);
  if(uiCountry == TONE_GEN_FRANCE)
  {
    if(SMM_ToneType[CurChanNum] == MESG_WAITING_INDICATOR_TONE)
       SMM_MesgIndToneCntr[CurChanNum] = 0; 

    if(SMM_ToneType[CurChanNum] == SPL_INFO_TONE)
       SMM_SplInfoToneCntr[CurChanNum] = 0;

    if(SMM_ToneType[CurChanNum] == ROC_TONE)
       SMM_RocToneCntr[CurChanNum] = 0;

    if(SMM_ToneType[CurChanNum] == VOIP_DIAL_TONE)
       VOIPDailToneCntr[CurChanNum] = 0;

    if(SMM_ToneType[CurChanNum] == CALL_WAITING_TONE1)
       SMM_CallWaitingCntr[CurChanNum] = 0;

  }
}

__inline void ToneGenSetCountry(void)
{
  confGetCountryOpts(&countryType);
}
#else // FXS_ToneDtmf_ACTIVE
// tonalites par DSP : uniquement pour generer la numerotation DTMF vers le FXO  
void ToneResetVars(Word16 CurChanNum)
{

}

__inline void ToneGenSetCountry(void)
{
  countryType=TONE_GEN_FRANCE;
}
#endif
