/***************************************************************************
File Name		:	JitProto.h
Description     :   This file contains the Proto type definitions used in the
    			  		Jitter Buffer module 	
Authors         : sivan.nagireddi@analog.com &rajakumar.kulakarni@analog.com.
Version Number	:	2.0
Date			:	10/June/2002
Company Name	:  	Analog Devices India (p) Ltd.
****************************************************************************/

//#define SIMULATION
#ifndef __JitProto_H
#define __JitProto_H


#ifdef  SIMULATION
#include "JitVar.h"
#endif

void AJBRead( uWord16 PortNum);
void AJBSet(uWord16 PortNum, Word16 AjbRdIsrEventDur );
void AJBReset(uWord16 PortNum);
void WtJitBuffer( WtRtpPktType_ *WtRTPPkt , uWord16 PortNum , UCHAR *pVoicePayload);
void RdJitBuffer(uWord16 PortNum);

void JitPutPkt( uWord16 PortNum);
void JitGetPkt( uWord16 PortNum);
void JitDelayEst(WtRtpPktType_ *WtRTPPkt , uWord16 PortNum );
int GetFreePkt(uWord16 PortNum);
int GetJitBuffPkt(uWord16 PortNum);
void JitFreeMem(uWord16 TempIndex ,uWord16 PortNum );
void ResetDelayEst( WtRtpPktType_ *WtRTPPkt , uWord16 PortNum);
Word32 L_mult(Word16 var1, Word16 var2);       /* Long mult,           1 */
Word32 L_add(Word32 L_var1, Word32 L_var2);    /* Long add,        2 */
Word32 L_shr(Word32 L_var1, Word16 var2);      /* Long shift right,    2 */
Word16 Jit_abs_s(Word16 var1);
Word32 L_sub(Word32 L_var1, Word32 L_var2);
Word32 L_shl(Word32 L_var1, Word16 var2);

void JitDelayTrack( uWord16 PortNum);
void JitStatics(uWord16 PortNum);
void AJBDebugTrace(uWord16 PortNum,uWord16 *pOuy);
void CidTxPlay(uWord16 PortNum);
int AJBInit(Word16 PortNum, WtRtpPktType_ *WtRTPPkt);
void Cli_AJBWtPara( uWord16 PortNum, uWord16 Index, uWord16 Value );
void Cli_AJBReadPara( uWord16 PortNum, uWord16 Index, uWord16 SubIndex  );
void AJBDefCon(uWord16 PortNum );
#if AJB_USE_CLI_CONFIGURATIONS
void AJBGetCon(uWord16 PortNum , AJBCliParaSt_  *AJBConPtr );
void AJBSetCon(uWord16 PortNum , AJBCliParaSt_  *AJBConPtr );
#endif
void Markov4Est(uWord16 PortNum);
void  Markov4EstInit(uWord16 PortNum , uWord16 RdFrameSize);
void VQMonPktMetrics(uWord16 PortNum);
uWord16 BuildVQMonRtcpXRPkt(uWord16 PortNum, uWord32 Src_SSRCNum);
int AJBEnqPkt(WtRtpPktType_ *WtRTPPkt , uWord16 PortNum , UCHAR *pVoicePayload);
void InitDelayEst(uWord16 PortNum);
void InitAJBStat(Word16 PortNum);
#endif
