/* ============================================================================
 *
 * Copyright (C) 2001 Analog Devices Inc. All rights reserved
 *
 * The information and source code contained herein is the exclusive property
 * of Analog Devices and may not be disclosed, examined or reproduced in whole
 * or in part without the explicit written authorization from Analog Devices.
 *
 * ============================================================================
 */
                                                                                               
#ifndef __OS_WRAPPER_H
#define __OS_WRAPPER_H

#define K0_TO_K1(x)   ((unsigned)(x)|0xA0000000) /* kseg0 to kseg1 */

#define FIRMWARE_CONF_COUNTRY_FR
#define FIRMWARE_CONF_AUDIPHONE 1

/* Linux Includes */
#include <voice_typedef.h>
#include <voiceconf.h>
#include <linux/module.h>
#include <linux/errno.h>
#include <linux/signal.h>
#include <linux/sched.h>
#include <linux/fs.h>
#include <linux/interrupt.h>
#include <linux/ioport.h>
#include <linux/kernel.h>
#include <linux/major.h>
#include <linux/time.h>
#include <linux/string.h>
#include <linux/types.h>
#include <linux/wait.h>
#include <linux/mm.h>
#include <linux/poll.h>
#include <linux/init.h>
#include <linux/delay.h>
#include <asm/system.h>
#include <asm/uaccess.h>
#include <asm/segment.h>
#include <asm/io.h>
#include <asm/irq.h>
#include <asm/fcntl.h>
#include <processor.h>
#include <voicespi.h>
#include <dspipc.h>
#include <slicapi.h>
#include <JitCons.h>
#include <JitVar.h>
#include <JitProto.h>
#include <CidTxVar.h>
#include <CidTxProto.h>
#include <HDtmfrxProto.h>
#include <HDtmfrxConst.h>
#include <voicelib.h>


                                                                                             
void osLockInterrupts(void);
void osUnlockInterrupts(void);
int osDSPIntHandler(int irq, void *dev_id, struct pt_regs *regs);
int osAssignInterrupt(int dsp_num);
int osDownloadDSPImage(UINT16 *pDSPData, int dspNum);
 
/* Function Prototypes */
int dsp_download_code(unsigned short *ldsp_code);
void dsp_data_ready(void);
void dsp_cmd_ready(void);
int assign_IDMA_registers(unsigned short dspnum);
int ad2189dn(void);
void osDisableSystem(void);
#endif

