/******************************************************************************
*
*   Copyright (C) 2002 Analog Devices India (P) Ltd. All rights are reserved.
*
*   The information and source code contained herein is the exclusive
*   property of Analog Devices India (P) Ltd. and may not be disclosed,
*   examined or reproduced in whole or in part without explicit written
*   authorization from the compnay.
*
******************************************************************************/
/*==============================================================================
	File Name	: 	dspdrv.h
	Description	:	File contains the definition for the DSP driver.
	Author		: 	Linux Media Team.			
 ===============================================================================*/

#ifndef __DSP_DRV_H
#define __DSP_DRV_H

/* DSP Major Number */
#define DSP_MAJOR 115
/* DSP Device Minoe for SLIC */
#define DSP_MINOR 15
/* DSP Minor Number for Voice data transactions */
#define VOICE_MINOR 16
/* Minor number for FXO Module */
#define FXO_MINOR 17
/* Minor number for FAX T.38 */
#define T38_MINOR 18

INT16 store_voice_conf(VOICELS* param);
INT16 restore_voice_conf(VOICELS* param);
int dsp_config_default(void);
int dsp_download_image(int);
int dsp_init_system(void);
int send_data_to_dsp(UCHAR *pData, int readCnt, int dspNum);
INT16 store_voice_conf(VOICELS *pVoice);
INT16 restore_voice_conf(VOICELS *pVoice);
INT16 save_voice_conf(void);
int dsp_config_default(void);
int dsp_init_system(void);
int parse_dsp_image_data(UCHAR *pData, int readCnt);
int dsp_download_static_images(void);
int store_dynamic_image(UINT16 **pImageData, UCHAR *pImageName);
int dsp_download_image(int dspNum);

#endif
