/******************************************************************************
*
*   Copyright (C) 2002 Analog Devices India (P) Ltd. All rights are reserved.
*
*   The information and source code contained herein is the exclusive
*   property of Analog Devices India (P) Ltd. and may not be disclosed,
*   examined or reproduced in whole or in part without explicit written
*   authorization from the compnay.
*
******************************************************************************/

#ifndef __POLAND_CONF_H
#define __POLAND_CONF_H

//****************************************************************************
//		Plan de transmission du FXS POLAND : 600 +2dBIn/-4.5dBout
//****************************************************************************
// SAGEM CFe : plan de transmission du FXS poland : +2dBIn/-4.5dBout 
// attnuation FXS totale en transmission de 2dB avec les attnuations de 3.5dB d'ATX, de 1.63dB du mode linaire et gain ADCG de 3.13dB
// attnuation FXS totale en rception de 4,5dB avec les attnuations de 3.5dB d'ARX, de 0.15dB intrinsque et 0.85dB de DACG 

// Transmit Path Digital To Analog Converter Gain/Attenuation = +3.13dB.
#define PL_XMIT_DIGITAL_GAIN_600_IR14 		0x5BC4
// Receive Path Digital To Analog Converter Gain/Attenuation = -0.85dB.
#define PL_RECV_DIGITAL_GAIN_600_IR13 		0x3A09


//****************************************************************************
//		POLAND Ring specifications : Ring 25Hz 35V 1s On 4s Off
//****************************************************************************
// Ringing Active Timer = 125uS * 0x1F40 = 1S.
#define PL_RING_ON_1S_LSB_DR48 			0x40
#define PL_RING_ON_1S_MSB_DR49 			0x1F
// Ringing Inactive Timer = 125uS * 0x7D00 = 4S
#define PL_RING_OFF_4S_LSB_DR50 			0x00
#define PL_RING_OFF_4S_MSB_DR51 			0x7D

// Ring Oscillator Frequency Coefficient for 25Hz.
#define PL_RING_OSC_FREQ_25HZ_IR7 			0x7E6C
// Ring Oscillator Amplitude Register for 50Hz and 35V.
#define PL_RING_OSC_AMP_25HZ_IR8 			0x0185
// Ring Oscillator Initial Phase Register for 50Hz and 35V.
#define PL_RING_OSC_INITPHASE_25HZ_IR9 		0x0000
// Data sheet SI3216.
#define PL_RING_TRIP_THRESH_25HZ_IR16 		0x3600
#define PL_RING_TRIP_FILTER_25HZ_IR23 		0x0350
// Ring Trip Detect Debounce Interval = 1.25mS * 0x0A = 12,5mS.
#define PL_RT_DEBOUNCE_25HZ_DR70 			0x0A


//****************************************************************************
//		POLAND Tones specifications
//****************************************************************************
#define	PL_FREQ_425Hz 				0x7E39
#define	PL_F425Hz_AMP_M10dBm05 		0x008F
#define	PL_F425Hz_AMP_M14dBm05 		0x005A

#define	PL_FREQ_2130Hz 			0x55C6
#define	PL_F2130Hz_AMP_M9dBm0 		0x0386

#define	PL_FREQ_2750Hz 			0x3C57
#define	PL_F2750Hz_AMP_M9dBm0 		0x04C0

// OSC1	425Hz -6dBm0 continuous
#define	PL_DIAL_IR0 				PL_FREQ_425Hz
#define	PL_DIAL_IR1 				PL_F425Hz_AMP_M10dBm05

// OSC1	425Hz -6dBm0 50ms On 50ms Off
#define	PL_CALL_IN_PROGRESS_C0_IR0 	PL_FREQ_425Hz
#define	PL_CALL_IN_PROGRESS_C0_IR1 	PL_F425Hz_AMP_M10dBm05
#define	PL_CALL_IN_PROGRESS_C0_DR36 	0x90
#define	PL_CALL_IN_PROGRESS_C0_DR37 	0x01
#define	PL_CALL_IN_PROGRESS_C0_DR38 	0x90
#define	PL_CALL_IN_PROGRESS_C0_DR39 	0x01

// OSC1	425Hz -6dBm0 1s On 4s Off
#define	PL_RINGBACK_IR0 			PL_FREQ_425Hz
#define	PL_RINGBACK_IR1 			PL_F425Hz_AMP_M10dBm05
#define	PL_RINGBACK_DR36 			0x40
#define	PL_RINGBACK_DR37 			0x1F
#define	PL_RINGBACK_DR38 			0X00
#define	PL_RINGBACK_DR39 			0X7D

// OSC1	425Hz -6dBm0 0.5s On 0.5s Off
#define	PL_BUSY_IR0 				PL_FREQ_425Hz
#define	PL_BUSY_IR1 				PL_F425Hz_AMP_M10dBm05
#define	PL_BUSY_DR36 				0xA0
#define	PL_BUSY_DR37 				0x0F
#define	PL_BUSY_DR38 				0xA0
#define	PL_BUSY_DR39 				0x0F

// OSC1	425Hz -6dBm0 0.2s On 0.2s Off	for cycle 0,1 and 3
#define	PL_MSG_WAITING_C013_IR0 		PL_FREQ_425Hz
#define	PL_MSG_WAITING_C013_IR1 		PL_F425Hz_AMP_M10dBm05
#define	PL_MSG_WAITING_C013_DR36 	0x40
#define	PL_MSG_WAITING_C013_DR37 	0x06
#define	PL_MSG_WAITING_C013_DR38 	0x40
#define	PL_MSG_WAITING_C013_DR39 	0x06
// OSC1	425Hz -6dBm0 0.4s On 0.4s Off	for cycle 2
#define	PL_MSG_WAITING_C2_IR0 		PL_FREQ_425Hz
#define	PL_MSG_WAITING_C2_IR1 		PL_F425Hz_AMP_M10dBm05
#define	PL_MSG_WAITING_C2_DR36 		0x80
#define	PL_MSG_WAITING_C2_DR37 		0x0C
#define	PL_MSG_WAITING_C2_DR38 		0x80
#define	PL_MSG_WAITING_C2_DR39 		0x0C
// OSC1	425Hz -6dBm0 0.2s On 0.5s Off	for cycle 4
#define	PL_MSG_WAITING_C4_IR0 		PL_FREQ_425Hz
#define	PL_MSG_WAITING_C4_IR1 		PL_F425Hz_AMP_M10dBm05
#define	PL_MSG_WAITING_C4_DR36 		0x40
#define	PL_MSG_WAITING_C4_DR37 		0x06
#define	PL_MSG_WAITING_C4_DR38 		0xA0
#define	PL_MSG_WAITING_C4_DR39 		0x0F

// OSC1	425Hz -6dBm0 0.150s On 0.150s Off
#define	PL_CALL_WAIT_C0_IR0 		PL_FREQ_425Hz
#define	PL_CALL_WAIT_C0_IR1 		PL_F425Hz_AMP_M14dBm05
#define	PL_CALL_WAIT_C0_DR36 		0xB0
#define	PL_CALL_WAIT_C0_DR37 		0x04
#define	PL_CALL_WAIT_C0_DR38 		0xB0
#define	PL_CALL_WAIT_C0_DR39 		0x04
// OSC1	425Hz -6dBm0 0.150s On 4s Off
#define	PL_CALL_WAIT_C1_IR0 		PL_FREQ_425Hz
#define	PL_CALL_WAIT_C1_IR1 		PL_F425Hz_AMP_M14dBm05
#define	PL_CALL_WAIT_C1_DR36 		0xB0	
#define	PL_CALL_WAIT_C1_DR37 		0x04
#define	PL_CALL_WAIT_C1_DR38 		0x00
#define	PL_CALL_WAIT_C1_DR39 		0x7D

// OSC1	2130Hz -9dBm0 80ms On
#define	PL_ALERTING_IR0 			PL_FREQ_2130Hz
#define	PL_ALERTING_IR1 			PL_F2130Hz_AMP_M9dBm0
#define	PL_ALERTING_DR36 			0x80
#define	PL_ALERTING_DR37 			0x02
#define	PL_ALERTING_DR38 			0x00
#define	PL_ALERTING_DR39 			0x00
// OSC2	2750Hz -9dBm0 80ms On
#define	PL_ALERTING_IR3 			PL_FREQ_2750Hz
#define	PL_ALERTING_IR4 			PL_F2750Hz_AMP_M9dBm0
#define	PL_ALERTING_DR40 			0x80
#define	PL_ALERTING_DR41 			0x02
#define	PL_ALERTING_DR42 			0x00
#define	PL_ALERTING_DR43 			0x00

// OSC1	425Hz -6dBm0 0.3s On 0.2s Off
#define	PL_VOIP_DIAL_C0_IR0 		PL_FREQ_425Hz
#define	PL_VOIP_DIAL_C0_IR1 		PL_F425Hz_AMP_M10dBm05
#define	PL_VOIP_DIAL_C0_DR36 		0x60
#define	PL_VOIP_DIAL_C0_DR37 		0x09
#define	PL_VOIP_DIAL_C0_DR38 		0X40
#define	PL_VOIP_DIAL_C0_DR39 		0X06
// OSC1	425Hz -6dBm0 1.6s On 0.2s Off
#define	PL_VOIP_DIAL_C1_IR0 		PL_FREQ_425Hz
#define	PL_VOIP_DIAL_C1_IR1 		PL_F425Hz_AMP_M10dBm05
#define	PL_VOIP_DIAL_C1_DR36 		0x00
#define	PL_VOIP_DIAL_C1_DR37 		0x32
#define	PL_VOIP_DIAL_C1_DR38 		0X40
#define	PL_VOIP_DIAL_C1_DR39 		0X06


//****************************************************************************
//		POLAND Dtmf specifications
//****************************************************************************
#define	PL_DTMF_FREQ_697Hz 			0x7b3c 
#define	PL_DTMF_F697Hz_AMP_M11dBm0 	0xdd

#define	PL_DTMF_FREQ_770Hz 			0x7a31 
#define	PL_DTMF_F770Hz_AMP_M11dBm0 	0xf5

#define	PL_DTMF_FREQ_852Hz 			0x78e6 
#define	PL_DTMF_F852Hz_AMP_M11dBm0 	0x110

#define	PL_DTMF_FREQ_941Hz 			0x775c 
#define	PL_DTMF_F941Hz_AMP_M11dBm0 	0x12d

#define	PL_DTMF_FREQ_1209Hz 		0x71d7 
#define	PL_DTMF_F1209Hz_AMP_M9dBm0 	0x1ea

#define	PL_DTMF_FREQ_1336Hz 		0x6ec8 
#define	PL_DTMF_F1336Hz_AMP_M9dBm0 	0x220

#define	PL_DTMF_FREQ_1477Hz 		0x6b10 
#define	PL_DTMF_F1477Hz_AMP_M9dBm0 	0x25d

#define	PL_DTMF_FREQ_1633Hz 		0x6692 
#define	PL_DTMF_F1633Hz_AMP_M9dBm0 	0x2a1

// OSC1	80ms On
#define	PL_DTMF_DR36 				0x80
#define	PL_DTMF_DR37 				0x02
// OSC2	80ms On
#define	PL_DTMF_DR40 				0x80
#define	PL_DTMF_DR41 				0x02

typedef enum
{
	PL_NULL_TONE 					= 0,
	PL_DIAL_TONE 					= 1,
	PL_CALL_IN_PROGRESS 			= 2,
	PL_RING_BACK_TONE 				= 3,
	PL_BUSY_TONE 					= 4,
	PL_MSG_WAITING_TONE 			= 5,
	PL_CALL_WAITING_TONE 			= 6,
	PL_ALERTING_TONE 				= 7,                                                                                
	PL_VOIP_DIAL_TONE 				= 8,
	PL_VOIP_MWI_TONE         	     = 9,
	PL_DTMF_DIG_0_TONE_LOCAL 		= 10,
	PL_DTMF_DIG_1_TONE_LOCAL 		= 11,
	PL_DTMF_DIG_2_TONE_LOCAL 		= 12,
	PL_DTMF_DIG_3_TONE_LOCAL 		= 13,
	PL_DTMF_DIG_4_TONE_LOCAL 		= 14,
	PL_DTMF_DIG_5_TONE_LOCAL 		= 15,
	PL_DTMF_DIG_6_TONE_LOCAL 		= 16,
	PL_DTMF_DIG_7_TONE_LOCAL 		= 17,
	PL_DTMF_DIG_8_TONE_LOCAL 		= 18,
	PL_DTMF_DIG_9_TONE_LOCAL 		= 19,
	PL_DTMF_DIG_A_TONE_LOCAL 		= 20,
	PL_DTMF_DIG_B_TONE_LOCAL 		= 21,
	PL_DTMF_DIG_C_TONE_LOCAL 		= 22,
	PL_DTMF_DIG_D_TONE_LOCAL 		= 23,
	PL_DTMF_DIG_STAR_TONE_LOCAL 		= 24,
	PL_DTMF_DIG_HASH_TONE_LOCAL 		= 25,
	PL_TONE_END 					= 26
} enumPolandTone;

#define	PL_MAX_NUM_CADENCE 			5


extern const ringStruct  polandRingTable;
extern const toneCadenceTables  polandToneCadenceTables [PL_TONE_END][PL_MAX_NUM_CADENCE];

#endif
