#ifndef __SI3216_H
#define __SI3216_H


/* Linefeed Operation States */
#define OPEN_DR64 				0 // Open Linefeed.
#define FORWARD_ACTIVE_DR64 		1 // Forward Active Linefeed.
#define OHT_DR64 				2 // Forward On-Hook Transmission Linefeed.
#define TIP_OPEN_DR64 			3 // TIP Open Linefeed.
#define RINGING_DR64 			4 // Ringing Linefeed.
#define REVERSE_ACTIVE_DR64 		5 // Reverse Active Linefeed.
#define REVERSE_OHT_DR64 		6 // Reverse On-Hook Transmission Linefeed.
#define RING_OPEN_DR64 			7 // RING Open Linefeed.


/* SI3216 DIRECT REGISTER ADDRESS (decimal) */
#define	DR0_SPI_MODE			0
#define	DR1_PCM_MODE			1
#define	DR2_PCM_XMIT_LSB		2
#define	DR3_PCM_XMIT_MSB		3
#define	DR4_PCM_RCV_LSB		4
#define	DR5_PCM_RCV_MSB		5
#define	DR6_PNI				6
#define	DR7_RESERVED			7
#define	DR8_AUDIO_LOOPBACK		8
#define	DR9_AUDIO_GAIN			9
#define	DR10_LINE_IMPEDANCE		10
#define	DR11_HYBRID			11
#define	DR12_RESERVED			12
#define	DR13_RESERVED			13
#define	DR14_PWR_DOWN1			14
#define	DR15_PWR_DOWN2			15
#define	DR16_RESERVED			16
#define	DR17_RESERVED			17
#define	DR18_INTRPT_STATUS1		18
#define	DR19_INTRPT_STATUS2		19
#define	DR20_INTRPT_STATUS3		20
#define	DR21_INTRPT_MASK1		21
#define	DR22_INTRPT_MASK2		22
#define	DR23_INTRPT_MASK3		23
#define	DR24_RESERVED			24
#define	DR25_RESERVED			25
#define	DR26_RESERVED			26
#define	DR27_RESERVED			27
#define	DR28_I_DATA_LOW		28
#define	DR29_I_DATA_HIGH		29
#define	DR30_I_ADDRESS			30
#define	DR31_I_STATUS			31
#define	DR32_OSC1				32
#define	DR33_OSC2				33
#define	DR34_RING_OSC_CTL		34
#define	DR35_RESERVED			35
#define	DR36_OSC1_ON_LO		36
#define	DR37_OSC1_ON_HI		37
#define	DR38_OSC1_OFF_LO		38
#define	DR39_OSC1_OFF_HI		39
#define	DR40_OSC2_ON_LO		40
#define	DR41_OSC2_ON_HI		41
#define	DR42_OSC2_OFF_LO		42
#define	DR43_OSC2_OFF_HI		43
#define	DR44_RESERVED			44
#define	DR45_RESERVED			45
#define	DR46_RESERVED			46
#define	DR47_RESERVED			47
#define	DR48_RING_ON_LO		48
#define	DR49_RING_ON_HI		49
#define	DR50_RING_OFF_LO		50
#define	DR51_RING_OFF_HI		51
#define	DR52_FSK_DATA			52
#define	DR53_RESERVED			53
#define	DR54_RESERVED			54
#define	DR55_RESERVED			55
#define	DR56_RESERVED			56
#define	DR57_RESERVED			57
#define	DR58_RESERVED			58
#define	DR59_RESERVED			59
#define	DR60_RESERVED			60
#define	DR61_RESERVED			61
#define	DR62_RESERVED			62
#define	DR63_RESERVED			63
#define	DR64_LINE_STATE		64
#define	DR65_BIAS_SQUELCH		65
#define	DR66_BAT_FEED			66
#define	DR67_AUTO_STATE		67
#define	DR68_LOOP_STAT			68
#define	DR69_LOOP_DEBOUNCE		69
#define	DR70_RT_DEBOUNCE		70
#define	DR71_LOOP_I_LIMIT		71
#define	DR72_ON_HOOK_V			72
#define	DR73_COMMON_V			73
#define	DR74_BAT_V_HI			74
#define	DR75_BAT_V_LO			75
#define	DR76_PWR_STAT_DEV		76
#define	DR77_PWR_STAT			77
#define	DR78_LOOP_V_SENSE		78
#define	DR79_LOOP_I_SENSE		79
#define	DR80_TIP_V_SENSE		80
#define	DR81_RING_V_SENSE		81
#define	DR82_BAT_V_HI_SENSE		82
#define	DR83_BAT_V_LO_SENSE		83
#define	DR84_IQ1				84
#define	DR85_IQ2				85
#define	DR86_IQ3				86
#define	DR87_IQ4				87
#define	DR88_IQ5				88
#define	DR89_IQ6				89
#define	DR90_RESERVED			90
#define	DR91_RESERVED			91
#define	DR92_DCDC_PWM_PERIOD	92
#define	DR93_DCDC_PWM_TIME		93
#define	DR94_DCDC_PW_OFF		94
#define	DR95_RESERVED			95
#define	DR96_CALIBR1			96
#define	DR97_CALIBR2			97
#define	DR98_RING_GAIN_CAL		98
#define	DR99_TIP_GAIN_CAL		99
#define	DR100_DIFF_I_CAL		100
#define	DR101_COMMON_I_CAL		101
#define	DR102_I_LIMIT_GAIN_CAL	102
#define	DR103_ADC_OFFSET_CAL	103
#define	DR104_DAC_ADC_OFFSET	104
#define	DR105_DAC_OFFSET_CAL	105
#define	DR106_RESERVED			106
#define	DR107_DC_PEAK_CAL		107
#define	DR108_ENHANCE_ENABLE	108


/* SI3216 INDIRECT REGISTER ADDRESS (decimal) */
/* Oscillators */
#define IR0_OSC1_COEF                   0
#define IR1_OSC1X                       1
#define IR2_OSC1Y                       2
#define IR3_OSC2_COEF                   3
#define IR4_OSC2X                       4
#define IR5_OSC2Y                       5
#define IR6_RING_V_OFF                  6
#define IR7_RING_OSC_COEF               7
#define IR8_RING_X                      8
#define IR9_RING_Y                      9

/* Digital Programmable Gain/attenuation */
#define IR13_RECV_DIGITAL_GAIN          13
#define IR14_XMIT_DIGITAL_GAIN          14

/* SLIC Control */
#define IR15_LOOP_CLOSE_THRESH          15
#define IR16_RING_TRIP_THRESH           16
#define IR17_COMMON_MIN_THRESH          17
#define IR18_COMMON_MAX_THRESH          18
#define IR19_PWR_ALARM_Q1Q2             19
#define IR20_PWR_ALARM_Q3Q4             20
#define IR21_PWR_ALARM_Q5Q6             21
#define IR22_LOOP_CLOSURE_FILTER        22
#define IR23_RING_TRIP_FILTER           23
#define IR24_THERM_LP_POLE_Q1Q2         24
#define IR25_THERM_LP_POLE_Q3Q4         25
#define IR26_THERM_LP_POLE_Q5Q6         26

#define IR27_CM_BIAS_RINGING            27
#define IR64_DCDC_MIN_V                 64
#define IR66_LOOP_CLOSE_THRESH_LOW      66

/* FSK Control */
#define IR69_FSK_X_0                    69
#define IR70_FSK_COEFF_0                70
#define IR71_FSK_X_1                    71
#define IR72_FSK_COEFF_1                72
#define IR73_FSK_X_01                   73
#define IR74_FSK_X_10                   74


/* Register related to Tone Generation */
/* ##########################################################*/
#define TONE_OSC_1_FREQ_COEFF		0x0
#define TONE_OSC_1_AMP_REG		0x0
#define TONE_OSC_1_INIT_PHASE_REG	0x0

#define TONE_OSC_2_FREQ_COEFF      0x0
#define TONE_OSC_2_AMP_REG         0x0
#define TONE_OSC_2_INIT_PHASE_REG  0x0
/* ##########################################################*/

/* Registers related to Ringing */
/* ##########################################################*/
/* Ringing DC Voltage Offset 0 */
#define RING_OFFSET_IR6                 0x0E00	/* Sagem 20060201 */

/* Ringing Generator frequency */
#define RING_OSC_FREQ_50HZ_IR7          0x79BC	/* Sagem 20060201 */ 

/* Ringing Generator Signal Amplitude */
#define RING_OSC_AMP_50HZ_IR8           0x030C	/* Sagem 20060201 */

/* Initial Phase of rigng generator signal */
#define RING_OSC_INITPHASE_50HZ_IR9     0x0000
/* ##########################################################*/

/* Registers related to ADC/DAC Gain/Loss */
/* ##########################################################*/
/* Receive Path Digital To Analog Converter Gain/Attenuation */
#define RECV_DIGITAL_GAIN_CPLX_IR13     0x2E19	/* Sagem linear 20060126 */

/* Transmit Path Analog to Digital Converter Gain/Attenuation */
#define XMIT_DIGITAL_GAIN_CPLX_IR14     0x56A2	/* Sagem linear 20060126 */
/* ##########################################################*/

/* Registers related to Impedance */
/* ##########################################################*/
#define LINE_IMPEDANCE_600_DR10         0x28 // Line Cap Compensation 10nF , Synthesis Enable , 600ohms Selected.
#define LINE_IMPEDANCE_CRT21_DR10       0x2C // Line Cap Compensation 10nF , Synthesis Enable , CTR21 Selected.
/* ##########################################################*/

/* Registers related to SLIC Control */
/* ##########################################################*/
/* Loop Closure Threshold 
   0x1000  =>  0001 0000 0000 0000 => 001 000 => 8 => 8*1.27 
   => 10.16 ma.
*/
#define LOOP_CLOSE_THRESH_IR15          0x0E00 

/* Ring Trip Threshold */
#define RING_TRIP_THRESH_50HZ_IR16      0x3600

/* Common Mode Minimum Threshold for Speed-Up */
#define COMMON_MODE_MIN_THRES           0x1000

/* Common Mode Maximum Threshold for Speed-Up */
#define COMMON_MODE_MAX_THRES           0x0080

/* Power Alarm Threshold for Transitors Q1 and Q2 (Si321x Values in AN47). */
#define PWR_ALARM_Q1Q2_SOT23_IR19       0x0700

/* Power Alarm Threshold for Transitors Q3 and Q4 (Si321x Values in AN47).*/
#define PWR_ALARM_Q3Q4_SOT23_IR20       0x373F

/* Power Alarm Threshold for Transitors Q5 and Q6 (Si321x Values in AN47). */
#define PWR_ALARM_Q5Q6_SOT223_IR21      0x150D 

/* Loop Closure Filter */
#define LOOP_CLOSURE_FILTER			0x8000

/* Ring Trip Filter Coefficient */
#define RING_TRIP_FILTER_50HZ_IR23      0x06A8 

/* Thermal Low Pass Filter Pole for Transitors Q1 and Q2 (Si321x Values in AN47).*/
#define THERM_LP_POLE_Q1Q2_SOT23_IR24   0x008C

/* Thermal Low Pass Filter Pole for Transitors Q3 and Q4 (Si321x Values in AN47).*/
#define THERM_LP_POLE_Q3Q4_SOT23_IR25   0x008C

/* Thermal Low Pass Filter Pole for Transitors Q5 and Q6 (Si321x Values in AN47).*/
#define THERM_LP_POLE_Q5Q6_SOT223_IR26  0x000E 

/* Common Mode Bias Adjust During Ringing */
#define VCMR_IR27                       0x0C00 

/* Overhead Voltage = 9V / 1.5 = 6  = 0x06 << 9 => 0x0C00. */
#define VOV_IR64                        0x0C00

/* Loop Closure Threshold Low */
#define LOOP_CLOSE_THRESH_LOW_IR66      0x0A00 
/* ##########################################################*/

/* Rest Resgiters for FSK Control, NOT USING */
/* ##########################################################*/
/* ##########################################################*/


/* ENUMERATIONS */
typedef enum
{
	TYPE_PCMA = 0,
	TYPE_PCMU,
	TYPE_LINEAR,
	TYPE_PCM_END
} enumPcm;

typedef enum
{
	TYPE_FRANCE = 0,
	TYPE_NETHERLANDS,
	TYPE_POLAND,
	TYPE_SPAIN,
	TYPE_COUNTRY_END
} enumCountry;

typedef enum
{
	TYPE_RING_20HZ	= 0,
	TYPE_RING_25HZ,
	TYPE_RING_50HZ,
	TYPE_RING_END
} enumRing;

typedef enum
{
	TYPE_600_OHMS = 0,
	TYPE_CTR21,
	TYPE_IMPEDANCE_END
} enumImpedance;

#define TYPE_NULL_TONE 	0

/* STRUCTURES */
/* Indirect Registers */
typedef struct
{
  unsigned char   address;
  unsigned char*  name;
  unsigned short  initial;
}SilabIndReg_t;

/* Chip Structure */
typedef struct 
{
	unsigned char	chipType;
	unsigned char	chipVersion;
	enumPcm		chipPcm;
	enumCountry	country;
	enumRing		ring;
	enumImpedance	impedance;
	unsigned char	flagSilabsToneGenerator;
	struct
	{
		unsigned char	tone;
		unsigned int	time;
		unsigned int 	counter;
		unsigned char 	nextCadenceEntryIndex;
	} toneCadenceOsc1;
	struct
	{
		unsigned char	tone;
		unsigned int	time;
		unsigned int 	counter;
		unsigned char 	nextCadenceEntryIndex;
	} toneCadenceOsc2;
} chipStruct;

/* Ring Structure */
typedef struct 
{
	unsigned short	coeff; // Frequency parameter
	unsigned short	x; // Amplitude parameter
	unsigned short	y; // Phase parameter
	unsigned char	onLsbByte; // RingOn time
	unsigned char	onMsbByte; // RingOn time
	unsigned char	offLsbByte; // RingOff time
	unsigned char	offMsbByte; // RingOff time
	unsigned short	rtThreshold; // RingTrip threshold
	unsigned short	rtFilter; // RingTrip filter
	unsigned char	rtDebounce; // RingTrip debounce interval
} ringStruct;

/* Tone Structure */
typedef struct
{
	unsigned short	coeff; // Frequency parameter
	unsigned short	x; // Amplitude parameter
	unsigned short	y; // Phase parameter
	unsigned char	onLsbByte; // ToneOn time
	unsigned char	onMsbByte; // ToneOn time
	unsigned char	offLsbByte; // ToneOn time
	unsigned char	offMsbByte; // ToneOn time
} Oscillator;

typedef struct
{
	Oscillator	osc1;
	Oscillator	osc2;
} toneStruct;

typedef struct
{
	unsigned char	nextOsc1;
	unsigned char	nextOsc2;
	toneStruct	toneRegs;
} toneCadenceTables;

#define ENABLE_OSC1_ACTIVE_DR32	0x10	// Enable Oscillator 1 Active Timer in DR32.
#define ENABLE_OSC1_INACTIVE_DR32	0x08	// Enable Oscillator 1 Inactive Timer in DR32.
#define START_OSC1_DR32			0x06	// Enable Oscillator 1 and Assign to receive path in DR32.
#define DISABLE_ALL_DR32			0	// Disable All Oscillator 1 Control in DR32.

#define ENABLE_OSC2_ACTIVE_DR33	0x10	// Enable Oscillator 2 Active Timer in DR33.
#define ENABLE_OSC2_INACTIVE_DR33	0x08	// Enable Oscillator 2 Inactive Timer in DR33.
#define START_OSC2_DR33			0x06	// Enable Oscillator 2 and Assign to receive path in DR33.
#define DISABLE_ALL_DR33			0	// Disable All Oscillator 2 Control in DR33.

#endif
