/******************************************************************************
*
*   Copyright (C) 2002 Analog Devices India (P) Ltd. All rights are reserved.
*
*   The information and source code contained herein is the exclusive
*   property of Analog Devices India (P) Ltd. and may not be disclosed,
*   examined or reproduced in whole or in part without explicit written
*   authorization from the compnay.
*
******************************************************************************/

#ifndef __SPAIN_CONF_H
#define __SPAIN_CONF_H

//********************************************************
//		SPAIN Country Tones specifications
//********************************************************
#define SPAIN_MAX_NUM_CADENCE          3

// OSC1	425Hz -6dBm0 Continuous
#define	SPAIN_DIAL_IR0                 FREQ_425Hz
#define	SPAIN_DIAL_IR1                 F425Hz_AMP_M6dBm0

// OSC1	425Hz -6dBm0 1.5s On 3s Off
#define	SPAIN_RINGBACK_IR0             FREQ_425Hz
#define	SPAIN_RINGBACK_IR1             F425Hz_AMP_M6dBm0
#define	SPAIN_RINGBACK_DR36            0xE0
#define	SPAIN_RINGBACK_DR37            0x2E
#define	SPAIN_RINGBACK_DR38            0XC0
#define	SPAIN_RINGBACK_DR39            0X5D

// OSC1	425Hz -6dBm0 0.2s On 0.2s Off
#define	SPAIN_BUSY_IR0                 FREQ_425Hz
#define	SPAIN_BUSY_IR1                 F425Hz_AMP_M6dBm0
#define	SPAIN_BUSY_DR36                0x40
#define	SPAIN_BUSY_DR37                0x06
#define	SPAIN_BUSY_DR38                0x40
#define	SPAIN_BUSY_DR39                0x06

// OSC1	950Hz -6dBm0 300ms On 20ms Off
#define	SPAIN_SPECIAL_INFO_C0_IR0      FREQ_950Hz
#define	SPAIN_SPECIAL_INFO_C0_IR1      F950Hz_AMP_M6dBm0
#define	SPAIN_SPECIAL_INFO_C0_DR36     0x60
#define	SPAIN_SPECIAL_INFO_C0_DR37     0x09
#define	SPAIN_SPECIAL_INFO_C0_DR38     0xA0
#define	SPAIN_SPECIAL_INFO_C0_DR39     0x00
// OSC1	1400Hz -6dBm0 300ms On 20ms Off
#define	SPAIN_SPECIAL_INFO_C1_IR0      FREQ_1400z
#define	SPAIN_SPECIAL_INFO_C1_IR1      F1400Hz_AMP_M6dBm0
#define	SPAIN_SPECIAL_INFO_C1_DR36     0x60
#define	SPAIN_SPECIAL_INFO_C1_DR37     0x09
#define	SPAIN_SPECIAL_INFO_C1_DR38     0xA0
#define	SPAIN_SPECIAL_INFO_C1_DR39     0x00
// OSC1	1800Hz -6dBm0 300ms On 1s Off
#define	SPAIN_SPECIAL_INFO_C2_IR0      FREQ_1800z
#define	SPAIN_SPECIAL_INFO_C2_IR1      F1800Hz_AMP_M6dBm0
#define	SPAIN_SPECIAL_INFO_C2_DR36     0x60
#define	SPAIN_SPECIAL_INFO_C2_DR37     0x09
#define	SPAIN_SPECIAL_INFO_C2_DR38     0x40
#define	SPAIN_SPECIAL_INFO_C2_DR39     0x1F

// OSC1	425Hz -13dBm0 0.175s On 0.175s Off
#define	SPAIN_CALL_WAIT_C0_IR0         FREQ_425Hz
#define	SPAIN_CALL_WAIT_C0_IR1         F425Hz_AMP_M13dBm0
#define	SPAIN_CALL_WAIT_C0_DR36        0x78	
#define	SPAIN_CALL_WAIT_C0_DR37        0x05
#define	SPAIN_CALL_WAIT_C0_DR38        0x78
#define	SPAIN_CALL_WAIT_C0_DR39        0x05
// OSC1	425Hz -6dBm0 0.175s On 3.5s Off
#define	SPAIN_CALL_WAIT_C1_IR0         FREQ_425Hz
#define	SPAIN_CALL_WAIT_C1_IR1         F425Hz_AMP_M6dBm0
#define	SPAIN_CALL_WAIT_C1_DR36        0x78	
#define	SPAIN_CALL_WAIT_C1_DR37        0x05
#define	SPAIN_CALL_WAIT_C1_DR38        0x60
#define	SPAIN_CALL_WAIT_C1_DR39        0x6D

// OSC1	425Hz -6dBm0 1s On 0.1s Off
#define	SPAIN_SPECIAL_DIAL_IR0         FREQ_425Hz
#define	SPAIN_SPECIAL_DIAL_IR1         F425Hz_AMP_M6dBm0
#define	SPAIN_SPECIAL_DIAL_DR36        0x40	
#define	SPAIN_SPECIAL_DIAL_DR37        0x1F
#define	SPAIN_SPECIAL_DIAL_DR38        0x20	
#define	SPAIN_SPECIAL_DIAL_DR39        0x03

// OSC1	425Hz -6dBm0 200ms On 200ms Off
#define	SPAIN_CONGESTION_C0_IR0        FREQ_425Hz
#define	SPAIN_CONGESTION_C0_IR1        F425Hz_AMP_M6dBm0
#define	SPAIN_CONGESTION_C0_DR36       0x40
#define	SPAIN_CONGESTION_C0_DR37       0x06
#define	SPAIN_CONGESTION_C0_DR38       0x40
#define	SPAIN_CONGESTION_C0_DR39       0x06
// OSC1	425Hz -6dBm0 200ms On 200ms Off
#define	SPAIN_CONGESTION_C1_IR0        FREQ_425Hz
#define	SPAIN_CONGESTION_C1_IR1        F425Hz_AMP_M6dBm0
#define	SPAIN_CONGESTION_C1_DR36       0x40
#define	SPAIN_CONGESTION_C1_DR37       0x06
#define	SPAIN_CONGESTION_C1_DR38       0x40
#define	SPAIN_CONGESTION_C1_DR39       0x06
// OSC1	425Hz -6dBm0 200ms On 600ms Off
#define	SPAIN_CONGESTION_C2_IR0        FREQ_425Hz
#define	SPAIN_CONGESTION_C2_IR1        F425Hz_AMP_M6dBm0
#define	SPAIN_CONGESTION_C2_DR36       0x40
#define	SPAIN_CONGESTION_C2_DR37       0x06
#define	SPAIN_CONGESTION_C2_DR38       0xC0
#define	SPAIN_CONGESTION_C2_DR39       0x12


typedef enum
{
        SPAIN_NULL_TONE                 = 0,
        SPAIN_DIAL_TONE                 = 1,
        SPAIN_RING_BACK_TONE            = 2,
        SPAIN_BUSY_TONE                 = 3,
        SPAIN_SPECIAL_INFO_TONE         = 4,
        SPAIN_CALL_WAITING_TONE         = 5,
        SPAIN_SPECIAL_DIAL_TONE         = 6,
        SPAIN_CONGESTION_TONE           = 7,
        SPAIN_NULL_MSG_WAITING_TONE     = 8,
        SPAIN_NULL_ALERTING_TONE        = 9,
                                                                                
        SPAIN_NULL_CONFIRMATION_TONE    = 10,
                                                                                
        SPAIN_NULL_VOIP_DIAL_TONE       = 11,
        SPAIN_NULL_VOIP_MWI_TONE        = 12,
        SPAIN_TONE_END                  = 13
} enumSpainTone;
                                                                                

/*
The following Array contains Spain Tones Parmeters
*/
toneCadenceTables  spainToneCadenceTables [SPAIN_TONE_END][SPAIN_MAX_NUM_CADENCE] =
{
	{ // SPAIN_NULL_TONE
		{
		0, // No Next Cadence Osc1
		0, // No Next Cadence Osc2
			{
				{ // OSC1 Not Used
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00
				},
				{ // OSC2 Not Used
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00
				},
			},
		},
	},

	{ // SPAIN_DIAL_TONE
		{
		0, // No Next Cadence Osc1
		0, // No Next Cadence Osc2
			{
				{ // OSC1 425Hz -6dBm0 Continuous
				SPAIN_DIAL_IR0,
				SPAIN_DIAL_IR1,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00
				},
				{ // OSC2 Not Used
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00
				},
			},
		},
	},

	{ // SPAIN_RING_BACK_TONE
		{
		0, // No Next Cadence Osc1
		0, // No Next Cadence Osc2
			{
				{ // OSC1 425Hz -6dBm0 1.5s On 3s Off
				SPAIN_RINGBACK_IR0,
				SPAIN_RINGBACK_IR1,
				0x00,
				SPAIN_RINGBACK_DR36,
				SPAIN_RINGBACK_DR37,
				SPAIN_RINGBACK_DR38,
				SPAIN_RINGBACK_DR39
				},
				{ // OSC2 Not Used
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00
				},
			},
		},
	},

	{ // SPAIN_BUSY_TONE
		{
		0, // No Next Cadence Osc1
		0, // No Next Cadence Osc2
			{
				{ // OSC1 425Hz -6dBm0 0.2s On 0.2s Off
				SPAIN_BUSY_IR0,
				SPAIN_BUSY_IR1,
				0x00,
				SPAIN_BUSY_DR36,
				SPAIN_BUSY_DR37,
				SPAIN_BUSY_DR38,
				SPAIN_BUSY_DR39
				},
				{ // OSC2 Not Used
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00
				},
			},
		},
	},

	{ // SPAIN_SPECIAL_INFO_TONE
		{
		1, // Next Cadence 1 Osc1
		0, // No Next Cadence Osc2
			{
				{ // OSC1 950Hz -6dBm0 300ms On 20ms Off
				SPAIN_SPECIAL_INFO_C0_IR0,
				SPAIN_SPECIAL_INFO_C0_IR1,
				0x00,
				SPAIN_SPECIAL_INFO_C0_DR36,
				SPAIN_SPECIAL_INFO_C0_DR37,
				SPAIN_SPECIAL_INFO_C0_DR38,
				SPAIN_SPECIAL_INFO_C0_DR39
				},
				{ // OSC2 Not Used
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00
				},
			},
		},
		{
		2, // Next Cadence 2 Osc1
		0, // No Next Cadence Osc2
			{
				{ // OSC1 1400Hz -6dBm0 300ms On 20ms Off
				SPAIN_SPECIAL_INFO_C1_IR0,
				SPAIN_SPECIAL_INFO_C1_IR1,
				0x00,
				SPAIN_SPECIAL_INFO_C1_DR36,
				SPAIN_SPECIAL_INFO_C1_DR37,
				SPAIN_SPECIAL_INFO_C1_DR38,
				SPAIN_SPECIAL_INFO_C1_DR39
				},
				{ // OSC2 Not Used
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00
				},
			},
		},
		{
		0, // Next Cadence 0 Osc1
		0, // No Next Cadence Osc2
			{
				{ // OSC1 1800Hz -6dBm0 300ms On 1s Off
				SPAIN_SPECIAL_INFO_C2_IR0,
				SPAIN_SPECIAL_INFO_C2_IR1,
				0x00,
				SPAIN_SPECIAL_INFO_C2_DR36,
				SPAIN_SPECIAL_INFO_C2_DR37,
				SPAIN_SPECIAL_INFO_C2_DR38,
				SPAIN_SPECIAL_INFO_C2_DR39
				},
				{ // OSC2 Not Used
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00
				},
			},
		},
	},

	{ // SPAIN_CALL_WAITING_TONE
		{
		1, // Next Cadence 1 Osc1
		0, // No Next Cadence Osc2
			{
				{ // OSC1 425Hz -6dBm0 0.175s On 0.175s Off
				SPAIN_CALL_WAIT_C0_IR0,
				SPAIN_CALL_WAIT_C0_IR1,
				0x00,
				SPAIN_CALL_WAIT_C0_DR36,
				SPAIN_CALL_WAIT_C0_DR37,
				SPAIN_CALL_WAIT_C0_DR38,
				SPAIN_CALL_WAIT_C0_DR39
				},
				{ // OSC2 Not Used
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00
				},
			},
		},
		{
		0, // Next Cadence 0 Osc1
		0, // No Next Cadence Osc2
			{
				{ // OSC1 425Hz -6dBm0 0.175s On 3.5s Off
				SPAIN_CALL_WAIT_C1_IR0,
				SPAIN_CALL_WAIT_C1_IR1,
				0x00,
				SPAIN_CALL_WAIT_C1_DR36,
				SPAIN_CALL_WAIT_C1_DR37,
				SPAIN_CALL_WAIT_C1_DR38,
				SPAIN_CALL_WAIT_C1_DR39
				},
				{ // OSC2 Not Used
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00
				},
			},
		},
	},

	{ // SPAIN_SPECIAL_DIAL_TONE
		{
		0, // No Next Cadence Osc1
		0, // No Next Cadence Osc2
			{
				{ // OSC1 425Hz -6dBm0 1s On 0.1s Off
				SPAIN_SPECIAL_DIAL_IR0,
				SPAIN_SPECIAL_DIAL_IR1,
				0x00,
				SPAIN_SPECIAL_DIAL_DR36,
				SPAIN_SPECIAL_DIAL_DR37,
				SPAIN_SPECIAL_DIAL_DR38,
				SPAIN_SPECIAL_DIAL_DR39
				},
				{ // OSC2 Not Used
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00
				},
			},
		},
	},

	{ // SPAIN_CONGESTION_TONE
		{
		1, // Next Cadence 1 Osc1
		0, // No Next Cadence Osc2
			{
				{ // OSC1 950Hz -6dBm0 200ms On 200ms Off
				SPAIN_CONGESTION_C0_IR0,
				SPAIN_CONGESTION_C0_IR1,
				0x00,
				SPAIN_CONGESTION_C0_DR36,
				SPAIN_CONGESTION_C0_DR37,
				SPAIN_CONGESTION_C0_DR38,
				SPAIN_CONGESTION_C0_DR39
				},
				{ // OSC2 Not Used
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00
				},
			},
		},
		{
		2, // Next Cadence 2 Osc1
		0, // No Next Cadence Osc2
			{
				{ // OSC1 1400Hz -6dBm0 200ms On 200ms Off
				SPAIN_CONGESTION_C1_IR0,
				SPAIN_CONGESTION_C1_IR1,
				0x00,
				SPAIN_CONGESTION_C1_DR36,
				SPAIN_CONGESTION_C1_DR37,
				SPAIN_CONGESTION_C1_DR38,
				SPAIN_CONGESTION_C1_DR39
				},
				{ // OSC2 Not Used
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00
				},
			},
		},
		{
		0, // Next Cadence 0 Osc1
		0, // No Next Cadence Osc2
			{
				{ // OSC1 1800Hz -6dBm0 200ms On 600ms Off
				SPAIN_CONGESTION_C2_IR0,
				SPAIN_CONGESTION_C2_IR1,
				0x00,
				SPAIN_CONGESTION_C2_DR36,
				SPAIN_CONGESTION_C2_DR37,
				SPAIN_CONGESTION_C2_DR38,
				SPAIN_CONGESTION_C2_DR39
				},
				{ // OSC2 Not Used
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00
				},
			},
		},
	},

	{ // SPAIN_NULL_MSG_WAITING_TONE
		{
		0, // No Next Cadence Osc1
		0, // No Next Cadence Osc2
			{
				{ // OSC1 Not Used
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00
				},
				{ // OSC2 Not Used
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00
				},
			},
		},
	},

	{ // SPAIN_NULL_ALERTING_TONE
		{
		0, // No Next Cadence Osc1
		0, // No Next Cadence Osc2
			{
				{ // OSC1 Not Used
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00
				},
				{ // OSC2 Not Used
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00
				},
			},
		},
	},

	{ // SPAIN_NULL_VOIP_DIAL_TONE
		{
		0, // No Next Cadence Osc1
		0, // No Next Cadence Osc2
			{
				{ // OSC1 Not Used
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00
				},
				{ // OSC2 Not Used
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00
				},
			},
		},
	},

	{ // SPAIN_NULL_VOIP_MWI_TONE
		{
		0, // No Next Cadence Osc1
		0, // No Next Cadence Osc2
			{
				{ // OSC1 Not Used
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00
				},
				{ // OSC2 Not Used
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00,
				0x00
				},
			},
		},
	},
};

/* Function Prototypes */
void spainDial(unsigned char codecNo, unsigned int frequency);
void spainRingBack(unsigned char codecNo, unsigned int frequency);
void spainBusy(unsigned char codecNo, unsigned int frequency);
void spainInfo(unsigned char codecNo, unsigned int frequency);
void spainCallWait(unsigned char codecNo, unsigned int frequency);
void spainSpDial(unsigned char codecNo, unsigned int frequency);
void spainCongestion(unsigned char codecNo, unsigned int frequency);


#endif
